2008-08-29  Julian Graham  <joolean@gmail.com>

	* threads.c (fat_mutex_lock): Resolve a deadlock caused by not
	checking mutex state after calling `SCM_TICK'.

2008-08-27  Ludovic Courtès  <ludo@gnu.org>

	Fix builds `--without-threads'.  Reported by Han-Wen Nienhuys
	<hanwen@xs4all.nl>.

	* scmsigs.c (scm_i_close_signal_pipe): Don't refer to
	`signal_pipe' unless `SCM_USE_PTHREAD_THREADS' is true.
	* threads.c (scm_leave_guile_cleanup): Mark as `SCM_UNUSED'.

2008-08-25  Ludovic Courtès  <ludo@gnu.org>

	* Makefile.am (AM_CFLAGS): New.
	(guile_CFLAGS, libguile_la_CFLAGS): Use it.

2008-08-20  Ludovic Courtès  <ludo@gnu.org>

	* eval.c, filesys.c, gc.c, numbers.c, stime.c, threads.c: Don't
	define `_GNU_SOURCE' explicitly as it's now defined in
	<config.h> thanks to `AC_USE_SYSTEM_EXTENSIONS'.

2008-08-19  Han-Wen Nienhuys  <hanwen@lilypond.org>
	    Ludovic Courtès  <ludo@gnu.org>

	* goops.c (scm_init_goops_builtins, go_to_hell): Fix allocation
	of `hell' by passing "hell_size * sizeof (*hell)" instead of
	"hell_size" to `scm_malloc ()' and `scm_realloc ()'.

2008-08-02  Neil Jerram  <neil@ossau.uklinux.net>

	* numbers.c (scm_rationalize): Update docstring to match the
	manual (which is more correct).  Change argument "err" to "eps",
	also to match the manual.

2008-07-17  Neil Jerram  <neil@ossau.uklinux.net>

	From Thiemo Seufer <ths@networkno.de>:
	
	* gc_os_dep.c (CPP_WORDSZ, ALIGN_DOUBLE, DATAEND,
        DYNAMIC_LOADING): Added #defines.
        (_fdata, _end): Added declarations.
        (DATASTART): Use _fdata instead of __data_start.
        (STACKBOTTOM): Changed from 0x80000000 to 0x7fff8000.

2008-07-16  Ludovic Courtès  <ludo@gnu.org>

	* gen-scmconfig.h.in (SCM_I_GSC_HAVE_STRUCT_DIRENT64): New.
	* gen-scmconfig.c (main): Produce definitions of
	`SCM_HAVE_STRUCT_DIRENT64' and `SCM_HAVE_READDIR64_R'.
	* _scm.h (dirent_or_dirent64): Depend on
	`SCM_HAVE_STRUCT_DIRENT64', for the sake of HP-UX 11.11.
	(readdir_r_or_readdir64_r): Depend on `SCM_HAVE_READDIR64_R',
	for HP-UX 11.11.

2008-07-05  Ludovic Courtès  <ludo@gnu.org>

	* strings.c (scm_c_symbol_length): New function.
	* strings.h (scm_c_symbol_length): New declaration.

2008-07-04  Ludovic Courtès  <ludo@gnu.org>

	* posix.h (scm_i_locale_mutex): Don't declare as `SCM_INTERNAL'
	since it's needed by `libguile-i18n'.  Reported by Patrick
	Horgan <phorgan1@gmail.com>.

	* __scm.h (SCM_INTERNAL): Add `extern' so that these symbols are
	not considered as "common" by GCC 4.3.  Reported by Patrick
	Horgan <phorgan1@gmail.com>.

2008-06-28  Ludovic Courtès  <ludo@gnu.org>

	* Makefile.am (INCLUDES): Renamed to...
	(AM_CPPFLAGS): this, to match current Automake conventions.
	Users updated.

	* tags.h (SCM_UNPACK): Disable type-checking for `__DECC' and
	`__HP_cc'.  Reported by Peter O'Gorman <pogma@thewrittenword.com>.

2008-06-02  Ludovic Courtès  <ludo@gnu.org>

	* deprecated.c (maybe_close_port): Rename EXCEPT to EXCEPT_SET
	to workaround `#define except' on Tru64.  Reported by Peter
	O'Gorman <pogma@thewrittenword.com>.

2008-05-31  Ludovic Courtès  <ludo@gnu.org>

	* __scm.h (SCM_INTERNAL): New macro.
	* *.h: Use it to mark as internal `scm_i_' and `scm_init_'
	functions that are not used by public macros or inline
	functions.

2008-05-14  Julian Graham  <joolean@gmail.com>

	* threads.c (fat_mutex)[recursive]: New field.
	(make_fat_mutex): Adjust initialization to reflect changes to
	mutex lock level semantics.
	(fat_mutex_lock, fat_mutex_unlock): Add support for unowned
	mutexes and locking mutexes on behalf of other threads.
	(scm_lock_mutex, scm_lock_mutex_timed): Update to reflect
	signature change to fat_mutex_lock.
	(scm_mutex_owner, scm_mutex_level, scm_mutex_locked_p): New /
	re-enabled functions.
	* threads.h (scm_mutex_owner, scm_mutex_level,
	scm_mutex_locked_p): Prototypes for new functions.

2008-05-12  Neil Jerram  <neil@ossau.uklinux.net>

	* discouraged.c: Expand DEFFROM and DEFTO macros, to avoid
	compiler warnings about excess semicolons.  (Reported by Didier
	Godefroy.)

2008-05-08  Neil Jerram  <neil@ossau.uklinux.net>

	* throw.c (scm_ithrow): For IA64 add a return statement, to
	appease GCC.

	* threads.h (scm_i_thread): New IA64 fields:
	register_backing_store_base and pending_rbs_continuation.

	* threads.c (guilify_self_1): For IA64: cap RBS base address at
	the current value of scm_ia64_ar_bsp, and store the capped value
	in thread state.
	(SCM_MARK_BACKING_STORE): Use thread->register_backing_store_base
	instead of scm_ia64_register_backing_store_base().
	(scm_threads_mark_stacks): Add "&" in "&t->regs", so that the code
	works both for jmp_buf defined as an array, and jmp_buf defined as
	a struct.

	* continuations.h (scm_t_contregs): Remove `fresh' and `ctx'
	fields; these are now inside the IA64 definition of `jmp_buf'.

	* continuations.c (scm_make_continuation): Simplify, by moving
	some of the IA64 code inside the definition of "setjmp", and by
	some obvious commonizations.  For IA64 register backing store
	(RBS) stack base, use thread->register_backing_store_base instead
	of scm_ia64_register_backing_store_base().
	(copy_stack): For IA64, store pointer to continuation being
	invoked in thread state, so we can restore the continuation's RBS
	stack just before the next setcontext call.
	(copy_stack_and_call): Don't restore RBS stack explicitly here.
	It will be restored, if appropriate, inside the longjmp call.
	(scm_ia64_longjmp): New function.

	* __scm.h (setjmp, longjmp, jmp_buf): For IA64, implement using
	getcontext and setcontext.

2008-05-07  Ludovic Courtès  <ludo@gnu.org>

	* numbers.c (scm_from_complex_double): Mark as `SCM_UNUSED'.
	This fixes compilation with `-Werror' on FreeBSD 6.2 (i386).

2008-05-05  Neil Jerram  <neil@ossau.uklinux.net>

	* c-tokenize.lex: #define YY_NO_INPUT.

2008-04-26  Ludovic Courtès  <ludo@gnu.org>

	* read.c (scm_read_sexp): Remove extraneous semi-colon at
	end-of-line, which broke compilation with GCC 2.7.  Reported by
	Alain Guibert <alguibert+bts@free.fr>.

2008-04-24  Ludovic Courtès  <ludo@gnu.org>

	* Makefile.am (DEFAULT_INCLUDES): New.  Fixes compilation on
	Tru64 where our "random.h" would shadown libc's one.
	(INCLUDES): Add "-I$(top_buildir)", which is normally in
	`DEFAULT_INCLUDES'.
	* gen-scmconfig.c: Include <libguile/gen-scmconfig.h>, not
	"gen-scmconfig.h" since that file is under `$(builddir)'.

2008-04-16  Ludovic Courtès  <ludo@gnu.org>

	* ports.c (scm_getc, scm_putc, scm_puts): Moved...
	* inline.h: ... here.  Noticeably improves `read' performance.

2008-04-15  Ludovic Courtès  <ludo@gnu.org>
	    Julian Graham  <joolean@gmail.com>

	* read.c (scm_keyword_postfix): New.
	(scm_read_opts): Update docstring for `keywords'.
	(scm_read_mixed_case_symbol): Add support for postfix keywords.

2008-04-13  Ludovic Courtès  <ludo@gnu.org>

	* inline.h (SCM_C_USE_EXTERN_INLINE): New macro.  Use it to make
	sure "extern" declarations are produced when "extern inline" is
	used.  Simplify macrology around inline definitions.

2008-04-10  Ludovic Courtès  <ludo@gnu.org>

	* inline.h (SCM_C_EXTERN_INLINE): Special-case Apple's GCC
	4.0-based compiler, which doesn't support GNU inline semantics
	at all in C99 mode but doesn't define `__GNUC_STDC_INLINE__'.
	See http://thread.gmane.org/gmane.network.gnutls.general/1135 .

2008-04-10  Andy Wingo  <wingo@pobox.com>

	* struct.c (scm_struct_ref, scm_struct_set_x): "Light" structs
	have no hidden words (members of the SCM_STRUCT_DATA(x) array
	accessed with negative indices). In that case, determine the
	number of fields from the length of the struct layout
	descriptor. (Most GOOPS instances are light structs.)

	* goops.c (wrap_init): Initialize 'u' slots to 0, not some random
	SCM value.

	* goops.c (get_slot_value, set_slot_value): In the struct
	allocation case, don't poke the slots array directly -- we should
	go through struct-ref/struct-set! code so that we get the
	permissions and allocation ('u' versus 'p') correct.

2008-04-03  Ludovic Courtès  <ludo@gnu.org>

	* inline.h (SCM_C_EXTERN_INLINE): New macro, addresses the
	"extern inline" semantic change in C99 mode with GCC 4.3 and
	later and the warning in C99 mode with GCC 4.2.  Use it in the
	inline function definitions.

2008-03-24  Neil Jerram  <neil@ossau.uklinux.net>

	Applying patch from Julian Graham, containing minor fixes to his
	thread enhancements:

	* threads.c (to_timespec): Change 1000000 multiplier to
	1000000000.
	(unchecked_unlock_sym, allow_external_unlock_sym,
	recursive_sym): Use SCM_SYMBOL.
	(scm_make_mutex_with_flags): When raising unsupported option
	error, report what the unsupported option was.
	(fat_mutex_unlock): When raising errors, unlock m->lock first.
	(fat_cond_timedwait): Removed.
	(scm_timed_wait_condition_variable): Call fat_mutex_unlock
	directly instead of via fat_cond_timedwait.

2008-03-10  Ludovic Courtès  <ludo@gnu.org>

	* eval.c, filesys.c: Enclose `alloca' blob in `#ifndef alloca',
	as per Gnulib's `alloca'.  This should fix compilation on
	FreeBSD 6.

2008-03-09  Neil Jerram  <neil@ossau.uklinux.net>

	* numbers.c: Only define scm_from_complex_double if it will
	actually be used.

2008-03-08  Julian Graham  <joolean@gmail.com>

	* threads.c (scm_join_thread_timed, scm_thread_p,
	scm_make_mutex_with_flags, scm_lock_mutex_timed,
	scm_unlock_mutex_timed, scm_mutex_p, scm_condition_variable_p): New
	functions.
	(thread_mark): Updated to mark new struct field `mutexes'.
	(do_thread_exit): Notify threads waiting on mutexes locked by exiting
	thread.
	(scm_join_thread, scm_make_mutex, scm_make_recursive_mutex,
	scm_mutex_lock): Reimplement in terms of their newer
	counterparts.
	(scm_abandoned_mutex_error_key): New symbol.
	(fat_mutex)[unchecked_unlock, allow_external_unlock]: New fields.
	(fat_mutex_lock): Reimplement to support timeouts and abandonment.
	(fat_mutex_trylock, scm_try_mutex): Remove fat_mutex_trylock and
	reimplement scm_try_mutex as a lock attempt with a timeout of zero.
	(fat_mutex_unlock): Allow unlocking from other threads and unchecked
	unlocking; implement in terms of condition variable wait.
	(scm_timed_wait_condition_variable): Reimplement in terms of
	fat_mutex_unlock.
	* threads.h (scm_i_thread)[mutexes]: New field.
	(scm_join_thread_timed, scm_thread_p, scm_lock_mutex_timed,
	scm_unlock_mutex_timed, scm_mutex_p, scm_condition_variable_p):
	Prototypes for new functions.

2008-03-06  Ludovic Courtès  <ludo@gnu.org>

	* eval.c (scm_eval): If MODULE_OR_STATE is not a dynamic state,
	make sure it's a module.  Reported by David I. Lehn.

2008-03-02  Ludovic Courtès  <ludo@gnu.org>

	* pairs.h (scm_is_pair): Moved declaration to `inline.h'.
	* inline.h: Make sure `extern' declarations are not produced
	when `inline' is supported but GCC is not used.  This
	fixes "mixed linkage" errors with compilers such as
	DEC/Compaq/HP CC.

2008-02-27  Neil Jerram  <neil@ossau.uklinux.net>

	* _scm.h (errno): Remove declarations that have been there
	forever, and are known to conflict on some platforms with that
	provided by <errno.h>, which we include unconditionally.  If
	<errno.h> doesn't provide a errno declaration, what is the point
	of it?

2008-02-23  Ludovic Courtès  <ludo@gnu.org>

	* numbers.c (scm_make_rectangular): Rename argument to
	`real_part' and `imaginary_part' to work around Solaris 2.10
	headers which define `imaginary' as a macro.  Patch by Tim
	Mooney <mooney@dogbert.cc.ndsu.NoDak.edu>.

2008-02-22  Ludovic Courtès  <ludo@gnu.org>

	* read.c (strncasecmp): Add declaration when
	`HAVE_DECL_STRNCASECMP' is undefined.  Fixes compilation on
	NetBSD 1.6.

	* gc.c (scm_ia64_ar_bsp)[linux]: Don't discard `const' qualifier
	of OPAQUE.

2008-02-21  Ludovic Courtès  <ludo@gnu.org>

	Fix bug #22369.

	* goops.c (scm_add_slot): Add `SCM_UNDEFINED' as last argument
	to `scm_list_n ()'.  Thanks to René Köcher
	<shirk87@googlemail.com>.

2008-02-17  Ludovic Courtès  <ludo@gnu.org>

	* script.c (scm_compile_shell_switches): Update copyright year.

2008-02-16  Ludovic Courtès  <ludo@gnu.org>

	* gc_os_dep.c: Add NetBSD/alpha support.  Patch by Greg Troxel
	<gdt@ir.bbn.com>.

2008-02-12  Ludovic Courtès  <ludo@gnu.org>

	* guile-snarf.in (tempdir): Honor `$TMPDIR'.

2008-02-11  Neil Jerram  <neil@ossau.uklinux.net>

	* numbers.c (SCM_COMPLEX_VALUE): Use GUILE_I instead of _Complex_I
	directly, and only if GUILE_I was defined by the configure step.
	(scm_log, scm_log10, scm_exp, scm_sqrt): Use SCM_COMPLEX_VALUE
	code only if SCM_COMPLEX_VALUE is defined.

2008-02-07  Ludovic Courtès  <ludo@gnu.org>

	Fix bug #21378.
	Thanks to David Diffenbaugh <davediff@nbcs.rutgers.edu>.

	* read.c (scm_read_quote): Don't use `__FUNCTION__' since it is
	not supported by Sun CC on Solaris 9.
	(scm_read_keyword): Likewise.
	* strings.c (scm_take_locale_stringn): Remove
	`SCM_C_INLINE_KEYWORD' to allow compilation with Sun CC.

2008-02-07  Julian Graham  <joolean@gmail.com>

	* threads.c (do_thread_exit, scm_cancel_thread,
	scm_set_thread_cleanup_x, scm_thread_cleanup): Lock on thread-specific
	admin mutex instead of `thread_admin_mutex'.
	* threads.h (scm_i_thread)[admin_mutex]: New field.
	* throw.c (make_jmpbuf): Don't enter critical section during thread
	spawn -- there is a possibility of deadlock if other threads are
	exiting.

2008-02-06  Neil Jerram  <neil@ossau.uklinux.net>

	* gc-malloc.c (scm_gc_malloc): Return NULL if requested size is 0.
	(scm_gc_free): Don't call `free' if mem is NULL.

2008-02-06  Ludovic Courtès  <ludo@gnu.org>

	* numbers.c (scm_i_mkbig, scm_i_long2big, scm_i_ulong2big,
	scm_i_clonebig, scm_i_bigcmp, scm_i_dbl2big, scm_i_dbl2num,
	scm_i_normbig): Remove `SCM_C_INLINE_KEYWORD' since these are
	declared as `extern' in `numbers.h'.  This precluded compilation
	on Solaris 9 with Sun CC (reported by David Halik
	<dhalik@nbcs.rutgers.edu>).

2008-02-05  Neil Jerram  <neil@ossau.uklinux.net>

	* fports.c (fport_seek): Make dependent on GUILE_USE_64_CALLS.

	* _scm.h: Make definition of CHOOSE_LARGEFILE depend on
	GUILE_USE_64_CALLS.

2008-02-01  Neil Jerram  <neil@ossau.uklinux.net>

	* modules.c (the_root_module): Moved before scm_current_module.
	(scm_current_module): Return the root module if `the-module' fluid
	gives #f.

2008-01-22  Neil Jerram  <neil@ossau.uklinux.net>

	* COPYING: Removed.

	* __scm.h, _scm.h, weaks.c: Update copyright statement to LGPL.

2008-01-18  Neil Jerram  <neil@ossau.uklinux.net>

	* hashtab.c (scm_hash_fn_create_handle_x): If supplied assoc_fn
	returns neither a pair nor #f, signal a wrong-type-arg error.
	(Thanks to Gregory Marton for reporting this.)

2007-12-29  Neil Jerram  <neil@ossau.uklinux.net>

	* gc.c (mark_gc_async): Change "func_data" to "fn_data", to avoid
	clash with AIX header file.
	* hooks.c (scm_c_hook_add, scm_c_hook_remove): Same again.
	* hooks.h (scm_t_c_hook_function, scm_c_hook_add,
	scm_c_hook_remove): Same again.

2007-12-08  Ludovic Courtès  <ludo@gnu.org>

	* __scm.h (SCM_EXPECT, SCM_LIKELY, SCM_UNLIKELY): New macros.
	(SCM_ASSERT, SCM_ASSERT_TYPE, SCM_ASRTGO, SCM_GASSERT0,
	SCM_GASSERT1, SCM_GASSERT2, SCM_GASSERTn): Use them.
	* eval.c (ASSERT_SYNTAX, ASSERT_SYNTAX_2): Likewise.
	* eval.i.c (CEVAL): Use branch prediction hints for syntax
	errors, wrong number of arguments and similar.
	* numbers.c (scm_sum): Use `SCM_LIKELY' for the sum of two
	immediate numbers.
	(scm_difference, scm_product, scm_i_divide): Likewise.
	* validate.h (SCM_ASSERT_RANGE): Use `SCM_UNLIKELY'.

2007-12-04  Ludovic Courtès  <ludo@gnu.org>

	* ports.c (scm_c_read): Validate PORT as an open input port.
	(scm_c_write): Validate PORT as an open output port.

	* socket.c (scm_accept): Leave guile mode using
	`scm_std_select ()' before calling `accept(2)'.  Reported by
	dskr <dskr@mac.com>.

2007-10-27  Ludovic Courtès  <ludo@gnu.org>

	* fports.c (scm_i_evict_port): Expect a port, rather than a pair
	containing the port.  Fixes a bug in the new port table (2007-08-26).
	(scm_evict_ports): Use `scm_c_port_for_each ()'.

2007-10-21  Neil Jerram  <neil@ossau.uklinux.net>

	* eval.c (unmemoize_delay): Extend the environment before
	unmemoizing the promise thunk.  This fixes a segmentation fault
	reported by Frank Schwidom.

2007-10-20  Julian Graham  <joolean@gmail.com>

	Add support for thread cancellation and user-defined thread
	cleanup handlers.  Small rework by Ludovic Courtès.

	* null-threads.h (scm_i_pthread_cancel,
	scm_i_pthread_cleanup_push, scm_i_pthread_cleanup_pop): New.
	* pthread-threads.h (scm_i_pthread_cancel,
	scm_i_pthread_cleanup_push, scm_i_pthread_cleanup_pop): New.
	* scmsigs.c (scm_i_signal_delivery_thread,
	signal_delivery_thread_mutex): New.
	(signal_delivery_thread): Leave when `read_without_guile ()'
	returns zero.
	(start_signal_delivery_thread): Acquire SIGNAL_DELIVERY_THREAD
	before spawning the thread.  Initialize
	SCM_I_SIGNAL_DELIVERY_THREAD.
	(ensure_signal_delivery_thread): Renamed to...
	(scm_i_ensure_signal_delivery_thread): this.
	(scm_i_close_signal_pipe): New.
	* scmsigs.h: Updated.
	* threads.c (thread_mark): Mark `t->cleanup_handler'.
	(guilify_self_1): Initialize `t->cleanup_handler' and
	`t->canceled'.
	(do_thread_exit): Invoke `t->cleanup_handler'.
	(on_thread_exit): Call `scm_i_ensure_signal_delivery_thread ()'.
	Call `scm_i_close_signal_pipe ()' when the next-to-last thread
	vanishes.
	(scm_leave_guile_cleanup): New.
	(scm_i_with_guile_and_parent): Use `scm_i_pthread_cleanup_push ()'
	and `scm_leave_guile_cleanup ()' to leave guile mode, rather
	than call `scm_leave_guile ()' after FUNC.
	(scm_cancel_thread, scm_set_thread_cleanup_x,
	scm_threads_cleanup): New.
	(scm_all_threads): Remove SCM_I_SIGNAL_DELIVERY_THREAD from the
	returned list.
	* threads.h (scm_i_thread)[cleanup_handler, canceled]: New
	fields.
	Add declarations of new functions.

2007-10-17  Ludovic Courtès  <ludo@gnu.org>

	* read.c (CHAR_IS_BLANK_): Add `\r' (ASCII 0x0d).  This fixes a
	regression compared to 1.8.2.  Reported by Puneet
	<schemer@gmail.com>.

2007-10-10  Ludovic Courtès  <ludo@gnu.org>

	* pthread-threads.h (SCM_I_PTHREAD_MUTEX_INITIALIZER): Check
	`SCM_NEED_BRACES_ON_PTHREAD_MUTEX_INITIALIZER'.
	* gen-scmconfig.h.in
	(SCM_I_GSC_NEED_BRACES_ON_PTHREAD_MUTEX_INITIALIZER): New.
	* gen-scmconfig.c (main): Define
	`SCM_NEED_BRACES_ON_PTHREAD_MUTEX_INITIALIZER'.

2007-10-04  Ludovic Courtès  <ludo@gnu.org>

	* i18n.c (scm_make_locale)[!USE_GNU_LOCALE_API]: Don't call
	`leave_locale_section ()' on failure of
	`enter_locale_section ()' since the mutex is not held and locale
	settings are unchanged.
	(scm_nl_langinfo)[!USE_GNU_LOCALE_API]: Use
	`restore_locale_settings ()' instead of `leave_locale_section ()'
	since the mutex is not held.

2007-10-02  Ludovic Courtès  <ludo@gnu.org>

	* threads.c (on_thread_exit): Don't call `scm_leave_guile ()'
	since we're already in non-guile mode.  Reported by Greg Toxel
	for NetBSD.

2007-10-01  Ludovic Courtès  <ludo@gnu.org>

	* ports.c (flush_output_port): Expect directly a port instead of
	a pair.  Fixes a bug in the new port table (2007-08-26).

2007-09-11  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_putenv): Confine the putenv("NAME=") bit to mingw, use
	putenv("NAME") as the fallback everywhere else.  In particular this is
	needed for solaris 9.  Reported by Frank Storbeck.

2007-09-03  Ludovic Courtès  <ludo@gnu.org>

	* read.c (flush_ws): Handle SCSH block comments.

2007-09-03  Ludovic Courtès  <ludo@gnu.org>

	Fix alignment issues which showed up at least on SPARC.

	* socket.c (scm_t_max_sockaddr, scm_t_getsockopt_result): New.
	(scm_inet_pton): Change DST to `scm_t_uint32' for correct
	alignment.
	(scm_getsockopt): Change OPTVAL to `scm_t_getsockopt_result' for
	correct alignment.
	(_scm_from_sockaddr): Change ADDRESS to `scm_t_max_sockaddr *'.
	(scm_from_sockaddr): Cast ADDRESS to `scm_t_max_sockaddr *'.
	(MAX_SIZE_UN, MAX_SIZE_IN6): Removed.
	(scm_accept, scm_getsockname, scm_getpeername, scm_recvfrom):
	Use `scm_t_max_sockaddr' instead of "char max_addr[MAX_ADDR_SIZE]".

2007-09-03  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_log): Test HAVE_CLOG as well as HAVE_COMPLEX_DOUBLE
	before using clog().  It's possible for gcc to provide the "complex
	double" type, but for the system not to have the complex funcs.
	(scm_exp): Ditto HAVE_CEXP for cexp().
	(clog, cexp, carg): Remove fallback definitions.  These only
	duplicated the code within scm_log and scm_exp, and the latter have to
	exist for the case when there's no "complex double".  So better just
	fix up the conditionals selecting between the complex funcs and plain
	doubles than worry about fallbacks.

2007-09-02  Ludovic Courtès  <ludo@gnu.org>

	* socket.c (scm_make_socket_address): Free C_ADDRESS after use.
	This fixes a memory leak.

2007-08-26  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* fports.c gc-card.c gc.c gc.h ioext.c ports.c ports.h weaks.h
	gc.c: replace port table with weak hash table. This simplifies
	memory management, and fixes freed cells appearing in
	port-for-each output.

	* init.c (cleanup_for_exit): abort cleanup if init_mutex is still
	held.

2007-08-23  Ludovic Courtès  <ludo@gnu.org>

	* read.c (scm_read_quote): Record position and copy source
	expression when asked to.  Reported by Kevin.

	* stime.c: Define `_REENTRANT' only if not already defined.

2007-08-21  Kevin Ryde  <user42@zip.com.au>

	* gc-card.c (scm_i_card_statistics): Record scm_tc7_number types as
	tc16 values so big, real, complex and fraction can be distinguished.

	(scm_i_tag_name): Return "number" for scm_tc7_number, not NULL.  NULL
	was making numbers come out as "type 23" in gc-live-object-stats.
	Fix tests of the tc16 number types, they were checked under
	scm_tc7_number, but the values went down the tag>=255 smob case.
	Put smob case under scm_tc7_smob instead of using tag>=255, per
	recommendation in comments with scm_tc7_smob to use symbolic values.
	Use SCM_TC2SMOBNUM to extract scm_smobs index, instead of explicit
	code.  Lose some unnecessary "break" statements.

	(scm_i_card_statistics): Use scm_hashq_create_handle_x and modify the
	element returned, rather than two lookups scm_hashq_ref and
	scm_hashq_set_x.

2007-08-17  Kevin Ryde  <user42@zip.com.au>

	* stime.c: Add #define _REENTRANT, to get gmtime_r() prototype on
	solaris 2.6.  Reported by anirkko.

2007-07-29  Ludovic Courtès  <ludo@gnu.org>

	* Makefile.am (INCLUDES): Added Gnulib includes.
	(gnulib_library): New.
	(libguile_i18n_v_@LIBGUILE_I18N_MAJOR@_la_LIBADD): Added
	`$(gnulib_library)'.
	(libguile_la_LIBADD): Likewise.

	* posix.c: Don't define `_GNU_SOURCE' since `gl_EARLY' arranges
	to define it when available.
	* srfi-14.c: Likewise.
	* i18n.c: Likewise.  Include Gnulib's <alloca.h>
	* eval.c: Include Gnulib's <alloca.h>.
	* filesys.c: Likewise.
	* read.c: Don't include <strings.h> and don't provide an
	`strncasecmp ()' replacement; use Gnulib's <string.h> and
	`strncasecmp ()' instead.

2007-07-25  Ludovic Courtès  <ludo@gnu.org>

	* eval.c (macroexp): When `scm_ilength (res) <= 0', return
	immediately.  This used to produce a circular memoized
	expression, e.g., for `(set (quote x) #t)'.

2007-07-22  Ludovic Courtès  <ludo@gnu.org>

	Overhauled the reader, making it faster.

	* gdbint.c (tok_buf, tok_buf_mark_p): Removed.
	(gdb_read): Don't use a token buffer.  Use `scm_read ()' instead
	of `scm_lreadr ()'.

	* read.c: Overhauled.  No longer use a token buffer.  Use a
	on-stack C buffer in the common case and use Scheme strings when
	larger buffers are needed.
	* read.h (scm_grow_tok_buf, scm_flush_ws, scm_casei_streq,
	scm_lreadr, scm_lreadrecparen): Removed.
	(scm_i_input_error): Marked as `SCM_NORETURN'.

2007-07-15  Ludovic Courtès  <ludo@gnu.org>

	* script.c (scm_compile_shell_switches): Updated copyright year.

2007-07-11  Ludovic Courtès  <ludo@gnu.org>

	* goops.c (scm_sys_method_more_specific_p): Added docstring.
	Make sure LEN is greater than or equal to the minimum length of
	specializers of M1 and M2.  This fixes a segfault later on in
	`more_specificp ()' if TARGS is too small.  Reported by Marco
	Maggi <marco.maggi-ipsu@poste.it>.

2007-06-26  Ludovic Courtès  <ludo@gnu.org>

	* fluids.c (next_fluid_num): When growing ALLOCATED_FLUIDS, make
	sure to free the previous array after the new one has been
	installed.  This leak is made visible by running
	"(define l (map (lambda (i) (make-fluid)) (iota 255)))"
	from the REPL within Valgrind.

2007-06-12  Ludovic Courtès  <ludo@chbouib.org>

	* socket.c (scm_inet_ntop): In the `AF_INET' case, declare `addr4'
	as an `scm_t_uint32' rather than re-using `addr6'.  This fixes a
	bus error on SPARC (and possibly others) due to unaligned access.

2007-06-07  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* posix.c (scm_ttyname): Check whether RESULT is NULL before
	making a string from it (reported by Dan McMahill).  Don't call
	`scm_from_locale_string ()' before the mutex is released.

2007-05-26  Ludovic Courtès  <ludo@chbouib.org>

	* eval.c (scm_m_define): Updated comment.  Changed order for value
	evaluation and `scm_sym2var ()' call, which is perfectly valid per
	R5RS.  This reverts the change dated 2004-04-22 by Dirk Herrmann.

2007-05-05  Ludovic Courtès  <ludo@chbouib.org>

	Implemented lazy duplicate binding handling.

	* modules.c (scm_export): Renamed to...
	(scm_module_export): This.  Now public.
	(module_variable): Removed.
	(default_duplicate_binding_procedures_var): New variable.
	(default_duplicate_binding_handlers, resolve_duplicate_binding,
	module_imported_variable, scm_module_local_variable,
	scm_module_variable): New functions.
	(scm_module_import_interface): Rewritten.
	(scm_module_reverse_lookup): Exported as a Scheme function.
	* modules.h (scm_module_index_duplicate_handlers,
	scm_module_index_import_obarray): New macros.
	(scm_module_variable, scm_module_local_variable,
	scm_module_export): New declarations.

2007-04-17  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* numbers.c: Commented out trailing `HAVE_COMPLEX_DOUBLE' after
	`#endif'.  Use `#ifndef HAVE_XXX' rather than `#if !HAVE_XXX'.

2007-04-09  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* numbers.c (carg): provide carg, cexp, clog in case they are
	missing.

2007-03-12  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* i18n.c (scm_nl_langinfo): `#ifdef'd uses of `GROUPING',
	`FRAC_DIGITS', etc., which are GNU extensions.  Reported by
	Steven Wu.

2007-03-08  Kevin Ryde  <user42@zip.com.au>

	* struct.c, struct.h (scm_make_vtable): New function, providing
	`make-vtable'.
	* stacks.c (scm_init_stacks): Use it.

2007-03-06  Kevin Ryde  <user42@zip.com.au>

	* struct.c (scm_make_struct): Check for R,W,O at end of layout when
	allocating a tail array.  If there's no such then those tail fields
	are uninitialized and garbage SCMs there can cause a segv if printed
	(after fetching with struct-ref).

2007-02-22  Kevin Ryde  <user42@zip.com.au>

	* scmsigs.c (scm_sleep): In docstring, cross refence usleep.
	(scm_usleep): Update docstring per manual, cross reference sleep.

	* struct.c (scm_make_struct): Move SCM_CRITICAL_SECTION_END up so that
	scm_struct_init is not within that section.  scm_struct_init can
	thrown an error, which within a critical section results in an
	abort().

2007-02-19  Neil Jerram  <neil@ossau.uklinux.net>

	* Makefile.am (noinst_HEADERS): Add private-options.h, so that it
	is included in the distribution.
	(noinst_HEADERS): And the same for eval.i.c.

2007-01-31  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* i18n.c: Include "libguile/threads.h" and "libguile/posix.h"
	unconditionally.  Include <langinfo.h> and <nl_types.h> when
	available.
	(SCM_I18N_STRINGIFY, SCM_LOCALE_CATEGORY_MASK,
	SCM_LIST_OR_INTEGER_P): New macros.
	(LC_*_MASK): When `USE_GNU_LOCALE_API' is undefined, define them
	as powers of two instead of `(1 << LC_*)'.
	(scm_i_locale_free): New function/macro.
	(scm_global_locale): New global variable.
	(smob_locale_free): Use `scm_i_locale_free ()'.
	(smob_locale_mark): Check whether the SMOB is `%global-locale'.
	(get_current_locale_settings): Return `EINVAL' instead of `errno'
	when `setlocale' fails.
	(restore_locale_settings): Likewise.
	(install_locale_categories): Likewise.
	(install_locale): Likewise.  Stop the locale stack traversal when
	all categories have been handled.
	(get_current_locale, category_to_category_mask,
	category_list_to_category_mask): New function.
	(scm_make_locale): Use them.  Accept both lists of `LC_*' values
	and single `LC_*' values as the first argument.  Handle the case
	where BASE_LOCALE is `%global-locale'.  When `USE_GNU_LOCALE_API',
	duplicate C_BASE_LOCALE before using it.
	(scm_nl_langinfo, define_langinfo_items): New functions.
	(scm_init_i18n): When `HAVE_NL_LANGINFO', add feature
	`nl-langinfo' and invoke `define_langinfo_items ()'.
	* i18n.h (scm_global_locale, scm_nl_langinfo): New declarations.
	* posix.c: Include <xlocale.h> when available.
	(scm_i_locale_mutex): Always define it.  Statically initialized.
	(scm_set_locale): Invoke `scm_i_to_lc_category ()' before
	acquiring the locale mutex.
	(scm_init_posix): No longer initialize SCM_I_LOCALE_MUTEX here.

2007-01-27  Kevin Ryde  <user42@zip.com.au>

	* ports.c (scm_port_line, scm_set_port_line_x), read.c
	(scm_i_input_error, scm_lreadr, scm_lreadrecparen): Corrections to
	port line number type, should be "long" not "int", as per line_number
	field of scm_t_port.  (Makes a difference only on 64-bit systems, and
	only then for a linenum above 2Gig.)

2007-01-25  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* vector.c: remove comment as per kryde's request.

2007-01-25  Kevin Ryde  <user42@zip.com.au>

	* sort.c (scm_stable_sort): Return empty list for input empty list, as
	done in guile 1.6 and as always done by plain `sort'.  Was falling
	through to SCM_WRONG_TYPE_ARG.  Reported by Ales Hvezda.

2007-01-22  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* vectors.c (s_scm_vector_move_right_x): complain about naming.

	* srcprop.c: regularize comments.

	* eval.c: remove superfluous ifndef DEVAL.

	* private-options.h: idem.

	* eval.i.c: copyright nitpicking.

	* eval.c: distangle. move duplicate code to eval.i.c and include
	twice.

	* eval.i.c: new file.

	* backtrace.c, debug.c, debug.h, deprecation.c, eq.c, eval.c
	eval.h, gsubr.c, init.c, macros.c, print.c, print.h, read.c,
	read.h, stacks.c, symbols.c, throw.c: use private-options.h

	* private-options.h: new file: contain hardcoded option
	definitions.

	* private-gc.h: add FSF header.

2007-01-19  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* debug.h (SCM_RESET_DEBUG_MODE): switch to debugging if
	memoize-symbol is set.

	* eval.h (SCM_MEMOIZE_HDLR): add macros for memoize symbol trap.

	* eval.c (CEVAL): add memoize_symbol trap.

	* options.c (scm_options_try): new function. This allows error
	reporting before changing options in a critical section.

	* srcprop.c: use double cell for storing source-properties.  Put
	filename in the plist, and share between srcprops if possible.
	Remove specialized storage.

	* srcprop.h: remove macros without SCM_ prefix from
	interface. Remove specialized storage/type definitions.

	* read.c: idem.

	* print.c: idem.

	* eval.c: terminate option lists with 0.

	* options.c: remove n (for length) from scm_option_X
	functions. Detect option list length by looking for NULL name.

2007-01-19  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* struct.c (scm_i_struct_equalp): Skip comparison if both FIELD1
	is equal to S1 and FIELD2 is equal to S2.  This avoids infinite
	recursion when comparing `s' fields, as the REQUIRED_VTABLE_FIELDS
	added by `make-vtable-vtable'.  Reported by Marco Maggi.

2007-01-18  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* throw.c (scm_ithrow): more refined error message: print symbols
	too.

2007-01-16  Kevin Ryde  <user42@zip.com.au>

	* feature.c, feature.h (scm_set_program_arguments_scm): New function,
	implementing `set-program-arguments'.

	* filesys.c (scm_init_filesys): Use scm_from_int rather than
	scm_from_long for O_RDONLY, O_WRONLY, O_RDWR, O_CREAT, O_EXCL,
	O_NOCTTY, O_TRUNC, O_APPEND, O_NONBLOCK, O_NDELAY, O_SYNC and
	O_LARGEFILE.  These are all int not long, per arg to open().
	(scm_init_filesys): Use scm_from_int rather than scm_from_long for
	F_DUPFD, F_GETFD, F_SETFD, F_GETFL, F_SETFL, F_GETOWN, F_SETOWN, these
	are all ints (per command arg to fcntl).  Likewise FD_CLOEXEC which is
	an int arg to fcntl.

	* posix.c (scm_putenv): Correction to "len" variable, was defined only
	for __MINGW32__ but used under any !HAVE_UNSETENV (such as solaris).
	Move it to where it's used.  Reported by Hugh Sasse.

	* regex-posix.c (scm_regexp_exec): Remove SCM_CRITICAL_SECTION_START
	and SCM_CRITICAL_SECTION_END, believe not needed.  Their placement
	meant #\nul in the input (detected by scm_to_locale_string) and a bad
	flags arg (detected by scm_to_int) would throw from a critical
	section, causing an abort().

	* regex-posix.c (scm_init_regex_posix): Use scm_from_int for
	REG_BASIC, REG_EXTENDED, REG_ICASE, REG_NEWLINE, REG_NOTBOL,
	REG_NOTEOL; they're all ints not longs (per args to regcomp and
	regexec).

2007-01-10  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* throw.c (scm_ithrow): print out key symbol and string arguments
	when error happens inside a critical section, and document why.

2007-01-06  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* read.c (s_scm_read_hash_extend): document #f argument to
	read-hash-extend.

2007-01-04  Kevin Ryde  <user42@zip.com.au>

	* deprecated.h (scm_create_hook), version.h.in (scm_major_version,
	scm_minor_version, scm_micro_version, scm_effective_version,
	scm_version, scm_init_version): Use SCM_API instead of just extern,
	for the benefit of mingw.  Reported by Cesar Strauss.

2007-01-03  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* gc.c (s_scm_gc_stats): return an entry for total-cells-allocated
	too.
	(gc_update_stats): update scm_gc_cells_allocated_acc too.

2006-12-27  Kevin Ryde  <user42@zip.com.au>

	* threads.c (get_thread_stack_base): In mingw with pthreads we can use
	the basic scm_get_stack_base.  As advised by Nils Durner.

	* threads.c (get_thread_stack_base): Add a version using
	pthread_get_stackaddr_np (when available), for the benefit of MacOS.
	As advised by Heikki Lindholm.

	* scmsigs.c (signal_delivery_thread): Restrict scm_i_pthread_sigmask
	to HAVE_PTHREAD_SIGMASK, it doesn't exist on mingw.  Reported by Nils
	Durner.

2006-12-24  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_kill): When only raise() is available, throw an ENOSYS
	error if pid is not our own process, instead of silently doing nothing.

	* print.c (scm_write, scm_display, scm_write_char): Disable port close
	on EPIPE.  This was previously disabled but introduction of HAVE_PIPE
	check in configure.in unintentionally enabled it.  Believe that
	testing errno after scm_prin1 or scm_putc is bogus, a long ago error
	can leave errno in that state.  popen.test "no duplicates" output test
	provoked that.

2006-12-23  Han-Wen Nienhuys  <hanwen@lilypond.org>

	* numbers.c (scm_i_fraction_reduce): move logic into
	scm_i_make_ratio(), so fractions are only read.
	scm_i_fraction_reduce() modifies a fraction when reading it.  A
	race condition might lead to fractions being corrupted by reading
	them concurrently.

	Also, the REDUCED bit alters the SCM_CELL_TYPE(), making
	comparisons between reduced and unreduced fractions go wrong.

	* numbers.h: remove SCM_FRACTION_SET_NUMERATOR,
	SCM_FRACTION_SET_DENOMINATOR, SCM_FRACTION_REDUCED_BIT,
	SCM_FRACTION_REDUCED_SET, SCM_FRACTION_REDUCED_CLEAR,
	SCM_FRACTION_REDUCED.

2006-12-16  Kevin Ryde  <user42@zip.com.au>

	* scmsigs.c (scm_raise): Use raise() rather than kill(), as this is
	more direct for a procedure called raise.
	(kill): Remove mingw fake fallback.

2006-12-15  Kevin Ryde  <user42@zip.com.au>

	* scmsigs.c: Conditionalize process.h, add io.h believe needed for
	_pipe on mingw.

2006-12-14  Kevin Ryde  <user42@zip.com.au>

	* threads.c (thread_print): Cope with the case where pthread_t is a
	struct, as found on mingw.  Can't just cast to size_t for printing.
	Reported by Nils Durner.

	* scmsigs.c: Add <fcntl.h> and <process.h> needed by mingw.  Copy the
	fallback pipe() using _pipe() from posix.c.  Reported by Nils Durner.

2006-12-13  Kevin Ryde  <user42@zip.com.au>

	* eval.c (scm_m_define): Set 'name procedure property on any
	scm_procedure_p, not just SCM_CLOSUREP.  In particular this picks up
	procedures with setters as used in srfi-17.

	* posix.c (scm_crypt): Check for NULL return from crypt(), which the
	linux man page says is a possibility.

2006-12-12  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* libguile/unif.c (read_decimal_integer): Let RESP be SIGN * RES
	instead of RES (reported by Szavai Gyula).  This allows the use of
	negative lower bounds.
	(scm_i_read_array): Make sure LEN is non-negative (reported by
	Szavai Gyula).

	(scm_array_in_bounds_p): Iterate over S instead of always
	comparing indices with the bounds of S[0].  This fixes
	`array-in-bounds?' for arrays with a rank greater than one and
	with different lower bounds for each dimension.

2006-12-05  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_product): For flonum*inum and complex*inum, return
	exact 0 if inum==0.  Already done for inum*flonum and inum*complex,
	and as per R5RS section "Exactness".

2006-12-03  Kevin Ryde  <user42@zip.com.au>

	* Makefile.am (.c.doc): Remove the "test -n" apparently attempting to
	allow $AWK from the environment to override.  It had syntax gremlins,
	and the presence of a $(AWK) variable set by AC_PROG_AWK in the
	Makefile stopped it having any effect.  Use just $(AWK), which can be
	overridden with "make AWK=xxx" in the usual way if desired.

2006-11-29  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* libguile/vectors.c (scm_vector_to_list): Fixed list
	construction: elements were not copied when INC is zero (see
	"shared array" example in `vectors.test').  Reported by
	Szavai Gyula.

2006-11-18  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* Makefile.am (lib_LTLIBRARIES): Added `libguile-i18n-v-XX.la'.
	(libguile_la_SOURCES): Added `gettext.c', removed `i18n.c'.
	(libguile_i18n_v_XX_la_SOURCES, libguile_i18n_v_XX_la_CFLAGS,
	libguile_i18n_v_XX_la_LIBADD, libguile_i18n_v_XX_la_LDFLAGS): New.
	(DOT_X_FILES): Added `gettext.x'.
	(DOT_DOC_FILES): Likewise.
	(EXTRA_libguile_la_SOURCES): Added `locale-categories.h'.
	(modinclude_HEADERS): Added `gettext.h'.
	(EXTRA_DIST): Added `libgettext.h'.

	* gettext.h: Renamed to...
	* libgettext.h: New file.

	* i18n.c: Renamed to...
	* gettext.c: New file.

	* i18n.h: Renamed to...
	* gettext.h: New file.

	* i18n.c, i18n.h, locale-categories.h: New files.

	* init.c: Include "libguile/gettext.h" instead of
	"libguile/i18n.h".
	(scm_i_init_guile): Invoke `scm_init_gettext ()' instead of
	`scm_init_i18n ()'.

	* posix.c: Include "libguile/gettext.h" instead of
	"libguile/i18n.h"  Test `HAVE_NEWLOCALE' and `HAVE_STRCOLL_L'.
	(USE_GNU_LOCALE_API): New macro.
	(scm_i_locale_mutex): New variable.
	(scm_setlocale): Lock and unlock it around `setlocale ()' calls.

	* posix.h: Include "libguile/threads.h".
	(scm_i_locale_mutex): New declaration.

2006-11-17  Neil Jerram  <neil@ossau.uklinux.net>

	* script.c (scm_shell_usage): Note need for subscription to bug-guile@gnu.org.

2006-11-08  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* libguile/gc-freelist.c (scm_i_adjust_min_yield): Take two
	"sweep_stats" arguments; use them instead of accessing the global
	variables `scm_gc_cells_collected' and `scm_gc_cells_collected_1'.

	* libguile/gc-segment.c (scm_i_sweep_some_cards): Reset SWEEP
	before each iteration of the loop.
	(scm_i_sweep_some_segments): Reset SWEEP at each iteration.
	(scm_i_get_new_heap_segment): Take an additional argument
	SWEEP_STATS.  Compute MIN_CELLS as a function of it.

	* libguile/gc.c (scm_gc_cells_collected,
	scm_gc_cells_collected_1): Removed.
	(scm_i_gc_sweep_stats, scm_i_gc_sweep_stats_1): New.
	(scm_gc_cells_marked_acc, scm_gc_cells_swept_acc,
	scm_gc_time_taken, scm_gc_mark_time_taken, scm_gc_times,
	scm_gc_cell_yield_percentage, protected_obj_count): Made `static'.
	(scm_gc_stats): Use `scm_i_gc_sweep_stats' instead of
	`scm_gc_cells_(collected|swept)'.
	(gc_update_stats): New.
	(gc_end_stats): Use `scm_i_gc_sweep_stats' and
	`scm_i_gc_sweep_stats_1' instead of the former globals.
	(scm_gc_for_newcell): Invoke `gc_update_stats ()' after each
	`scm_i_sweep_some_segments' call.  This fixes a bug where the GC
	would keep allocating new segments instead of re-using collected
	cells (because `scm_gc_cells_collected' would remain zero).

	* libguile/gc.h (scm_gc_cells_swept, scm_gc_cells_collected,
	scm_gc_cell_yield_percentage): Removed.

	* libguile/private-gc.h (scm_gc_cells_collected_1): Removed.
	(scm_i_adjust_min_yield): Updated.
	(scm_i_get_new_heap_segment): Updated.

2006-11-02  Neil Jerram  <neil@ossau.uklinux.net>

	* modules.c: Correct comment saying that low-level environments
	will be used "in the next release".

	* init.c: Comment out #include of environments.h.
	(scm_i_init_guile): Comment out scm_environments_prehistory() and
	scm_init_environments() calls.

	* Makefile.am (libguile_la_SOURCES): Remove environments.c.
	(DOT_X_FILES): Remove environments.x.
	(DOT_DOC_FILES): Remove environments.doc.
	(modinclude_HEADERS): Remove environments.h.

2006-10-25  Neil Jerram  <neil@ossau.uklinux.net>

	IA64 HP-UX GC patch from Hrvoje Nikšić.  (Thanks!)

	* threads.c (SCM_MARK_BACKING_STORE): Use scm_ia64_ar_bsp() and
	scm_ia64_register_backing_store_base() instead of Linux-specific
	implementations.

	* gc.h (scm_ia64_register_backing_store_base, scm_ia64_ar_bsp):
	New declarations.

	* gc.c (__libc_ia64_register_backing_store_base): Declaration
	removed.
	(scm_ia64_register_backing_store_base, scm_ia64_ar_bsp): New, with
	implementations for Linux and HP-UX.

	* coop-pthreads.c (SCM_MARK_BACKING_STORE): Use scm_ia64_ar_bsp()
	and scm_ia64_register_backing_store_base() instead of
	Linux-specific implementations.

	* continuations.h (__libc_ia64_register_backing_store_base):
	Declaration removed.
	(scm_t_contregs): New "fresh" field.

	* continuations.c (ia64_getcontext): Removed.
	(scm_make_continuation): Use continuation fresh field instead of
	interpreting getcontext return values (which isn't portable).  Use
	scm_ia64_ar_bsp() and scm_ia64_register_backing_store_base()
	instead of Linux-specific implementations.
	(copy_stack_and_call): Use scm_ia64_register_backing_store_base()
	instead of Linux-specific implementation.

	* _scm.h (__ia64__): Also detect __ia64.

2006-10-03  Kevin Ryde  <user42@zip.com.au>

	* eval.c (SCM_APPLY): For scm_tc7_subr_2o, throw wrong-num-args on 0
	arguments or 3 or more arguments.  Previously 0 called proc with
	SCM_UNDEFINED, and 3 or more silently used just the first 2.

2006-09-28  Kevin Ryde  <user42@zip.com.au>

	* fports.c, ports.c (ftruncate): Use "HAVE_CHSIZE && ! HAVE_FTRUNCATE"
	for chsize fallback, instead of hard-coding mingw.  Mingw in fact
	supplies ftruncate itself these days.

	* ports.c (fcntl.h): Can include this unconditionally, no need for
	__MINGW32__.

	* ports.c (truncate): Conditionalize on "HAVE_FTRUNCATE && !
	HAVE_TRUNCATE" so as not to hard-code mingw.  Use "const char *" and
	"off_t" for parameters, per usual definition of this function, rather
	than "char *" and "int".  Use ftruncate instead of chsize.  Check for
	error on final close.

2006-09-27  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_log10): Check HAVE_CLOG10, clog10() is not available
	in mingw.

	* posix.c (scm_execl, scm_execlp, scm_execle): Cast "const char *
	const *" for mingw to suppress warnings from gcc (which are errors
	under the configure default -Werror).  Reported by Nils Durner.

2006-09-26  Kevin Ryde  <user42@zip.com.au>

	* _scm.h (scm_to_off64_t, scm_from_off64_t): New macros.
	* fports.c (scm_open_file): Use open_or_open64.
	(fport_seek_or_seek64): New function, adapting fport_seek.
	* fports.c, fports.h (scm_i_fport_seek, scm_i_fport_truncate): New
	functions.
	* ports.c (scm_seek, scm_truncate_file): Use scm_i_fport_seek and
	scm_i_fport_truncate to allow 64-bit seeks and truncates on fports.

	* ports.c (scm_truncate_file): Update docstring per manual.

2006-09-23  Kevin Ryde  <user42@zip.com.au>

	* numbers.c, numbers.h (scm_log, scm_log10, scm_exp, scm_sqrt): New
	functions.

2006-09-20  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* srfi-14.c: Include <config.h>.  Define `_GNU_SOURCE'.
	(make_predset, define_predset, make_strset, define_strset, false,
	true): Removed.
	(SCM_CHARSET_UNSET, CSET_BLANK_PRED, CSET_SYMBOL_PRED,
	CSET_PUNCT_PRED, CSET_LOWER_PRED, CSET_UPPER_PRED,
	CSET_LETTER_PRED, CSET_DIGIT_PRED, CSET_WHITESPACE_PRED,
	CSET_CONTROL_PRED, CSET_HEX_DIGIT_PRED, CSET_ASCII_PRED,
	CSET_LETTER_AND_DIGIT_PRED, CSET_GRAPHIC_PRED, CSET_PRINTING_PRED,
	CSET_TRUE_PRED, CSET_FALSE_PRED, UPDATE_CSET): New macros.
	(define_charset, scm_srfi_14_compute_char_sets): New functions.
	(scm_init_srfi_14): Use `define_charset ()' instead of
	`define_predset ()' and `define_strset ()'.

	* srfi-14.h (scm_c_init_srfi_14): Removed.
	(scm_srfi_14_compute_char_sets): New declaration.

	* posix.h: Include "srfi-14.h".
	(scm_setlocale): Invoke `scm_srfi_14_compute_char_sets ()' after a
	successful `setlocale ()' call.

2006-09-08  Kevin Ryde  <user42@zip.com.au>

	* socket.c (scm_init_socket): Add MSG_DONTWAIT.
	(scm_recvfrom): Update docstring from manual.

2006-08-31  Rob Browning  <rlb@defaultvalue.org>

	* ports.c (scm_c_port_for_each): Add a
	scm_remember_upto_here_1(ports) at the end of the function to fix
	a GC bug.

2006-08-28  Neil Jerram  <neil@ossau.uklinux.net>

	* backtrace.c (scm_display_backtrace_with_highlights): Minor
	improvements to docstring.
	(scm_backtrace_with_highlights): Analogous improvements.

2006-08-12  Kevin Ryde  <user42@zip.com.au>

	* gen-scmconfig.h.in (SCM_I_GSC_NEED_BRACES_ON_PTHREAD_ONCE_INIT):
	New, set from configure.
	* gen-scmconfig.c (SCM_NEED_BRACES_ON_PTHREAD_ONCE_INIT): New output
	to scmconfig.h.
	* pthread-threads.h (SCM_I_PTHREAD_ONCE_INIT): Use
	SCM_NEED_BRACES_ON_PTHREAD_ONCE_INIT to cope with Solaris.
	Reported by Claes Wallin.

2006-08-11  Neil Jerram  <neil@ossau.uklinux.net>

	* stacks.c (scm_last_stack_frame): Correct docstring (returns a
	frame, not a stack).

2006-07-25  Kevin Ryde  <user42@zip.com.au>

	* threads.c (get_thread_stack_base): Restrict HAVE_PTHREAD_GETATTR_NP
	on pthreads version, since pthread_getattr_np not available on solaris
	and macos.  Reported by Claes Wallin.

2006-07-24  Kevin Ryde  <user42@zip.com.au>

	* filesys.c (dirfd): Test with #ifndef rather than HAVE_DIRFD, since
	it's a macro on MacOS X.  Reported by Claes Wallin.

	* posix.c (sethostname): Give prototype if not HAVE_DECL_SETHOSTNAME,
	for the benefit of Solaris 10.  Reported by Claes Wallin.

	* socket.c (scm_htonl, scm_ntohl): Use scm_to_uint32 rather than
	NUM2ULONG, to enforce 32-bit range check on systems with 64-bit long.

2006-07-21  Kevin Ryde  <user42@zip.com.au>

	* eval.c, filesys.c (alloca): Update <alloca.h> etc blob, per current
	autoconf recommendation.  Should fix Solaris 10 reported by Claes
	Wallin.

	* threads.c: Include <string.h>, needed for memset() which is used by
	FD_ZERO() on Solaris 10.  Reported by Claes Wallin.

2006-07-18  Rob Browning  <rlb@defaultvalue.org>

	* continuations.c: Add __attribute__ ((returns_twice)) to the
	ia64_getcontext prototype so that gcc will make the right
	arrangements and avoid an illegal instruction during
	call-with-current-continuation.

2006-07-12  Ludovic Courtès <ludovic.courtes@laas.fr>

	* numbers.c (guile_ieee_init): Use regular ANSI C casts rather
	than C++-style `X_CAST ()'.  Patch posted by by Mike Gran.

2006-07-08  Kevin Ryde  <user42@zip.com.au>

	* environments.c (core_environments_unobserve): Use if/else rather
	than ?: for "SET" bits, avoiding complaints from AIX xlc compiler
	about them not being rvalues.  Reported by Mike Gran.

	* Makefile.am (version.h): Don't use $< in an explicit rule, it's not
	portable and in particular fails on OpenBSD and AIX (see autoconf
	manual too).  Reported by Mike Gran.

2006-06-25  Kevin Ryde  <user42@zip.com.au>

	* stime.c (bdtime2c): tm_gmtoff is seconds East, so take negative of
	tm:gmtoff which is seconds West.  Reported by Aaron VanDevender.
	(bdtime2c): Test HAVE_STRUCT_TM_TM_GMTOFF for tm_gmtoff, rather than
	HAVE_TM_ZONE.
	(scm_strptime): Use tm_gmtoff from the strptime result when that field
	exists, it's set by glibc strptime "%s".

2006-06-13  Ludovic Courtès <ludovic.courtes@laas.fr>

	* eq.c: Include "struct.h", "goops.h" and "objects.h".
	(scm_equal_p): Invoke `scm_i_struct_equalp ()' on structures that
	are not GOOPS instances.
	* struct.c: Include "eq.h".
	(scm_free_structs): Use `SCM_STRUCT_VTABLE_DATA ()' instead of
	hand-written code.
	(scm_i_struct_equalp): New.
	* struct.h (scm_i_struct_equalp): New declaration.

2006-06-06  Kevin Ryde  <user42@zip.com.au>

	* Makefile.am (BUILT_SOURCES): Remove guile.texi, only used by
	maintainers (with doc/maint/docstring.el).  Fixes parallel "make -j2"
	reported by Mattias Holm.

2006-06-03  Kevin Ryde  <user42@zip.com.au>

	* read.c (s_vector): Conditionalize on SCM_ENABLE_ELISP, to avoid
	unused variable warning when elisp disabled.  Reported by Ryan
	VanderBijl.

	* throw.c (scm_handle_by_message): Add dummy return value to avoid
	compiler warning on cygwin.  Reported by Ryan VanderBijl.

	* Makefile.am (EXTRA_DOT_X_FILES): Typo in dependency rule, was a
	duplicate of EXTRA_DOT_DOC_FILES.
	(DOT_X_FILES, EXTRA_DOT_X_FILES, DOT_DOC_FILES, EXTRA_DOT_DOC_FILES):
	Add scmconfig.h to dependencies, since these all run cpp.  Helps a
	parallel "make -j2".  Reported by Mattias Holm.

2006-05-30  Kevin Ryde  <user42@zip.com.au>

	* ports.c, ports.h (scm_set_port_mark, scm_set_port_free,
	scm_set_port_print, scm_set_port_equalp, scm_set_port_flush,
	scm_set_port_end_input, scm_set_port_close, scm_set_port_seek,
	scm_set_port_truncate, scm_set_port_input_waiting): Use scm_t_bits for
	port type descriptor, same as scm_make_port_type return value.

2006-05-30  Marius Vollmer  <mvo@zagadka.de>

	* eq.c (scm_equal_p): Use scm_array_equal_p explicitely when one
	of the arguments is a array.  This allows vectors to be equal to
	one-dimensional arrays.

2006-05-29  Marius Vollmer  <mvo@zagadka.de>

	* throw.c (scm_ithrow): When looking for the jmpbuf, first test
	that we have a pair before accessing its cdr.  Thanks to Bill
	Schottstaedt!

2006-05-28  Kevin Ryde  <user42@zip.com.au>

	* eval.c, filesys.c: Add malloc.h to get alloca() on mingw.  Reported
	by "The Senator".

2006-05-27  Marius Vollmer  <mvo@zagadka.de>

	* srfi-4.c, strings.c: Replace SCM_C_INLINE with
	SCM_C_INLINE_KEYWORD.  Thanks to Mark Gran!

2006-05-26  Kevin Ryde  <user42@zip.com.au>

	* fports.c (fport_input_waiting): For ioctl, check HAVE_IOCTL as well
	as defined(FIONREAD), since mingw has FIONREAD but not ioctl().
	Reported by "The Senator".
	For select and ioctl, move fdes into those conditionals, to avoid
	unused variable warning when neither of those used.

2006-05-23  Kevin Ryde  <user42@zip.com.au>

	* fports.c: Remove "fwrite" declaration under "! HAVE_UNISTD_H".
	It's unused and will be in stdio.h anyway (if it's anywhere).

2006-05-20  Kevin Ryde  <user42@zip.com.au>

	* filesys.c (scm_stat2scm): Test #ifdef S_ISLNK directly, rather than
	HAVE_S_ISLNK from configure (it was only a #ifdef test anyway).

	* posix.c (scm_mknod): Test #ifdef S_IFLNK before using that (for
	symlink).  Probably can't create symlinks with mknod anyway though.

	* inline.h (scm_is_pair): Add a workaround for i386 gcc 2.95 bad code
	generation.

2006-05-15  Kevin Ryde  <user42@zip.com.au>

	* simpos.c, simpos.h (scm_primitive__exit): New function.
	(scm_primitive_exit): Update docstring, no longer the best exit after
	a fork.

2006-05-09  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_i_divide): For big/big wanting inexact, use mpq_get_d
	rather than converting to doubles, to avoid inf or nan when the inputs
	are too big for a double but the quotient does fit.  This affects
	conversions exact->inexact of big fractions.

	* filesys.c (scm_open_fdes): Use open64.
	(scm_init_filesys): Add O_LARGEFILE.

	* ports.c (scm_seek): Use lseek64.
	(scm_truncate_file): Use ftruncate64.

2006-05-08  Marius Vollmer  <mvo@zagadka.de>

	* private-gc.h (CELL_P): Also check that the potential pointer is
	correctly aligned for a cell.  Thanks to Miroslav Lichvar!

2006-04-18  Rob Browning  <rlb@defaultvalue.org>

	* _scm.h: Add back error if the size of off_t is unknown.  The bug
	was actually in guile-readline's configuration.

2006-04-18  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_mkstemp): Update docstring from the manual, in
	particular file mode 0600 is not guaranteed.

2006-04-17  Kevin Ryde  <user42@zip.com.au>

	* _scm.h (scm_to_off_t, scm_from_off_t): No error if unknown off_t
	size, to help the guile-readline build where off_t is unused.

2006-04-16  Kevin Ryde  <user42@zip.com.au>

	* filesys.c (scm_stat2scm, scm_stat, scm_lstat): Use stat or stat64.
	(scm_readdir): Use readdir64.
	(scm_copy_file): Use open64 and fstat64, to cope with >2Gb files.
	* ports.c (scm_truncate_file): Use truncate64.  Correction truncate
	and ftruncate take off_t not size_t.
	* _scm.h (stat_or_stat64 etc): Macros for selecting LFS64 when
	available.

2006-04-06  Kevin Ryde  <user42@zip.com.au>

	* fports.c (scm_setvbuf): Fix for not _IOLBF, clear SCM_BUFLINE
	instead of toggling it.  Reported by Ludovic Courtès.

2006-03-26  Marius Vollmer  <mvo@zagadka.de>

	* threads.c (get_thread_stack_base): Use scm_get_stack_base
	instead of accessing __libc_stack_end directly, and only do this
	when pthread_attr_getstack is known not to work for the main
	thread or when not using pthreads at all.

	* gc_os_dep.c (scm_get_stack_base): Abort when the machine type is
	unknown instead of returning NULL.

2006-03-21  Ludovic Courtès  <ludovic.courtes@laas.fr>

        * numbers.c (scm_i_mem2number): Renamed to
	scm_c_locale_stringn_to_number.
	* numbers.c, print.c, read.c: Updated callers.
        * numbers.h: Update function declaration.

2006-03-11  Neil Jerram  <neil@ossau.uklinux.net>

	* unif.c (string_set): Don't return in a void function.  (Reported
	by Mike Gran.)

	* srfi-4.c (scm_uniform_vector_read_x): Declare base as char*
	rather than void*, so we can do pointer arithmetic on it.
	(Reported by Mike Gran.)
	(s_scm_uniform_vector_write): Ditto.

2006-03-10  Neil Jerram  <neil@ossau.uklinux.net>

	* unif.c (scm_make_shared_array): Don't use SCM_I_ARRAY_BASE when
	oldra is not an array.  (Reported by Steve Juranich.)

	* threads.c (do_unlock): Renamed from "unlock", which is defined
	in unistd.h on QNX.  (Reported by Matt Kraai.)

2006-03-04  Kevin Ryde  <user42@zip.com.au>

	* deprecated.c (scm_i_defer_ints_etc): Show SCM_DEFER_INTS in message,
	not SCM_CRITICAL_SECTION_START.

	* eval.c, posix.c: Change comments from C++ to C style.  Reported by
	Mike Gran.

2006-02-28  Kevin Ryde  <user42@zip.com.au>

	* unif.c (bitvector_set): Use h->writable_elements not h->elements.

2006-02-26  Kevin Ryde  <user42@zip.com.au>

	* filesys.c (scm_readdir): Use fpathconf for the dirent size when
	NAME_MAX is not available, which is so on Solaris 10.  Report and help
	by Bill Schottstaedt.

	* srfi-13.c (MY_VALIDATE_SUBSTRING_SPEC_UCOPY): New macro.
	(scm_string_compare, scm_string_compare_ci, scm_string_lt,
	scm_string_gt, scm_string_le, scm_string_ge, scm_string_ci_lt,
	scm_string_ci_gt, scm_string_ci_le, scm_string_ci_ge): In comparisons
	use "unsigned char", not signed char.  This ensures comparisons are
	the same as `char<?' etc, and is also the same as guile 1.6 did.
	Reported by Sven Hartrumpf.

2006-02-19  Mikael Djurfeldt  <mdj@neurologic.cc>

	* random.c: Test for SCM_HAVE_T_UINT64 instead of
	SCM_HAVE_T_INT64.
	(scm_i_uniform32, scm_i_uniform32, scm_i_init_rstate): Use
	scm_t_uint64 and scm_t_uint32 instead of scm_t_int64 and
	scm_t_int32.

2006-01-04  Ludovic Courtès  <ludovic.courtes@laas.fr>

        * gc-segment.c (scm_i_sweep_some_cards): Take a SWEEP_STATS
        argument.  Don't refer to SCM_GC_CELLS_COLLECTED and
        SCM_CELLS_ALLOCATED.  If SEG->FIRST_TIME, let CELLS_COLLECTED as zero.
        Take into account SEG->SPAN when computing CELLS_SWEPT.
        (scm_i_sweep_segment): Take one more argument, similarly.
        (scm_i_sweep_all_segments): Likewise.
        (scm_i_sweep_some_segments): Likewise.
        (scm_i_adjust_min_yield): Change the way MIN_CELLS is computed: do not
        refer to SCM_GC_CELLS_COLLECTED.

        * gc-freelist.c (scm_i_adjust_min_yield): Take one more
        argument, an `scm_i_sweep_statistics' object.
        Change the way DELTA is collected: don't take into account
        SCM_GC_CELLS_COLLECTED_1, only SWEEP_STATS.COLLECTED.

        * gc-malloc.c (scm_realloc): Pass an extra argument
        to `scm_i_sweep_all_segments ()'.

        * gc.c (gc_start_stats): Updated accordingly.
        (gc_end_stats): Take an additional SWEEP_STATS argument.
        Decrement SCM_CELLS_ALLOCATED after calls to `scm_i_sweep_* ()'.
        (scm_gc_for_newcell): Updated callers of `scm_i_sweep_*'.
        Decrement SCM_CELLS_ALLOCATED.
        (scm_i_gc): Likewise.

        * private-gc.h (scm_i_sweep_*): Updated function
        prototypes accordingly.
        (scm_t_sweep_statistics): New type.
        (scm_i_sweep_statistics_init): New macro.
        (scm_i_sweep_statistics_sum): New macro

2006-02-14  Ludovic Courtès  <ludovic.courtes@laas.fr>

        * strings.c (scm_i_take_stringbufn): Register LEN+1 bytes instead of
	LEN.  Without this, too much collectable memory gets unregistered,
	which results in an underflow of SCM_MALLOCATED in
	`decrease_mtrigger()'.

        * gc-malloc.c (decrease_mtrigger): Make sure SIZE is lower than or
	equal to SCM_MALLOCATED.

2006-02-13  Marius Vollmer  <mvo@zagadka.de>

	* eval.c (scm_eval_body): Use scm_i_dynwind_pthread_mutex_lock
	oinstead of scm_dynwind_pthread_mutex_lock so that it works when
	configured --without-threads.
	(SCM_APPLY, CEVAL): Likewise.  Thanks to Han-Wen Nienhuys!

2006-02-12  Marius Vollmer  <mvo@zagadka.de>

	* unif.c (scm_dimensions_to_uniform_array): Use the prototype for
	filling when the fill parameter is omitted, as documented, but
	turn #\nul into 0 since s8 arrays (signified by a #\nul prototype)
	can not store characters.

2006-02-09  Neil Jerram  <neil@ossau.uklinux.net>

	* socket.c (scm_c_make_socket_address): Pass address_size pointer
	on to scm_fill_sockaddr call.

2006-02-04  Neil Jerram  <neil@ossau.uklinux.net>

	* throw.h (scm_c_catch, scm_c_with_throw_handler,
	scm_catch_with_pre_unwind_handler, scm_with_throw_handler): New.

	* throw.c (SCM_JBPREUNWIND, SCM_SETJBPREUNWIND): New.
	(struct pre_unwind_data): New, replaces struct lazy_catch.
	(scm_c_catch): New, replaces scm_internal_catch as the primary
	catch API for C code; adds pre-unwind handler support.
	(scm_internal_catch): Now just a wrapper for scm_c_catch, for back
	compatibility.
	(tc16_pre_unwind_data, pre_unwind_data_print,
	make_pre_unwind_data, SCM_PRE_UNWIND_DATA_P): Renamed from
	"lazy_catch" equivalents.
	(scm_c_with_throw_handler): New, replaces scm_internal_lazy_catch
	as the primary C API for a "lazy" catch.
	(scm_internal_lazy_catch): Now just a wrapper for
	scm_c_with_throw_handler, for back compatibility.
	(scm_catch_with_pre_unwind_handler): Renamed from scm_catch; adds
	pre-unwind handler support.
	(scm_catch): Now just a wrapper for
	scm_catch_with_pre_unwind_handler, for back compatibility.
	(scm_with_throw_handler): New.
	(scm_lazy_catch): Update comment to say that the handler can
	return, and what happens if it does.
	(toggle_pre_unwind_running): New.
	(scm_ithrow): When identifying the throw target, take running
	flags into account.  In general, change naming of things from
	"lazy_catch" to "pre_unwind".  When throwing to a throw handler,
	don't unwind the dynamic context first.  Add dynwind framing to
	manage the running flag of a throw handler.  If a lazy catch or
	throw handler returns, rethrow the same exception again.  Add
	pre-unwind support to the normal catch case (SCM_JMPBUFP).

	* root.c (scm_internal_cwdr): Add NULL args to
	scm_i_with_continuation_barrier call.

	* dynwind.c: Change comment mentioning lazy-catch to mention
	pre-unwind data and throw handler also.

	* continuations.h (scm_i_with_continuation_barrier): Add
	pre-unwind handler args.

	* continuations.c (scm_i_with_continuation_barrier): Add
	pre-unwind handler args, and pass on to scm_c_catch (changed from
	scm_internal_catch).
	(c_handler): Remove scm_handle_by_message_noexit call.
	(scm_c_with_continuation_barrier): Call
	scm_i_with_continuation_barrier with scm_handle_by_message_noexit
	as the pre-unwind handler.
	(scm_handler): Remove scm_handle_by_message_noexit call.
	(s_scm_with_continuation_barrier): Call
	scm_i_with_continuation_barrier with scm_handle_by_message_noexit
	as the pre-unwind handler.

2006-02-04  Kevin Ryde  <user42@zip.com.au>

	* gc-mark.c (scm_mark_all): Fix c99-isms "loops" and "again" variables.

2006-02-03  Kevin Ryde  <user42@zip.com.au>

	* list.c, list.h (scm_list): Restore this function for use from C.
	It's a complete no-op but in theory might used by someone.

2006-01-30  Marius Vollmer  <mvo@zagadka.de>

	* eval.c (scm_eval_body): Lock source_mutex with a dynwind context
	so that it gets unlocked in all cases.
	(SCM_APPLY, CEVAL): Likewise.

2006-01-29  Marius Vollmer  <mvo@zagadka.de>

	* ramap.c: (scm_array_map_x): Don't use scm_array_p, use
	scm_is_typed_array instead.

	Renamed the "frames" that are related to dynamic-wind to "dynamic
	contexts.  Renamed all functions from scm_frame_ to scm_dynwind_.
	Updated documentation.

	Disabled "futures":

	* futures.h, futures.c: Wrap whole contents in "#if 0"/"#endif".
	* eval.c, init.c: Comment out all 'future' related things.

2006-01-28  Marius Vollmer  <mvo@zagadka.de>

	* inline.h, pairs.c (scm_is_pair): Moved scm_is_pair from pairs.c
	to inline.h to make it inline.

2005-12-19  Ludovic Courtès  <ludovic.courtes@laas.fr>

        * strings.c (scm_i_take_stringbufn): New.
        (scm_i_c_take_symbol): New.
        (scm_take_locale_stringn): Use `scm_i_take_stringbufn ()'.

        * strings.h (scm_i_c_take_symbol): New.
        (scm_i_take_stringbufn): New.

        * symbols.c  (lookup_interned_symbol): New function.
        (scm_i_c_mem2symbol): New function.
        (scm_i_mem2symbol): Use `lookup_symbol ()'.
        (scm_from_locale_symbol): Use `scm_i_c_mem2symbol ()'.  This avoids
        creating a new Scheme string.
        (scm_from_locale_symboln): Likewise.
        (scm_take_locale_symbol): New.
        (scm_take_locale_symboln): New.

        * symbols.h (scm_take_locale_symbol): New.
        (scm_take_locale_symboln): New.

2006-01-18  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* gc-card.c ("sweep_card"): don't count scm_tc_free_cell for
	free_count.

2005-11-29  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* regex-posix.c (s_scm_regexp_exec): list the offending pattern
	upon error

2005-12-29  Neil Jerram  <neil@ossau.uklinux.net>

	* fluids.c (next_fluid_num): [From Ludovic Courtès:] Don't trigger
	the GC when allocated_fluids_len is zero.

2005-12-14  Neil Jerram  <neil@ossau.uklinux.net>

	* load.c (the_reader, the_reader_fluid_num): New.
	(scm_primitive_load): Support custom reader.
	(scm_init_load): Init the_reader and the_reader_fluid_num; export
	the_reader as `current-reader'.

	* scmsigs.c (do_read_without_guile): Use the "raw_data" passed in
	(rather than an uninitialized pointer on the stack).

2005-12-07  Marius Vollmer  <mvo@zagadka.de>

	Reported by Bruce Korb:

	* init.c (invoke_main_func): Don't call exit here.  Throws that
	are only caught by scm_with_guile will bypass us and would cause
	scm_boot_guile to return erroneously.
	(scm_boot_guile): Expect scm_with_guile to return and call exit
	here, passing it an appropriate exit code.

	From Andy Wingo:

	* script.c (scm_find_executable): Compile fix -- fgetc returns an
	unsigned char cast to an int, or -1 for EOS.

2005-12-06  Marius Vollmer  <mvo@zagadka.de>

	* srfi-4.h, srfi-4.c, srfi-4.i.c (take_uvec): Make BASE pointer
	non-const.
	(scm_take_u8vector, etc): Likewise.  Thanks to Ludovic Courtès!

	* threads.h, threads.c (scm_t_guile_ticket, scm_leave_guile,
	scm_enter_guile): Removed from public API.  See comment at
	scm_without_guile for the rationale.

	* scmsigs.c (read_without_guile): New.
	(signal_delivery_thread): Use it instead of
	scm_leave_guile/read/scm_enter_guile.

	From Stephen Compall:

	* eval.c (scm_m_cond): Recognize SRFI 61 cond syntax.
	(CEVAL): Evaluate SRFI 61 cond clauses.

2005-12-06  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* gc-card.c (scm_i_card_statistics): Return if BITVEC is NULL.
	This was typically hit when running `gc-live-object-stats' right
	after starting Guile.

2005-11-30  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (scm_string_append_shared): No copying if just one
	non-empty string in args.

2005-11-26  Kevin Ryde  <user42@zip.com.au>

	* gc-mark.c (scm_mark_all): Change C++ comment to C comment.  Reported
	by Ludovic Courtès.

	* list.c (list): Should be "primitive" in SCM_SNARF_DOCS, not
	"register".

	* random.c (scm_i_copy_rstate, scm_c_make_rstate): Don't test for
	scm_malloc returning NULL, it never does that.
	* putenv.c (putenv): Likewise.

	* socket.c (scm_fill_sockaddr): Remove SCM_C_INLINE_KEYWORD, this is
	much too big to want to inline.

2005-11-17  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* print.c (EXIT_NESTED_DATA): Before popping from the stack, reset
	the value at its top.  This fixes a reference leak.
	(PUSH_REF): Perform `pstate->top++' after calling
	`PSTATE_STACK_SET ()' in order to avoid undesired potential side
	effects.

2005-11-12  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* gc.c (scm_weak_vectors): Removed.

2005-11-12  Kevin Ryde  <user42@zip.com.au>

	* socket.c (scm_setsockopt): Missing @defvar in docstring.  Reported
	by Ludovic Courtès.

2005-11-07  Marius Vollmer  <mvo@zagadka.de>

	* stime.c (scm_mktime): Use scm_frame_critical_section instead of
	SCM_CRITICAL_SECTION_START/END since the code inside the critical
	section might exit non-locally.

2005-11-04  Neil Jerram  <neil@ossau.uklinux.net>

	* eval.c (sym_instead): New symbol.
	(ENTER_APPLY): Remove optional use of a continuation when making
	trap call.
	(scm_debug_opts): Change doc for 'cheap option to make clear that
	it is now obsolete.
	(CEVAL, SCM_APPLY): Remove optional use of a continuation when
	making trap calls, and implement substitution of eval expressions
	and return values using the values that the trap call handlers
	return.

	* debug.h (SCM_CHEAPTRAPS_P): Removed.

2005-10-27  Ludovic Courtès  <ludovic.courtes@laas.fr>

	* socket.c (scm_fill_sockaddr): No need to check NULL from scm_malloc.
	(scm_connect, scm_bind, scm_sendto): Accept sockaddr object.
	(scm_addr_vector): Renamed to _scm_from_sockaddr, update usages.
	(scm_from_sockaddr, scm_to_sockaddr, scm_make_socket_address,
	scm_c_make_socket_address): New functions.
	* socket.h: Add prototypes.

2005-10-24  Kevin Ryde  <user42@zip.com.au>

	* socket.c (scm_init_socket): Add IPPROTO_IP, IPPROTO_TCP,
	IPPROTO_UDP.  Remove SOL_IP, SOL_TCP, SOL_UDP.  The former are in
	POSIX spec examples, the latter are not available on for instance
	NetBSD.

	* socket.c (scm_getsockopt, scm_setsockopt): Update docstrings from
	posix.texi.

	* stime.c (scm_strftime): Update docstring from posix.texi.

2005-10-23  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP is not portable enough.

	* null-threads.h, pthread-threads.h
	(SCM_I_PTHREAD_RECURSIVE_MUTEX_INITIALIZER): Removed.
	(scm_i_pthread_mutexattr_recursive): New.

	* threads.c (scm_i_pthread_mutexattr_recursive): Declare.
	(scm_i_critical_section_mutex): Do not initialize statically.
	(scm_threads_prehistory): Initialize
	scm_i_pthread_mutexattr_recursive and scm_i_critical_section_mutex
	here.

	* eval.c (source_mutex): Do not initialiaze statically.
	(scm_init_eval): Do it here, using
	scm_i_pthread_mutexattr_recursive.

2005-09-05  Marius Vollmer  <mvo@zagadka.de>

	* print.h (SCM_PRINT_KEYWORD_STYLE_I, SCM_PRINT_KEYWORD_STYLE):
	New.
	(sym_reader): New.
	(scm_print_opts): Added "quote-keywordish-symbols" option.
	(quote_keywordish_symbol): New, for evaluating the option.
	(scm_print_symbol_name): Use it.
	(scm_init_print): Initialize new option to sym_reader.

2005-08-15  Neil Jerram  <neil@ossau.uklinux.net>

	* eval.c (eval_letrec_inits): New.
	(CEVAL): Eval letrec initializer forms using eval_letrec_inits.

2005-08-12  Marius Vollmer  <mvo@zagadka.de>

	* numbers.c: Use scm_from_bool instead of SCM_BOOL.  Thanks to
	Peter Gavin!

2005-08-12  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (scm_string_for_each_index): Correction to docstring.

2005-08-06  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (scm_string_any, scm_string_every, scm_string_tabulate,
	scm_string_trim, scm_string_trim_right, scm_string_trim_both,
	scm_string_index, scm_string_index_right, scm_string_skip,
	scm_string_skip_right, scm_string_count, scm_string_map,
	scm_string_map_x, scm_string_for_each, scm_string_for_each_index,
	scm_string_filter, scm_string_delete): Use scm_t_trampoline_1 for
	procedures called in loops.

2005-08-02  Kevin Ryde  <user42@zip.com.au>

	* strports.c (st_flush): Increase buffer by 1.5x when growing, to
	avoid lots of copying where previoulsy growing by only 80 bytes at a
	time.

2005-08-01  Marius Vollmer  <mvo@zagadka.de>

	* modules.h, modules.c (scm_eval_closure_module): Removed, we
	already have scm_lookup_closure_module, which does the same thing.

2005-08-01  Marius Vollmer  <mvo@zagadka.de>

	New marking algorithm for weak hashtables that fixes the problem
	that references from the non-weak value to the associated weak
	key (for example) would prevent the entry from ever being dropped.

	Guardians have been changed back to their original semantics and
	are no longer greedy and no longer drop cycles.

	* gc-mark.c (scm_mark_all): Do not rely on hooks to run the weak
	hashtable and guardian machinery but call the relevant functions
	directly.

	* guardians.h, guardians.c, deprecated.h,
	deprecated.c (scm_destroy_guardian_x, scm_guardian_greedy_p,
	scm_guardian_destroyed_p, scm_guard, scm_get_one_zombie):
	Deprecated and moved into deprecated.[ch].

	* guardians.h, guardians.c: Mostly rewritten.
	(scm_i_init_guardians_for_gc,
	scm_i_identify_inaccessible_guardeds,
	scm_i_mark_inaccessible_guardeds): New.
	(scm_make_guardian): Removed greedy_p argument.

	* weaks.h, weaks.c (SCM_I_WVECT_TYPE, SCM_I_SET_WVECT_TYPE): New.
	(SCM_I_WVECT_N_ITEMS, SCM_I_SET_WVECT_N_ITEMS): New.
	(SCM_WVECTF_NOSCAN, SCM_WVECT_NOSCAN_P): Removed.
	(scm_weaks_prehistory): Removed.
	(scm_i_init_weak_vectors_for_gc, scm_i_mark_weak_vector,
	scm_i_mark_weak_vectors_non_weaks,
	scm_i_remove_weaks_from_weak_vectors, scm_i_remove_weaks): New.
	(scm_weak_vector_gc_init, scm_mark_weak_vector_spines,
	scm_scan_weak_vectors): Removed.

	* hashtab.h (scm_i_scan_weak_hashtables): New.
	* hashtab.c (make_hash_table, scm_i_rehash): Do not use
	SCM_WVECTF_NOSCAN.
	(hashtable_print): Use SCM_HASHTABLE_N_ITEMS instead of
	t->n_items.
	(scan_weak_hashtables, scm_i_scan_weak_hashtables): Renamed former
	to latter.  Do not scan the alists themselves, this is done by the
	weak vector code now.  Just update the element count.

	* vectors.h (SCM_I_WVECT_TYPE, SCM_I_WVECT_EXTRA): Renamed former
	to latter.  The type is now only part of the cell word.
	(SCM_I_SET_WVECT_TYPE, SCM_I_SET_WVECT_EXTRA): Likewise.

	* init.c (scm_i_init_guile): Do not call scm_weaks_prehistory.

2005-07-18  Mikael Djurfeldt  <mdj@d14n36.pdc.kth.se>

	Some changes towards making it possible to run Guile on the EM64T
	platform.

	* gc.c (scm_gc_stats): Bugfix: Measure size of the type we are
	mallocating for (unsigned long *bounds).

	* hashtab.c (scm_i_rehash): Cast SCM_HASHTABLE_FLAGS (table) to
	scm_t_bits before storing them in the type word.

	* gc.c (tag_table_to_type_alist): Modified type of c_tag from
	scm_t_bits to int.

2005-07-12  Kevin Ryde  <user42@zip.com.au>

	* eval.c (scm_dbg_make_iloc): Should be SCM_IFRAMEMAX and
	SCM_IDISTMAX, and cast uints through scm_t_bits to make gcc happy.
	* pairs.c (scm_error_pair_access): Use scm_from_locale_string rather
	than scm_makfrom0str.
	Reported by Ken Raeburn.

	* gc-card.c (scm_dbg_gc_get_bvec): Change return from long* to
	scm_t_c_bvec_long*, gcc 4 doesn't like different pointer targets when
	returning SCM_GC_CARD_BVEC.

	* pairs.c (scm_error_pair_access): Plain ascii ' in error message
	rather than latin-1 acute accent, the latter may not print on all
	terminals.

	* srfi-13.c (scm_string_filter, scm_string_delete): Strip leading and
	trailing deletions, so as to return a substring if those are the only
	changes.

2005-07-10  Kevin Ryde  <user42@zip.com.au>

	* socket.c (scm_inet_pton, scm_inet_ntop): Pointer cast to scm_t_uint8
	for scm ipv6 funcs, gcc 4 is picky about char* vs uchar*.
	(scm_getsockopt, scm_accept, scm_getsockname, scm_getpeername,
	scm_recvfrom) Use socklen_t, gcc 4 is picky about int* vs socklen_t*.

2005-07-01  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* gc-card.c (scm_i_card_statistics): init tag.

	* gc.c (tag_table_to_type_alist): check type of tag. Should be integer.

2005-06-18  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* fports.c (s_scm_open_file): add the b flag for binary to the doc
	string.

2005-06-25  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (scm_string_filter, scm_string_delete): Partial revert
	last change, use plain copy-on-write substrings, the individual
	descriptions in the srfi don't mention shared storage (only the
	introduction does).

	* strings.c (scm_take_locale_stringn): Use realloc to make room for
	null-terminator, rather than mallocing a whole new block.
	(scm_take_locale_string): Use scm_take_locale_stringn len==-1.

2005-06-12  Marius Vollmer  <mvo@zagadka.de>

	* ramap.c (scm_array_index_map_x): First test for real arrays,
	then check for generalized vectors.  This ensures that the
	generalized vector case need only work with zero-origin ranges.
	(scm_ra_eqp, scm_ra_compare): Use the new array handle functions
	to access the target array, making these functions work with all
	kinds of arrays, not just bit arrays.

	* gh.h, gh_data.c, gh_eval.c, gh_funcs.c, gh_init.c, gh_io.c,
	gh_list.c, gh_predicates.c: Deprecated everything.

	* environments.c (environment_default_folder,
	environment_default_observer): Do not use gh_call3, gh_call1.

2005-06-10  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* modules.c (s_scm_eval_closure_module): new function. Return the
	module inside an eval-closure.

	* gc.c (scm_init_storage): make scm_stand_in_procs a weak_key hash
	table. This means that procedure properties are GC'd if the
	procedure dies.

2005-06-11  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (scm_string_filter, scm_string_delete): For char and
	charset cases, count chars kept and build a string in a second pass,
	rather than using a cons cell for every char kept.  Use a shared
	substring when nothing removed (such sharing is allowed by the srfi).

2005-06-09  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* gc.c (tag_table_to_type_alist): convert tag number to "tag %d"
	string, so live object stats can be sorted with string<?.

2005-06-06  Marius Vollmer  <mvo@zagadka.de>

	* print.c (iprin1): When writing a string, collect all characters
	that can be printed directly into one call to scm_lfwrite.
	Previously, every character was output with its own call to
	write(2) on unbuffered ports.

	* eval.c (scm_eval_options_interface): Use
	scm_frame_critical_section instead of SCM_CRITICAL_SECTION_START
	and SCM_CRITICAL_SECTION_END.

	* unif.c (scm_array_in_bounds_p): First test for real arrays, then
	check for generalized vectors.  This ensures that the generalized
	vector case need only work with zero-origin ranges.

2005-06-06  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (scm_string_split): Compare char/char in scan.  Mixing an
	unsigned int SCM_CHAR and a char string meant an 8-bit char was never
	matched.

2005-06-05  Marius Vollmer  <mvo@zagadka.de>

	* eval.c: Added comment on how to make case 1.1 of
	r5rs_pitfall.test succeed.

	From Jan Nieuwenhuizen <janneke@gnu.org>. Thanks!

 	* hashtab.h: Bugfix: use SCM_API (WAS: extern).

 	* socket.c: Remove obsolete comment about socklen_t.
 	(s_scm_setsockopt)[!HAVE_IP_MREQ]: Do not use ip_mreq code.

 	* numbers.h (isnan)[__MINGW32__]: Remove.

 	* Makefile.am (gen_scmconfig_SOURCES): Bugfix: Add
 	DEFAULT_INCLUDES when cross compiling.

 	* threads.c (ETIMEDOUT, pipe)[__MINGW32__]: Add defines.

 	* stime.c (scm_strftime)[!HAVE_TM_ZONE]: Use
	SCM_SIMPLE_VECTOR_REF instead of SCM_VELTS.  (Changed slightly
	from Jan's patch.)

2005-05-22  Marius Vollmer  <mvo@zagadka.de>

	* unif.c (scm_make_shared_array): Add old base to new base since
	scm_array_handle_pos does not include the base.
	(scm_aind): Likewise.

	* ports.c (scm_putc, scm_puts): Assert that the port argument is a
	output port.

2005-05-12  Neil Jerram  <neil@ossau.uklinux.net>

	Mac OS X compile warning fixes, reported by Richard Todd.

	* unif.c (scm_i_read_array): Declare rank as ssize_t, to guarantee
	that it is signed.

	* strports.c (st_resize_port): Add unsigned char cast.
	(scm_mkstrport): Make read/write_buf cast unsigned.

	* srfi-13.c (string_titlecase_x): Add unsigned char cast.

	* rdelim.c (scm_read_line): Initialize slen.

	* load.c (scm_search_path): Remove weird >=1, and add
	parentheses to clarify conditions.

	* hash.c (scm_hasher): Add const unsigned char cast.

	* gh_data.c (gh_chars2byvect): Add scm_t_int8 cast.

2005-05-11  Neil Jerram  <neil@ossau.uklinux.net>

	Fix C99isms reported by Ludovic Courtès:

	* threads.c (s_scm_lock_mutex): Don't declare msg in middle of
	code.

	* gc.c (s_scm_gc_live_object_stats): Don't declare alist in middle
	of code.

	* gc-card.c (scm_i_card_statistics): Don't declare tag in middle
	of code.
	(scm_i_card_statistics): Add block for declarations of tag_as_scm
	and current.

2005-05-10  Neil Jerram  <neil@ossau.uklinux.net>

	* scmsigs.c (signal_delivery_thread): Return a value, to avoid
	compile warning reported by Werner Scheinast.

2005-04-30  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* list.h: remove scm_list()

	* fluids.c (DYNAMIC_STATE_NEXT_LOC): new macro for use with
	SCM_DEBUG_CELL_ACCESSES
	(FLUID_NEXT_LOC): idem.

2005-04-30  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_divide): Correction to 1/complex and <any>/complex,
	need to test abs(re)<abs(im) for choice of cases, otherwise divide by
	zero when re==0 and im<0.  Reported by Jean Crepeau.

2005-04-25  Kevin Ryde  <user42@zip.com.au>

	* ramap.c (scm_array_map_x): Allow no source args, add num args checks
	to subr_1, subr_2, subr_2o and dsubr cases.  No source args only has a
	few sensible uses (like filling with a random number generator say),
	but has been allowed in the past and so should be kept.

2005-04-23  Kevin Ryde  <user42@zip.com.au>

	* hashtab.c (scm_hashx_remove_x): Need to pass "closure" to
	scm_hash_fn_remove_x.

	* list.c (scm_cons_star): Don't modify the rest list, it belongs to
	the caller when cons* is reached through apply.

	* list.c (list): Use scm_list_copy, so as to produce a fresh list when
	list is called using apply, under the debugging evaluator.
	(scm_list): Remove.

	* list.c, list.h (scm_make_list): New code, moving make-list from
	boot-9.scm.

2005-04-14  Kevin Ryde  <user42@zip.com.au>

	* numbers.c, numbers.h (scm_oneplus, scm_oneminus): New functions,
	converted from scheme code in boot-9.scm.

2005-04-11  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (scm_string_concatenate, scm_string_concatenate_shared):
	Validate list argument, scm_string_append and scm_string_append_shared
	don't do that to their rest argument (in a normal build).

2005-04-04  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* hashtab.h, hashtab.c (scm_t_hashtable): Removed 'closure' field.  The
	closure can not be stored since it is no longer valid at GC time.
	(make_hash_table): Initialize 'hash_fn' field.
	(scm_i_rehash): Only store hash_fn in hash table when closre is
	NULL.
	(rehash_after_gc): Only call scm_i_rehash when 'hash_fn' is
	non-NULL.  Always use a NULL closure.
	(scm_hash_fn_create_handle_x): Also rehash when table contains too
	few entries.

2005-03-29  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* hashtab.h, hashtab.c (scm_hash_fx_remove_x): Removed delete_fn
	argument; always use scm_delq_x.  The delete_fn function works on
	the handle, not the key, and it therefore makes no sense to make
	it configurable.  Changed all callers.
	(scm_hashx_remove_x): Likewise.  Also, exported to Scheme.
	(scm_hash_clear): Accept plain vectors as hashtables.
	(scm_delx_x): Removed.

2005-03-28  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* inline.h (scm_double_cell): use __asm__ iso. asm, to maintain
	compatibility with gcc -std=c99.

2005-03-24  Mikael Djurfeldt  <djurfeldt@nada.kth.se>

	* async.h (scm_mask_ints): Removed left over reference to
	scm_root.

	* threads.c: Removed fprintf debug statements.

2005-03-24  Neil Jerram  <neil@ossau.uklinux.net>

	* debug.c (scm_make_memoized): Restore use of SCM_UNPACK.

2005-03-23  Neil Jerram  <neil@ossau.uklinux.net>

	* debug.c (scm_make_memoized): Remove unnecessary critical
	section, and simplify by using SCM_RETURN_NEWSMOB.

2005-03-20  Mikael Djurfeldt  <djurfeldt@nada.kth.se>

	* strings.h (SCM_STRING_UCHARS): Added missing argument.

2005-03-18  Kevin Ryde  <user42@zip.com.au>

	* arbiters.c (FETCH_STORE) [generic C]: Should be
	scm_i_scm_pthread_mutex_lock/unlock now.  Reported by Ludovic Courtès.

2005-03-13  Kevin Ryde  <user42@zip.com.au>

	* numbers.c, numbers.h (scm_i_clonebig): Remove static, so can use in
	srfi-60.

	* numbers.c (scm_logior): Must scm_i_normbig results as per scm_logand,
	because OR-ing bits into a negative can reduce the value to an inum.

	* numbers.c (scm_num_eq_p): On 64-bit systems, be careful about
	casting inum to double since that can lose precision.

2005-03-10  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* threads.h, threads.c (scm_i_thread): Added gc_running_p field.
	(guilify_self_1): Initialize it.

	* gc.h, gc.c (SCM_FREECELL_P): Removed for good.
	(scm_block_gc, scm_gc_heap_lock): Removed.  Removed all uses.
	(scm_gc_running_p): Now a macro that refers to the scm_i_thread
	field.
	(scm_i_sweep_mutex): Now a non-recursive mutex.  GC can not happen
	recursively.
	(scm_igc, scm_i_gc): Renamed former to latter.  Changed all uses.
	Do not lock scm_i_sweep_mutex, which is now non-recursive, or set
	scm_gc_running_p.  Do not run the scm_after_gc_c_hook.
	(scm_gc): Lock scm_i_sweep_mutex, set scm_gc_running_p and run the
	scm_after_gc_c_hook here.
	(scm_gc_for_new_cell): Set scm_gc_running_p here and run the
	scm_after_gc_c_hook when a full GC has in fact been performed.
	(scm_i_expensive_validation_check): Call scm_gc, not scm_i_gc.

	* gc-segment.c (scm_i_get_new_heap_segment): Do not check
	scm_gc_heap_lock.

	* gc-malloc.c (scm_realloc, increase_mtrigger): Set
	scm_gc_running_p while the scm_i_sweep_mutex is locked.

	* inline.h (scm_cell, scm_double_cell): Do not check
	scm_gc_running_p, allocation during sweeping is OK.

	* gdbint.c (SCM_BEGIN_FOREIGN_BLOCK, SCM_END_FOREIGN_BLOCK): Do
	not set scm_block_gc.

	* init.c (scm_i_init_guile): Do not set scm_block_gc.

	* deprecation.c (scm_c_issue_deprecation_warning): Use malloc
	instead of scm_malloc.  The latter can not be used during GC.

2005-03-09  Marius Vollmer  <mvo@zagadka.de>

	* script.c (scm_compile_shell_switches): Added 2005 to Copyright
	years.

2005-03-09  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* gc-card.c (scm_i_sweep_card): Do not increase/decrease
	scm_gc_running_p.  Sweeping can happen in parallel with
	allocation.

	* inline.h: Updated comments for current threading implementation.

	* threads.h, threads.c (scm_i_frame_single_threaded): Removed.
	(scm_i_thread): Removed unused signal_asyncs field.
	(threads_mark): Do not mark it.
	(guilify_self_1): Do not initialize it.  Do initialize
	continuation_root field.
	(do_thread_exit): Do not remove thread from all_threads list.
	(on_thread_exit): Do it here, after leaving guile mode.
	(sleep_level): Removed.
	(scm_i_thread_put_to_sleep): Leave thread_admin_mutex locked when
	returning.  Do not support recursive sleeps.
	(scm_i_thread_wake_up): Expect thread_admin_mutex to be locked on
	entry.  Do not support recursive sleeps.

	* fluids.c (ensure_state_size, ensure_all_state_sizes,
	resize_all_states): Collapsed ensure_state_size and
	ensure_all_state_sizes into one function named resize_all_states.
	Allocate new vectors outside of single threaded region.  Do only
	simple things inside that region.
	 (scm_make_fluid, scm_make_dynamic_state): Lock fluid_admin_mutex
	while adding to the global lists.


2005-03-08  Marius Vollmer  <mvo@zagadka.de>

	libltdl is no longer distributed.  We expect it to be installed
	already.

	* Makefile.am (INCLUDES): Removed @LTDLINCL@.
	(libguile_la_LIBADD): Removed @LIBLTDL@.

2005-03-07  Marius Vollmer  <mvo@zagadka.de>

	* threads.h, async.h, threads.c (SCM_CRITICAL_SECTION_START,
	SCM_CRITICAL_SECTION_END): Moved here from threads.h since now
	they also block/unblock execution of asyncs and call
	scm_async_click which is declared in async.h but threads.h can not
	include async.h since async.h already includes threads.h.
	(scm_i_critical_section_level): New, for checking mistakes in the
	use of the SCM_CRITICAL_SECTION_* macros.
	(scm_i_critical_section_mutex): Make it a recursive mutex so that
	critical sections can be nested.

	* throw.c (scm_ithrow): Abort when scm_i_critical_section_level is
	not zero.

	* threads.h, threads.c (scm_frame_lock_mutex): New.
	(scm_frame_critical_section): Take mutex as argument.
	(framed_critical_section_mutex): New, used as default for above.
	(scm_init_threads): Initialize it.
	(scm_threads_prehistory): Do not initialize thread_admin_mutex and
	scm_i_critical_section_mutex; both are initialized statically.

	* continuation.c, deprecated.c, goops.c, guardians.c keywords.c,
	libguile_la-arrays.loT, objprop.c, ports.c, smob.c, sort.s,
	srcprop.c, stime.c, struct.c, throw.c, regex-posix.c: Include
	"libguile/async.h" for SCM_CRITICAL_SECTION_START/END.

	* debug.c (scm_debug_options): Replace
	SCM_CRITICAL_SECTION_START/END with a frame and
	scm_frame_critical_section.

	* continuations.c (scm_make_continuation): No longer a critical
	section.
	(scm_dynthrow):  Abort when scm_i_critical_section_level is
	not zero.

2005-03-04  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* threads.c (scm_try_mutex): Renamed argument for consistency.

	* root.c (scm_call_with_dynamic_root): New docstring.

	* eval.c: Define _GNU_SOURCE.

2005-03-02  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	Big merge from the mvo-thread-cleanup branch. The main changes
	are:

	- The dynamic roots functionality has been split into dynamic
	  states and continuations barriers.  Fluids have been
	  reimplemented and can now be garbage collected.

	- Initialization of Guile now works in a multi-thread friendly
	  manner.  Threads can freely enter and leave guile mode.

	- Blocking on mutexes or condition variables or while selecting
	  can now be reliably interrupted via system asyncs.

	- The low-level threading interface has been removed.

	- Signals are delivered via a pipe to a dedicated 'signal delivery
	  thread'.

	- SCM_DEFER_INTS, SCM_ALLOW_INTS etc have been deprecated.

	* throw.c (scm_handle_by_message): Exit only the current thread,
	not the whole process.
	(scm_handle_by_message_noexit): Exit when catching 'quit.

	* scmsigs.c (take_signal, signal_delivery_thread,
	start_signal_delivery_thread, ensure_signal_delivery_thread,
	install_handler): Reimplemented signal delivery as explained in
	the comments.

	* pthreads-threads.h (scm_i_pthread_t, scm_i_pthread_self,
	scm_i_pthread_create, scm_i_pthread_detach, scm_i_pthread_exit,
	scm_i_sched_yield, scm_i_pthread_sigmask,
	SCM_I_PTHREAD_MUTEX_INITIALIZER,
	SCM_I_PTHREAD_RECURSIVE_MUTEX_INITIALIZER, scm_i_pthread_mutex_t ,
	scm_i_pthread_mutex_init, scm_i_pthread_mutex_destroy,
	scm_i_pthread_mutex_trylock, scm_i_pthread_mutex_lock,
	scm_i_pthread_mutex_unlock, SCM_I_PTHREAD_COND_INITIALIZER,
	scm_i_pthread_cond_t, scm_i_pthread_cond_init,
	scm_i_pthread_cond_destroy, scm_i_pthread_cond_signal,
	scm_i_pthread_cond_broadcast, scm_i_pthread_cond_wait,
	scm_i_pthread_cond_timedwait, scm_i_pthread_once_t,
	SCM_I_PTHREAD_ONCE_INIT, scm_i_pthread_once, scm_i_pthread_key_t ,
	scm_i_pthread_key_create, scm_i_pthread_setspecific,
	scm_i_pthread_getspecific, scm_i_scm_pthread_mutex_lock,
	scm_i_frame_pthread_mutex_lock, scm_i_scm_pthread_cond_wait,
	scm_i_scm_pthread_cond_timedwait): Provide the obvious mapping
	when using pthreads.
	* null-threads.c, null-threads.h: Provide dummy definitions for
	the above symbols when not using pthreads.

	* modules.h, modules.c (scm_frame_current_module): New.

	* load.c (scm_primitive_load): Use scm_i_frame_current_load_port
	instead of scm_internal_dynamic_wind.

	* init.h, init.c (restart_stack, start_stack): Removed.
	(scm_boot_guile, invoke_main_func): Simply use scm_with_guile.
	(scm_boot_guile_1): Removed.
	(scm_i_init_mutex): New.
	(really_cleanup_for_exit, cleanup_for_exit): New.
	(scm_init_guile_1, scm_i_init_guile): Renamed former to latter.
	Moved around some init funcs.  Call
	scm_init_threads_default_dynamic_state.  Register cleanup_for_exit
	with atexit.

	* hashtab.c (scm_hash_fn_create_handle_x, scm_hash_fn_remove_x):
	Use "!scm_is_eq" instead of "!=".

	* ge-scmconfig.c, gen-scmconfig.h.in (SCM_I_GSC_USE_COOP_THREADS,
	SCM_USE_COOP_THREADS): Removed.

	* gc.c (scm_igc): Take care that scm_gc_running_p is properly
	maintained.  Unlock scm_i_sweep_mutex before running
	scm_after_gc_c_hook.
	(scm_permanent_object): Allocate outside of critical section.
	(cleanup): Removed.

	* fluids.h, fluids.c: Reimplemented completely.
	(SCM_FLUID_NUM, SCM_FAST_FLUID_REF,
	SCM_FAST_FLUID_SET): Reimplemented as functions.
	(scm_is_fluid): New.
	(scm_i_make_initial_fluids, scm_i_copy_fluids): Removed.
	(scm_make_dynamic_state, scm_dynamic_state_p,
	scm_is_dynamic_state, scm_current_dynamic_state,
	scm_set_current_dynamic_state, scm_frame_current_dynamic_state,
	scm_c_with_dynamic_state, scm_with_dynamic_state,
	scm_i_make_initial_dynamic_state, scm_fluids_prehistory): New.

	* feature.c (progargs_fluid): New.
	(scm_program_arguments, scm_set_program_arguments): Use it instead
	of scm_progargs.
	(scm_init_feature): Allocate it.  Also, only add "threads" feature
	when SCM_USE_PTHREAD_THREADS is true.

	* eval.c (scm_makprom): Use scm_make_recursive_mutex instead of
	scm_make_rec_mutex, with all the consequences.
	(scm_eval_x, scm_eval): Use scm_frame_begin etc instead of
	scm_internal_dynamic_wind.  Handle dynamic states as second
	argument.

        * threads.h, threads.c (scm_internal_select): Renamed to
	scm_std_select and discouraged old name.
	(scm_thread_sleep, scm_thread_usleep): Likewise, as scm_std_sleep
	and scm_std_usleep.
	(scm_tc16_fair_mutex, scm_tc16_fair_condvar, SCM_MUTEXP,
	SCM_FAIR_MUTEX_P, SCM_MUTEX_DATA, SCM_CONDVARP,
	SCM_FAIR_CONDVAR_P, SCM_CONDVAR_DATA, SCM_THREADP,
	SCM_THREAD_DATA): Removed.
	(SCM_I_IS_THREAD, SCM_I_THREAD_DATA): New.
	(scm_i_thread): New.
	(SCM_VALIDATE_THREAD, SCM_VALIDATE_MUTEX, SCM_VALIDATE_CONDVAR):
	Use scm_assert_smob_type.
	(scm_c_scm2thread, scm_thread_join, scm_thread_detach,
	scm_thread_self, scm_thread_yield, scm_mutex_init,
	scm_mutex_destroy, scm_mutex_trylock, scm_mutex_unlock,
	scm_rec_mutex_init, scm_rec_mutex_destroy, scm_make_rec_mutex,
	scm_rec_mutex_free, scm_rec_mutex_lock, scm_rec_mutex_trylock,
	scm_cond_init, scm_cond_destroy, scm_cond_wait,
	scm_cond_timedwait, scm_cond_signal, scm_cond_broadcast,
	scm_key_create, scm_key_delete, scm_setspecific, scm_getspecific,
	scm_thread_select): Removed.  Replaced with scm_i_pthread
	functions as appropriate.
	(scm_in_guile, scm_outside_guile): Removed.
	(scm_t_guile_ticket, scm_leave_guile, scm_enter_guile): Return and
	take a ticket.
	(scm_with_guile, scm_without_guile, scm_i_with_guile_and_parent):
	New.
	(scm_i_frame_single_threaded): New.
	(scm_init_threads_default_dynamic_state): New.
	(scm_i_create_thread): Removed.
	(scm_make_fair_mutex, scm_make_fair_condition_variable): Removed.
	(scm_make_recursive_mutex): New.
	(scm_frame_critical_section): New.
	(SCM_CURRENT_THREAD, SCM_I_CURRENT_THREAD): Renamed former to
	latter, changed all uses.
	(scm_i_dynwinds, scm_i_setdynwinds, scm_i_last_debug_frame,
	scm_i_set_last_debug_frame): New, use them instead of scm_root
	stuff.
	(SCM_THREAD_LOCAL_DATA, SCM_SET_THREAD_LOCAL_DATA,
	scm_i_root_state_key,m scm_i_set_thread_data): Removed.
	(scm_pthread_mutex_lock, scm_frame_pthread_mutex_lock,
	scm_pthread_cond_wait, scm_pthread_cond_timedwait).
	(remqueue): Allow the removal of already removed cells.  Indicate
	whether a real removal has happened.
	(scm_thread): Removed, replaced with scm_i_thread.
	(make_thread, init_thread_creatant): Removed.
	(cur_thread): Removed.
	(block_self, unblock_from_queue): New.
	(block, timed_block, unblock): Removed.
	(guilify_self_1, guilify_self_2, do_thread_exit,
	init_thread_key_once, init_thread_key,
	scm_i_init_thread_for_guile, get_thread_stack_base,
	scm_init_guile): New initialisation method.
	(scm_call_with_new_thread, scm_spawn_thread): Use it to simplify
	thread creation.
	(fair_mutex, fat_mutex, etc, fair_condvar, fat_condvar): Renamed
	"fair" to fat and implemented new semantics, including reliable
	interruption.
	(all_threads): Now a pointer to a scm_i_thread, not a SCM.
	(scm_threads_mark_stacks): Explicitly mark handle.
	(scm_std_select): Allow interruption by also selecting on the
	sleep_pipe.
	(scm_i_thread_put_to_sleep): Handle recursive requests for
	single-threadedness.
	(scm_threads_prehistory, scm_init_threads): Put current thread
	into guile mode via guileify_self_1 and guileify_self_2,
	respectively.

	* fluid.h (SCM_FLUIDP): Deprecated.

	* coop-threads.c: Removed.

	* continuations.h, continuations.c (scm_with_continuation_barrier,
	scm_c_with_continuation_barrier, scm_i_with_continuation_barrier):
	New.

	* async.h, async.c (scm_i_setup_sleep, scm_i_reset_sleep): New.
	(async_mutex): New.
	(scm_async_click): Protected with async_mutex.  Do not deal with
	signal_asyncs, which are gone.  Set cdr of handled async cell to
	#f.
	(scm_i_queue_async_cell): Protected with async_mutex.  Interrupt
	current sleep.
	(scm_system_async_mark_for_thread): Do not use scm_current_thread
	since that might not work during early initialization.

	* __scm.h (SCM_DEFER_INTS, SCM_ALLOW_INTS, SCM_REDEFER_INTS,
	SCM_REALLOW_INTS): Deprecated by moving into deprecated.h and
	deprecated.c.  Replaced all uses with SCM_CRITICAL_SECTION_START
	and SCM_CRITICAL_SECTION_END.
	(SCM_ENTER_A_SECTION, SCM_EXIT_A_SECTION): Removed.  Replaced with
	SCM_CRITICAL_SECTION_START/END.

	* Makefile.am (modinclude_HEADER): Removed threads-plugin.h.
	(libguile_la_SOURCES): Added null-threads.c
	(EXTRA_libguile_la_SOURCES): Removed pthread-threads.c and
	threads-plugin.c.
	* pthread-threads.c, threads-plugin.c, threads-plugin.h: Removed.

	* root.h, root.c (scm_tc16_root, SCM_ROOTP, SCM_ROOT_STATE,
	scm_root_state, scm_stack_base, scm_save_regs_gc_mark,
	scm_errjmp_bad, scm_rootcont, scm_dynwinds, scm_progargs,
	scm_last_debug_frame, scm_exitval, scm_cur_inp, scm_outp,
	scm_cur_err, scm_cur_loadp, scm_root, scm_set_root,
	scm_make_root): Removed or deprecated.  Replaced with references
	to the current thread, dynamic state, continuation barrier, or
	some fluid, as appropriate.
	(root_mark, root_print): Removed.
	(scm_internal_cwdr): Reimplemented guts with
	scm_frame_current_dynamic_state and
	scm_i_with_continuation_barrier.
	(scm_dynamic_root): Return current continuation barrier.


2005-02-28  Marius Vollmer  <mvo@zagadka.de>

	* socket.c (scm_setsockopt): Handle IP_ADD_MEMBERSHIP and
	IP_DROP_MEMBERSHIP options.  Also, reorganized the code a bit for
	cleanliness.
	(scm_init_socket): Define IP_ADD_MEMBERSHIP and
	IP_DROP_MEMBERSHIP.
	Thanks to Greg Troxel!

2005-02-27  Mikael Djurfeldt  <djurfeldt@nada.kth.se>

	* gh.h: Bugfix: Include <libguile.h> outside of the extern "C"
	block.

2005-02-25  Marius Vollmer  <mvo@zagadka.de>

	* hashtab.c (scm_i_rehash): Remove elements from old bucket vector
	so that no two weak alist vectors share a spine.
	(scm_hash_fn_create_handle_x): Deal with a possible rehashing
	during GC before inserting the new alist cell.

2005-02-23  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* hashtab.c (scm_i_rehash): Cope with the case that a GC modifies
	the hashtable.
	(scm_hash_fn_create_handle_x): Likewise.
	* vectors.h (SCM_I_SET_WVECT_TYPE): New, for use in scm_i_rehash.

2005-02-10  Mikael Djurfeldt  <djurfeldt@nada.kth.se>

	* unif.c (prototype_to_type): Bugfix: Don't compare prototype to
	the prototypical examples mentioned in the old reference manual.
	Instead keep the old semantics of dispatching on type.  (Yes, this
	is extremely ugly, but the whole point of keeping the deprecated
	interface is not to break old code.)

2005-02-08  Mikael Djurfeldt  <djurfeldt@nada.kth.se>

	* deprecated.h (SCM_ARRAY_DIMS): Rename scm_i_attay_dims -->
	scm_i_array_dims.

2005-01-28  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_ash): Rewrite using shifts, much faster than
	integer-expt and multiply/divide.  Inexacts and fractions no longer
	supported (they happened to work before for left shifts, but not
	right).  Don't really need inexacts and fractions, since ash is
	documented as a "bitwise operation", and all the rest of those only
	take exact integers.

2005-01-27  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* gc-card.c (scm_i_card_statistics): map structs, closures and
	subrs to one tag.

	* gc.c (s_scm_gc_live_object_stats): return alist, not hashtable.
	(tag_table_to_type_alist): ignore unknown types.

	* gc-segment.c (scm_i_all_segments_statistics): new function.
	(scm_i_heap_segment_statistics): new function

	* gc.c (s_scm_gc_live_object_stats): new GUILE callable: return
	statistics on the number of live objects of each type.

	* gc-card.c (scm_i_tag_name):  new function.
	(scm_i_card_statistics): new function.

2005-01-24  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_setlocale): Force errno=EINVAL for an error, since
	POSIX and C99 don't document errno being set.  Reported by Bruno
	Haible.
	(scm_flock): Update docstring from manual.

	* random.c (scm_i_init_rstate): Compare w to -1 not 0xffffffffUL, now
	that it's an scm_t_int32.  Otherwise gcc 3.4 says it's always false on
	a 64-bit system.

	* scmsigs.c (scm_sigaction_for_thread): Use scm_to_long for
	sa_handler, needs to be a long on 64-bit systems where int is only 32
	bits.

2005-01-20  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* environments.c (obarray_enter, obarray_replace): Call
	SCM_HASHTABLE_INCREMENT when adding a new entry.

	* objects.c: Include goops.h for the scm_class_of prototype.

	* hashtab.c (hashtable_size, HASHTABLE_SIZE_N): Restrict hashtable
	sizes to be smaller than the maximum lengths of vectors.

2005-01-18  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* ports.c, smob.c: Include "libguile/goops.h".

	* objects.h, objects.c, goops.c, goops.h (scm_class_boolean,
	scm_class_char, scm_class_pair, scm_class_procedure,
	scm_class_string, scm_class_symbol,
	scm_class_procedure_with_setter, scm_class_primitive_generic,
	scm_class_vector, scm_class_null, scm_class_real,
	scm_class_complex, scm_class_integer, scm_class_fraction,
	scm_class_unknown, scm_port_class, scm_smob_class,
	scm_no_applicable_method, scm_class_of): Moved from objects to
	goops since they are only useable once goops has been loaded.
	(scm_classes_initialized): Removed.
	(scm_class_of): Do not check it.
	(create_standard_classes): Do not set it.

2005-01-17  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* objects.h, objects.c (scm_classes_initialized): New.
	(scm_class_of): Signal error when scm_classes_initialized is zero.
	* goops.c (create_standard_classes): Set scm_classes_initialized
	to one.

	* random.c (scm_random_solid_sphere_x): Use
	scm_c_generalized_vector_length instead of
	scm_uniform_vector_length.

2005-01-16  Marius Vollmer  <mvo@zagadka.de>

	* script.c (scm_compile_shell_switches): Removed debugging output.

2005-01-15  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_logtest, scm_logbit_p, scm_integer_expt): Update
	docstrings from manual.
	* random.c (scm_random_solid_sphere_x): Update docstring from manual.

2005-01-14  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* random.c: Don't check for definedness of SCM_HAVE_T_INT64, check
	its value.

	Implement u64 and s64 uniform numeric vectors with bignums when
	scm_t_uint64 and scm_t_int64 are not available.

	* srfi-4.h, srfi-4.c, srfi-4.i.c (scm_take_u64vector,
	scm_array_handle_u64_elements,
	scm_array_handle_u64_writable_elements, scm_u64vector_elements,
	scm_u64vector_writable_elements): Do not define when scm_t_uint64
	is not available.
	(scm_take_s64vector, scm_array_handle_s64_elements,
	scm_array_handle_s64_writable_elements, scm_s64vector_elements,
	scm_s64vector_writable_elements): Likewise for scm_t_int64.
	(uvec_sizes, uvec_print, uvec_equalp): Use SCM bignums when
	scm_t_int64/scm_t_uint64 are not available.
	(uvec_mark): New, to mark the bignums.
	(alloc_uvec): Initialize bignums.
	(uvec_fast_ref): Return bignums directly.
	(scm_uint64_min, scm_uint64_max, scm_int64_min, scm_int64_max,
	assert_exact_integer): New.
	(uvec_fast_set): Use them to validate the bignums.
	(scm_init_srfi_4): Set mark function of smob when needed.
	Initialize scm_uint64_min, scm_uint64_max, scm_int64_min,
	scm_int64_max.

	Recognize 1.4 -e syntax.

	* script.c (sym_at, sym_atat, sym_main, all_symbols): New.
	(scm_compile_shell_switches): Use them to recognize and convert
	1.4 "-e" syntax.

2005-01-12  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* deprecated.h, deprecated.c, strings.h, strings.c: Turn all
	deprecated features that once were macros but are now functions
	back into macros.

2005-01-11  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* eval.c, debug.h (SCM_WARN_DEPRECATED): New debug option.
	* deprecation.c (scm_issue_deprecation_warning,
	scm_c_issue_deprecation_warning_fmt): Use it.
	(mode): Removed.
	(print_summary): New.
	(scm_init_deprecation): Initialize SCM_WARN_DEPRECATED instead of
	mode.

	Deprecated SCM_ARRAY* macros.

	* unif.h, unif.c, ramap.c, vectors.c, srfi-4.c, srfi-4.i.c
	(SCM_ARRAYP, SCM_I_ARRAYP): Renamed former to latter internal
	version.  Changed all uses.
	(scm_tc16_array, scm_i_tc16_array,
	scm_tc16_enclosed_array, scm_i_tc16_enclosed_array,
	SCM_ARRAY_FLAG_CONTIGUOUS, SCM_I_ARRAY_FLAG_CONTIGUOUS,
	SCM_ENCLOSE_ARRAYP, SCM_I_ENCLOSE_ARRAYP,
	SCM_ARRAY_NDIM, SCM_I_ARRAY_NDIM,
	SCM_ARRAY_CONTP, SCM_I_ARRAY_CONTP,
	SCM_ARRAY_MEM, SCM_I_ARRAY_MEM,
	SCM_ARRAY_V, SCM_I_ARRAY_V,
	SCM_ARRAY_BASE, SCM_I_ARRAY_BASE,
	SCM_ARRAY_DIMS, SCM_I_ARRAY_DIMS,
	scm_t_array, scm_i_t_array): Likewise.
	(SCM_SET_ARRAY_CONTIGUOUS_FLAG, SCM_CLR_ARRAY_CONTIGUOUS_FLAG):
	Moved from unif.h to unif.c.
	(scm_c_array_rank): New.
	(scm_array_rank): Reimplement using it.

	* deprecated.h, deprecated.c (SCM_ARRAYP, SCM_ARRAY_NDIM,
	SCM_ARRAY_CONTP, SCM_ARRAY_MEM, SCM_ARRAY_V, SCM_ARRAY_BASE,
	SCM_ARRAY_DIMS, scm_t_array): New deprecated versions.

2005-01-11  Marius Vollmer  <mvo@zagadka.de>

	* ramap.c: Replace uses of scm_make_ra with scm_i_make_ra.
	(GVREF, GVSET): New abbreviations.  Use them everywhere instead of
	scm_c_generalized_vector_ref and scm_cvref, and
	scm_c_generalized_vector_set_x, respectively.
	(RVREF, IVDEP, BINARY_ELTS_CODE, BINARY_PAIR_ELTS_CODE,
	UNARY_ELTS_CODE, UNARY_PAIR_ELTS_CODE): Removed since unused.

	* unif.h, unif.c (indices_to_pos, scm_array_handle_pos): Renamed
	former to latter and made public.  Changed all uses.
	(scm_i_make_ra): Made public, changed tag param to enclosed flag.
	(scm_make_ra): Deprecated, changed all uses to scm_i_make_ra.
	(scm_i_shap2ra): New internal version of scm_shap2ra.
	(scm_shap2ra): Deprecated, changed all uses to scm_i_shap2ra.
	(scm_i_ra_set_contp): New internal version of scm_ra_set_contp.
	(scm_ra_set_contp): Deprecated, changed all uses to
	scm_i_ra_set_contp.
	(scm_cvref, scm_aind, scm_raprin1): Deprecated.

2005-01-10  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* eval.c (scm_eval): Added example to docstring.  Thanks to Issac
	Trotts!

	* unif.c (scm_list_to_typed_array): Allow the specification of the
	upper bound as well.  This is needed for empty arrays.
	(l2ra): Give needed number of elements in error message.
	(scm_i_print_array): Print length information for arrays that need
	it.
	(scm_i_read_array): Parse it.

	* deprecated.h, deprecated.c (SCM_CHARS, SCM_UCHARS, SCM_LENGTH,
	scm_i_object_chars, scm_i_object_length): Brought back from the
	dead.

2005-01-10  Marius Vollmer  <mvo@zagadka.de>

	* ramap.c: Replaced single-index uses of scm_array_set_x with
	scm_c_generalized_vector_set_x.

	* unif.c (scm_array_rank, scm_array_dimensions,
	scm_shared_array_offset, scm_shared_array_increments,
	scm_array_ref, scm_array_set_x): Use scm_t_array_handle operations
	to simplify code and make it more general.
	(scm_shared_array_root): Work with all kinds of arrays, including
	naked vectors.
	(indices_to_pos): New.
	(scm_make_shared_array): Use it instead of scm_aind; use handle
	for oldra.

2005-01-10  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_mkstemp): Update docstring from manual.

	* stime.c (scm_mktime): Missing default errno=EINVAL from prev change.

2005-01-09  Marius Vollmer  <mvo@zagadka.de>

	* srfi-4.h, srfi-4.c, srfi-4.i.c (scm_i_uniform_vector_ref_proc,
	scm_i_uniform_vector_set_proc): New.
	(u8ref, u8set, s8ref, s8set, etc): New.
	(uvec_reffers, uvec_setters): New.
	(uvec_to_list): Use generic scm_array_handle_ref instead of
	uvec_fast_ref since scm_array_handle_ref should be faster now.
	(coerce_to_uvec, scm_c_uniform_vector_ref,
	scm_c_uniform_vector_set_x): Likewise.

	* unif.h, unif.c, inline.h (scm_i_t_array_ref, scm_i_t_array_set):
	New.
	(scm_t_array_handle): Added ref, set, elements and
	writable_elements for fast inline operation of
	scm_array_handle_ref and scm_array_handle_set.
	(scm_array_handle_ref, scm_array_handle_set): Moved to inline.h
	and replaced with inline code that simply calls the ref/set
	members of the handle.
	(enclosed_ref, vector_ref, string_ref, bitvector_ref, memoize_ref,
	enclosed_set, vector_set, string_set, bitvector_set, memoize_set):
	New.
	(scm_array_handle_get): Initialize ref/set fields to memoize_ref
	and memoize_set.
	(scm_bitvector_fill_x, scm_bitvector_to_list, scm_bit_count,
	scm_bit_position, scm_bit_set_star_x, scm_bit_count_star,
	scm_bit_invert_x): Correctly multiply index with increment in the
	general case.

	* unif.c (scm_array_handle_set): Correctly execute only one
	alternative.  D'Oh!
	(scm_list_to_typed_array, l2ra): Use scm_t_array_handle to fill
	the array; this covers all cases with much simpler code.

	* srfi-4.c (scm_uniform_element_size): Deprecated implementation
	as well.

2005-01-09  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* srfi-4.c (uvec_type): New.
	(uvec_to_list, uvec_ref, uvec_set_x, scm_c_uniform_vector_ref,
	scm_c_uniform_vector_x): Use it to get concrete type.

	* unif.h (scm_t_array_dim): Changed type of members to ssize_t, to
	fit the docs.

	* unif.c (ra2l): Handle zero rank arrays.
	(scm_i_print_array): Print zero rank arrays specially.
	(tag_to_type): Return #t for an empty tag, not the empty symbol.
	(scm_i_read_array): Allow zero rank arrays.

2005-01-07  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* hashtab.h, hashtab.c (SCM_HASHTAB_BUCKET_LOC): Removed.
	(scan_weak_hashtables): Rewrote its use with SCM_HASHTAB_BUCKET
	and SCM_SET_HASHTAB_BUCKET.

	* print.h, print.c (scm_print_state, SCM_PRINT_STATE_LAYOUT):
	Removed ref_stack field.
	(PSTATE_STACK_REF, PSTATE_STACK_SET): New, for accessing the stack
	of a print state.  Use them everywhere instead of ref_stack.

	* srfi-4.h (scm_uniform_element_size): Deprecated for real.

	* srfi-4.c: Include deprecation.h.

	* vectors.h, vectors.c, unif.h, unif.c, deprecated.h,
	deprecated.c, eq.c
	(SCM_BITVEC_REF, SCM_BITVEC_SET, SCM_BITVEC_CLR): Removed.
	(scm_vector_elements, scm_vector_writable_elements,
	scm_generalized_vector_get_handle): Moved to vectors.[hc] from
	unif.[hc].
	(SCM_SIMPLE_VECTOR_LOC): Removed.
	(SCM_VECTOR_MAX_LENGTH, SCM_VECTOR_LENGTH, SCM_VELTS,
	SCM_WRITABLE_VELTS, SCM_VECTOR_REF, SCM_VECTOR_SET,
	scm_vector_equal_p): Moved from vectors.[hc] to deprecated.[hc].
	(scm_vector_equal_p, scm_i_vector_equal_p): Renamed former to
	latter.  Changed use in eq.c.

2005-01-07  Marius Vollmer  <mvo@zagadka.de>

	Make the uniform vector routines also deal with one dimensional
	arrays.

	* srfi-4.c (SCM_IS_UVEC): New, use it instead of
	SCM_SMOB_PREDICATE in this file.
	(is_uvec): Also recognize one-dimensional uniform numeric arrays
	of the right type.
	(scm_is_uniform_vector): Likewise.
	(uvec_fast_ref): Made BASE param const.
	(uvec_writable_elements, uvec_elements): New.
	(uvec_to_list, uvec_ref, uvec_set_x, uvec_length,
	scm_c_uniform_vector_length, scm_c_uniform_vector_ref,
	scm_c_uniform_set_x): Use them to also deal with one-dimensional
	arrays.
	(scm_uniform_vector_ref, scm_uniform_vector_set_x): Deprecate old
	argument convention.
	(scm_uniform_vector_to_list): Let uvec_to_list do all the
	checking.
	(scm_uniform_vector_length): Use uvec_length.

2005-01-06  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* srfi-4.h, srfi-4.c (scm_c_uniform_vector_element_size,
	scm_c_uniform_vector_size): Removed.
	(scm_array_handle_uniform_element_size): New.


	* unif.h (scm_array_handle_ref, scm_array_handle_set): Changed
	type of POS parameter to be signed, positions can be negative.
	(scm_array_handle_release): New, changed all uses of
	scm_t_array_handle to properly call it.
	(scm_vector_get_handle, scm_generalized_vector_get_handle):
	Renamed former to latter, changed all uses.

2005-01-05  Marius Vollmer  <mvo@zagadka.de>

	Updated bitvector routines to also use scm_t_array_handles.

	* unif.h (scm_bitvector_elements,
	scm_bitvector_writable_elements): Use a scm_t_array_handle and
	deliver offset, length and increment to caller.  Changed all uses.
	(scm_bitvector_release_elements,
	scm_frame_bitvector_release_elements,
	scm_bitvector_release_writable_elements,
	scm_frame_bitvector_release_writable_elements): Removed.
	(scm_array_handle_bit_elements,
	scm_array_handle_bit_writable_elements,
	scm_array_handle_bit_elements_offset): New.
	(scm_make_typed_array): The special value for non-initialized
	arrays is now SCM_UNSPECIFIED.  The old special value SCM_BOOL_F
	was a valid value to fill bitvectors with, so it can't really be
	specialed out.

2005-01-04  Kevin Ryde  <user42@zip.com.au>

	* stime.c (scm_strftime): Free t.tm_zone produced by bdtime2c.
	Reported by Bill Schottstaedt.

2005-01-02  Marius Vollmer  <mvo@zagadka.de>

	* sort.c (quicksort): Added INC parameter for non-contigous
	vectors.
	(quicksort1): New, for contigous vectors.  Both functions are
	generated from the same code by including "quicksort.i.c".
	(scm_restricted_vector_sort_x): Call one of quicksort and
	quicksort1, depending on increment of vector.
	(scm_sort): Simply call scm_sort_x on a copy of the list or
	vector.
	(scm_merge_vector_x, scm_merge_vector_step): Changed indices to
	size_t, added inc parameter.
	(scm_stable_sort_x): Allocate temporary storage as Scheme vector
	so that it doesn't leak.
	(scm_stable_sort): Simply call scm_stable_sort_x on a copy of the
	list or vector.

	* ramap.c (scm_array_map_x): Do not try to convert fill value
	before filling, any necessary conversion is done while storing.

	* gc-card.c (scm_i_sweep_card): Call scm_i_vector_free instead of
	doing it inline.

	* hashtab.c, hashtab.h (SCM_HASHTABLE_BUCKETS): Removed.
	(SCM_HASHTABLE_BUCKET, SCM_HASHTABLE_BUCKET_LOC): New.  Replaced
	all uses of SCM_HASHTABLE_BUCKETS with SCM_HASHTABLE_BUCKET.

	* tags.h, weaks.c, vports.c, hashtab.c, convert.c, sort.c,
	convert.c, convert.h, convert.i.c, deprecated.c, environments.c,
	eval.c, filesys.c, fluids.c, gc-mark.c, gh.h, gh_data.c, goops.c,
	hash.c, init.c, libguile_la-arrays.loT, modules.c, net_db.c,
	objects.c, ports.c, posix.c, print.c, random.c, read.c,
	regex-posix.c, scmsigs.c, socket.c, stime.c, symbols.c: Use new
	vector elements API or simple vector API, as appropriate.  Removed
	SCM_HAVE_ARRAYS ifdefery.  Replaced all uses of
	SCM_HASHTABLE_BUCKETS with SCM_HASHTABLE_BUCKET.

	* srfi-4.h, srfi-4.c,
	srfi-4.i.c (scm_array_handle_uniform_elements,
	scm_array_handle_uniform_writable_elements,
	scm_uniform_vector_elements,
	scm_uniform_vector_writable_elements):
	(scm_<foo>vector_elements, scm_<foo>vector_writable_elements): Use
	scm_t_array_handle, deliver length and increment.
	(scm_array_handle_<foo>_elements,
	scm_array_handle_<foo>_writable_elements): New.

	* gen-scmconfig.h.in (SCM_I_GSC_HAVE_ARRAYS): Removed.
	* gen-scmconfig.c: Hard code SCM_HAVE_ARRAYS to "1".

	* unif.h, unif.c (scm_t_array_handle, scm_array_get_handle,
	scm_array_handle_rank, scm_array_handle_dims, scm_array_handle_ref
	scm_array_handle_set, scm_array_handle_elements
	scm_array_handle_writable_elements, scm_vector_get_handle): New.
	(scm_make_uve, scm_array_prototype, scm_list_to_uniform_array,
	scm_dimensions_to_uniform_array): Deprecated for real.
	(scm_array_p, scm_i_array_p): Use latter for SCM_DEFINE since
	snarfing wont allow a mismatch between C and Scheme arglists.
	(scm_make_shared_array, scm_enclose_array): Correctly use
	scm_c_generalized_vector_length instead of
	scm_uniform_vector_length.

	* validate.h (SCM_VALIDATE_VECTOR,
	SCM_VALIDATE_VECTOR_OR_DVECTOR): use scm_is_simple_vector instead
	of SCM_VECTORP.

	* weaks.h, weaks.c: Use new internal weak vector API from
	vectors.h.

	* Makefile.am (libguile_la_SOURCES, DOT_X_FILES, DOT_DOC_FILES,
	EXTRA_libguile_la_SOURCES): Changed ramap.c and unif.c from being
	'extra' to being regular sources.
	(noinst_HEADERS): Added quicksort.i.c.
	* quicksort.i.c: New file.

	* vectors.h, vector.c (SCM_VECTORP, SCM_VECTOR_LENGTH, SCM_VELTS,
	SCM_WRITABLE_VELTS, SCM_VECTOR_REF, SCM_VECTOR_SET): Deprecated
	and reimplemented.  Replaced all uses with scm_vector_elements,
	scm_vector_writable_elements, or SCM_SIMPLE_VECTOR_*, as
	appropriate.
	(scm_is_simple_vector, SCM_SIMPLE_VECTOR_LENGTH,
	SCM_SIMPLE_VECTOR_REF, SCM_SIMPLE_VECTOR_SET,
	SCM_SIMPLE_VECTOR_LOC): New.
	(SCM_VECTOR_BASE, SCM_SET_VECTOR_BASE, SCM_VECTOR_MAX_LENGTH,
	SCM_MAKE_VECTOR_TAG, SCM_SET_VECTOR_LENGTH,
	SCM_VELTS_AS_STACKITEMS, SCM_SETVELTS, SCM_GC_WRITABLE_VELTS):
	Removed.
	(scm_vector_copy): New.
	(scm_vector_elements, scm_vector_writable_elements): Use
	scm_t_array_handle, deliver length and increment.  Moved to
	unif.h. Changed all uses.
	(scm_vector_release_elements,
	scm_vector_release_writable_elements,
	(scm_frame_vector_release_elements,
	scm_frame_vector_release_writable_elements): Removed.
	(SCM_I_IS_VECTOR, SCM_I_VECTOR_ELTS, SCM_I_VECTOR_WELTS,
	SCM_I_VECTOR_LENGTH, scm_i_vector_free): New internal API.
	(SCM_I_WVECTP SCM_I_WVECT_LENGTH SCM_I_WVECT_VELTS
	SCM_I_WVECT_GC_WVELTS SCM_I_WVECT_TYPE SCM_I_WVECT_GC_CHAIN
	SCM_I_SET_WVECT_GC_CHAIN, scm_i_allocate_weak_vector): New, for
	weak vectors.

2004-12-29  Marius Vollmer  <mvo@zagadka.de>

	No longer use creators to specify the type of an array.  Creators
	expose the fact that arrays are wrapped around vectors, but that
	might change.

	* srfi-4.h (scm_i_proc_make_u8vector, scm_i_proc_make_s8vector,
	scm_i_proc_make_u16vector, scm_i_proc_make_s16vector,
	scm_i_proc_make_u32vector, scm_i_proc_make_s32vector,
	scm_i_proc_make_u64vector, scm_i_proc_make_s64vector,
	scm_i_proc_make_f32vector, scm_i_proc_make_f64vector,
	scm_i_proc_make_c32vector, scm_i_proc_make_c64vector,
	uvec_proc_vars): Removed.
	(scm_i_generalized_vector_creator): Removed.
	(scm_i_generalized_vector_type): New.

	* unif.h, unif.c (scm_typed_array_p, scm_make_array,
	scm_make_typed_array, scm_array_type, scm_list_to_array,
	scm_list_to_typed_array, scm_is_array, scm_is_typed_array): New.
	(scm_array_creator): Removed.
	(scm_array_p): Deprecated second PROT argument.
	(scm_dimensions_to_uniform_array, scm_list_to_uniform_array):
	Deprecated, reimplemented in terms of scm_make_typed_array and
	scm_list_to_typed_array.
	(scm_i_proc_make_vector, scm_i_proc_make_string,
	scm_i_proc_make_bitvector): Removed.
	(type_creator_table, init_type_creator_table, type_to_creator,
	make_typed_vector): New.
	(scm_i_convert_old_prototype): Removed.
	(prototype_to_type): New.
	(scm_make_uve): Deprecated, reimplemented using make_typed_vector.
	(scm_array_dimensions): Use scm_list_1 instead of scm_cons for
	minor added clarity.
	(scm_make_shared_array, scm_ra2contig): Use make_typed_vector
	instead of scm_make_uve.
	(tag_creator_table, scm_i_tag_to_creator): Removed.
	(tag_to_type): New.
	(scm_i_read_array): Use scm_list_to_typed_array instead of
	scm_list_to_uniform_array.

2004-12-27  Marius Vollmer  <mvo@zagadka.de>

	* unif.h, unif.c (scm_bitvector_elements): Made return value "const".
	(scm_bitvector_writable_elements): New.
	(scm_bitvector_release, scm_bitvector_release_elements):
	Renamed former to latter.  Added explicit call to
	scm_remember_upto_here_1.
	(scm_frame_bitvector_release,
	scm_frame_bitvector_release_elements): Renamed former to latter.
	(scm_bitvector_release_writable_elements,
	scm_bitvector_release_writable_elements): New.
	Changed all uses as required by the changes above.

	* srfi-4.h, srfi-4.c, srfi-4.i.c (scm_uniform_vector_elements,
	scm_u8vector_elements, etc): Made return value "const".
	(scm_uniform_vector_writable_elements,
	scm_u8vector_writable_elements, etc): New.
	(scm_uniform_vector_release, scm_uniform_vector_release_elements):
	Renamed former to latter.  Added explicit call to
	scm_remember_upto_here_1.
	(scm_frame_uniform_vector_release,
	scm_frame_uniform_vector_release_elements): Renamed former to latter.
	(scm_uniform_vector_release_writable_elements,
	scm_frame_uniform_vector_release_writable_elements): New. Takes
	crown of longest identifier yet.
	Changed all uses as required by the changes above.

	* vectors.h, vectors.c (scm_c_vector_set_x): Make return type
	void.
	(scm_is_vector, scm_vector_p, scm_vector_length,
	scm_c_vector_length, scm_vector_ref, scm_c_vector_ref,
	scm_vector_set_x, scm_c_vector_set_x, scm_vector_to_list,
	scm_vector_move_left_x, scm_vector_move_right_x,
	scm_vector_fill_x): handle one-dimensional arrays.
	(scm_vector_elements, scm_vector_release_elements,
	scm_vector_frame_release_elements, scm_vector_writable_elements,
	scm_vector_release_writable_elements,
	scm_vector_frame_release_writable_elements): New.
	(scm_list_to_vector, scm_vector_to_list, scm_vector_fill,
	scm_vector_move_left_x, scm_vector_move_right_x): Use them.

	* ramap.c (scm_ramapc, scm_raeql): Use
	scm_c_generalized_vector_length instead of
	scm_uniform_vector_length.
	(scm_ramap, rafe): Use scm_c_vector_ref instead of SCM_VELTS.  use
	scm_c_generalized_vector_ref instead of scm_uniform_vector_ref.

2004-12-23  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* continuations.h, continuations.c (scm_t_contregs): New 'offset'
	member for relocating debug frames.
	(scm_make_continuation): Set it.

	* stacks.c (read_frame, read_frames, scm_make_stack,
	scm_last_stack_frame, scm_stack_id): Use the new 'offset' member
	of continuations instead of calculating the offset ourselves.
	Relocate 'vect' member of scm_t_debug_frame.

2004-12-16  Kevin Ryde  <user42@zip.com.au>

	* ramap.c (scm_array_map_x): Check for at least one source argument.

2004-12-14  Kevin Ryde  <user42@zip.com.au>

	* srfi-13.c (string-any, string-every): Use a scheme wrapper around
	the C code so for the final call to the predicate procedure is a tail
	call, per SRFI-13 spec.

2004-12-10  Kevin Ryde  <user42@zip.com.au>

	* eq.c (scm_eq_p, scm_eqv_p, scm_equal_p): Update docstrings from
	recent revision to the reference manual.

	* numbers.c (scm_modulo): Amend fixme comment about negative divisor
	with "%", C99 says it's well-defined.

	* socket.c (scm_from_ipv6): Just use mpz_import.  Don't bother trying
	to fit scm_from_ulong_long, since that uses mpz_import anyway.  Don't
	bother trying to fit scm_from_ulong, not really worth the trouble if
	addresses are more than 4 bytes usually.

2004-11-30  Kevin Ryde  <user42@zip.com.au>

	* gc_os_dep.c (NetBSD): Test __m68k__ and __arm__ as well as m68k and
	arm32.  Reported by Greg Troxel.

2004-11-14  mvo  <mvo@zagadka.de>

	* unif.c, unif.h (scm_i_cvref): Made non-static for ramap.c.

	* Makefile.am (INCLUDES): It is "@LTDLINCL@", not "@LTDLINC@".

2004-11-12  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	Enclosed arrays are now their own smob.  This has been done to
	make the code more explicit about them and to prepare for the time
	when generalized vectors include arbitrary one-dimensional
	arrays. (Uptonow, enclosed arrays have been recognized by their
	use of an array as their storage 'vector'.  When all generalized
	vectors are allowed as storage, including one-dimensional arrays,
	this will no longer work.)

	* unif.h, unif.c: (scm_tc16_enclosed_array, SCM_ENCLOSED_ARRAYP):
	New.
	(exactly_one_third, singp): Removed.
	(scm_array_p, scm_array_dimensions, scm_shared_array_root,
	scm_shared_array_offset, scm_shared_array_increments): Handle
	enclosed arrays explicitely.
	(scm_array_rank): Likewise. Also, do not return zero for
	non-arrays, signal an error instead since arrays with rank zero do
	exist.
	(scm_i_make_ra): New, for specifying the tag of the new array.
	(scm_make_enclosed_array): Use it.
	(scm_make_ra): Reimplemented in terms of scm_i_make_ra.
	(scm_make_shared_array): Use scm_c_generalized_vector_length
	instead of scm_uniform_vector_length.
	(scm_array_in_bounds_p): Rewritten to be much cleaner.
	(scm_i_cvref): New, doing the job of scm_cvref.
	(scm_cvref): Use scm_i_cvref.
	(scm_array_ref): Do not accept non-arrays when no indices are
	given. Use scm_i_cvref to do the actual access.
	("uniform-array-set1"): Do not register.
	(scm_array_set_x, scm_uniform_array_read_x,
	scm_uniform_array_write): Handle enclosed arrays explicitly.
	(ra2l): Use scm_i_cvref instead of scm_uniform_vector_ref to also
	handle enclosed arrays.
	(scm_array_to_list): Handle enclosed arrays explicitly.
	(rapr1): Removed.
	(scm_i_print_array_dimension): Use scm_i_cvref to also handle
	enclosed arrays.
	(scm_i_print_enclosed_array): New.
	(tag_proto_table, tag_creator_table): Renamed former to latter.
	Added "a" and "b" for strings and bitvectors, resp.
	(scm_i_tag_to_prototype, scm_i_tag_to_creator): Renamed former to
	latter.  Tag "a" is in the table now, no need to handle it as a
	legacy tag.
	(scm_raprin1): Just call scm_iprin1.
	(scm_array_creator, scm_array_prototype): Handle enclosed arrays
	explicitly.
	(scm_init_unif): Initialize scm_tc16_enclosed_array smob.
	Use scm_i_print_array as printer for scm_tc16_array.

2004-11-10  Marius Vollmer  <mvo@zagadka.de>

	* ramap.c (cind): Changed second arg to be pointer to long instead
	of uniform vector.
	(scm_ramapc): Allocate index vector with scm_malloc and not as
	uniform vector.  Wrap it in a frame so that it gets properly freed.
	(scm_array_index_map_x): Likewise.

	* unif.c: Changed all uses of scm_array_prototype to
	scm_array_creator. (scm_i_get_old_prototype): Signal error when no
	prototype is known.
	(scm_uniform_array_read_x, scm_uniform_array_write): Reimplemented
	in terms of scm_uniform_vector_read_x and
	scm_uniform_vector_write, respectively.  Strings and
	bitvector support has been dropped.

	* srfi-4.h, srfi-4.c: Do not include <libguile.h>, include the
	needed files directly.  Include config.h, <unistd.h> and <io.h>
	when available.
	(scm_uniform_vector_read_x, scm_uniform_vector_write): New.

2004-11-09  Marius Vollmer  <mvo@zagadka.de>

	* gh_data.c (gh_uniform_vector_length): Properly use
	scm_c_uniform_vector_length instead of scm_uniform_vector_length.

2004-11-09  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* srfi-4.h (scm_c_uniform_vector_ref, scm_c_uniform_vector_set_x):
	New.
	(scm_i_uniform_vector_creator): Removed.
	(scm_i_generalized_vector_creator): New.
	(scm_uniform_vector_length, scm_uniform_element_size): Do not
	handle generalized vectors, only uniform numeric vectors.
	(alloc_uvec): Do length check here...
	(make_uvec): ...but not here.
	(coerce_to_uvec): Use new generalized vector functions to handle
	all kinds of vectors in one go.

	* tags.h (scm_tc7_bvect): Renamed to scm_tc7_unused7, renaming the
	remaining scm_tc7_unused tags to get a neatly ordered list.

	* eq.c, evalext.c, gc-card.c, gc-mark.c, objects.c, print.c: Do no
	longer handle scm_tc7_bvect bitvectors.

	* ramap.c: Use the new generalized vector functions to handle all
	vector like things.

	* vectors.h, vectors.c (scm_is_vector, scm_c_vector_length,
	scm_c_vector_ref, scm_c_vector_set_x, scm_generalized_vector_p,
	scm_generalized_vector_length, scm_generalized_vector_ref,
	scm_generalized_vector_set_x, scm_generalized_vector_to_list,
	scm_is_generalized_vector, scm_c_generalized_vector_length,
	scm_c_generalized_vector_ref, scm_c_generalized_vector_set_x):
	New.

	* unif.h, unif.c (scm_bitvector_p, scm_bitvector,
	scm_make_bitvector, scm_bitvector_length, scm_bitvector_ref,
	scm_bitvector_set_x, scm_list_to_bitvector, scm_bitvector_to_list,
	scm_bitvector_fill_x, scm_is_bitvector, scm_c_make_bitvector,
	scm_c_bitvector_length, scm_c_bitvector_ref,
	scm_c_bitvector_set_x, scm_bitvector_elements,
	scm_bitvector_release, scm_frame_bitvector_release,
	scm_tc16_bitvector, bitvector_free, bitvector_print,
	bitvector_equalp, count_ones, find_first_one): New.
	(scm_bit_count, scm_bit_position, scm_bit_set_star_x,
	scm_bit_count_star, scm_bit_invert_x, scm_istr2bve): Rewritten
	using the new C API for bitvectors and maybe count_ones or
	find_first_one, as appropriate.
	(SCM_I_MAX_LENGTH, SCM_BITVECTOR_P, SCM_BITVECTOR_BASE,
	SCM_SET_BITVECTOR_BASE, SCM_BITVECTOR_MAX_LENGTH,
	SCM_BITVECTOR_LENGTH, SCM_MAKE_BITVECTOR_TAG,
	SCM_SET_BITVECTOR_LENGTH): Removed.  Replaced all uses with the
	new functions from above.
	(scm_i_proc_make_vector, scm_i_proc_make_string,
	scm_i_proc_make_bitvector): Made non-static for use in
	scm_i_generalized_vector_creator.
	(scm_make_u1vector): Removed, replaced by scm_make_bitvector.
	(scm_make_uve): Validate that the created object is a generalized
	vector.
	(scm_i_legacy_tag): Removed.
	(scm_i_print_array): Do it here.
	(scm_raprin1): Only print enclosed arrays.

	* Makefile.am (DOT_DOC_FILES): Added srfi-4.doc.

2004-11-04  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* srfi-4.c (make_uvec): Use SCM_I_SIZE_MAX instead of SIZE_MAX for
	added portability.

	* chars.c (scm_charnames, scm_charnums): Added "sp" as an alias
	for "space".  Thanks to Bruce Korb!

	* rw.c (scm_read_string_x_partial): Bugfix, apply offset to dest
	only after dest has been set.  Thanks to Hyper Division!

	* gh_data.c (gh_uniform_vector_length): Use
	scm_uniform_vector_length instead of SCM_UVECTOR_LENGTH.

2004-11-03  Marius Vollmer  <mvo@zagadka.de>

	* unif.h (SCM_UVECTOR_BASE, SCM_SET_UVECTOR_BASE,
	SCM_UVECTOR_MAXLENGTH, SCM_UVECTOR_LENGTH, SCM_MAKE_UVECTOR_TAG,
	SCM_SET_UVECTOR_LENGTH): Removed.

2004-11-02  Marius Vollmer  <mvo@zagadka.de>

        Mac OS X and OpenBSD compatibility patches from Andreas Vögele.
	Thanks!

	* backtrace.c (scm_display_backtrace_with_highlights): Join the
	first and the second line of the SCM_DEFINE macro call, since old
	preprocessors cannot handle definitions that are split into two
	lines.

	* inline.h (scm_cell, scm_double_cell): Don't use C99 variable
	declarations.

	* pairs.c (scm_i_chase_pairs): Replace scm_t_bits with
	scm_t_uint32 to fix the mismatch between the function declaration
	and definition.

	* sort.c (quicksort): Don't use C99 variable declarations.

	* srfi-4.c (uvec_fast_ref): Avoid a compiler warning by returning
	SCM_BOOL_F if no type matches.

	* threads.c (thread_print): Cast a pointer to size_t when printing
	with scm_uintprint.

	* unif.c (scm_i_tag_to_prototype): Make sure that "instead" gets
	defined.
	(scm_array_prototype): Deprecated.

2004-11-02  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* srfi-4.h, srfi-4.c (scm_frame_uniform_vector_release): New.
	* unif.c (scm_bit_set_star_x, scm_bit_count_star_x): Use it to get
	more efficient access to the u32vector.

	* tags.h (scm_tc7_llvect, scm_tc7_uvect, scm_tc7_fvect,
	scm_tc7_dvect, scm_tc7_cvect, scm_tc7_svect, scm_tc7_byvect,
	scm_tc7_ivect): Renamed to scm_tc7_unused_1 to scm_tc7_unused_8.

	* validate.h (SCM_VALIDATE_VECTOR_OR_DVECTOR): Accept f64vectors
	instead of the old-style dvectors.

	* gh_data.c: Use new-style uniform arrays in place of old-style
	ones.

	* eq.c, evalext.c, gc-card.c, gc-mark.c, objects.c, print.c,
	ramap.c, unif.c: Do no longer handle old-style uniform vectors.

	* unif.c (scm_bit_set_star_x, scm_bit_count_star_x): Use u32vectors
	instead of old-sytle uvectors.

	* convert.c, convert.i.c: Rewritten completely, using
	scm_any_to_u8vector, etc and other new-style uniform vector
	functions.

	* random.c (scm_random_solid_sphere_x,
	scm_random_hollow_sphere_x): Do not validate vector argument, this
	is already done elsewhere.

	* srfi-4.h, srfi-4.i.c, srfi-4.c (coerce_to_uvec,
	scm_any_to_u8vector, etc): New.
	(scm_uniform_element_size, scm_uniform_vector_length): Do no
	longer handle old-style uniform vectors.

	* read.c (scm_lreadr): Bugfix: include the last bit in the
	bit vector.

2004-10-29  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* unif.h, unif.c (scm_array_creator): New.
	(scm_i_get_old_prototype): New.
	(scm_array_prototype): use it to return old-style prototype, never
	return creators.
	(scm_make_uve): Use scm_call_1 instead of scm_call_2 with a second
	arg of SCM_UNDEFINED.  The latter is wrong.

	* unif.h, unif.c (scm_make_u1vector): New, but only temporary.
	(make_uve): Removed.
	(scm_i_proc_make_vector, scm_i_proc_make_string,
	scm_i_proc_make_u1vector): New.
	(scm_init_unif): Initialize them.
	(scm_i_convert_old_prototype): New.
	(scm_make_uve): Use it to get the creator procedure.  Removed all
	old code that created old-style uniform vectors.
	(scm_array_p): Handle generic vectors.
	(scm_dimensions_to_uniform_array): Do not fill new array with
	prototype when that is a procedure.
	(scm_list_to_uniform_array): Also accept a list of lower bounds as
	the NDIM argument.
	(scm_i_print_array): Print rank for shared or non-zero-origin
	vectors.
	(tag_proto_table, scm_i_tag_to_prototype, scm_i_read_array): New.
	(scm_raprin1): Do not call scm_i_array_print for enclosed arrays,
	which I do not understand yet.
	(scm_array_prototype): Explicitely handle generic vectors.

	* numbers.c, number.h (scm_i_print_complex, icmplx2str): New.
	(iflo2str): Use icmplx2str for complex numbers.

	* srfi-4.c, srfi-4.h (scm_i_read_homogenous_vector,
	scm_i_uniform_vector_prototype): Removed.
	(scm_i_uniform_vector_creator): New.
	(SCM_UVEC_C32, scm_c32vector, scm_make_c32vector, etc,
	SCM_UVEC_C64, scm_c64vector, scm_make_c64vector, etc): New.
	Updated all tables and generic functions to support them.
	(scm_i_proc_make_u8vector, scm_i_proc_make_s8vector, etc): New.
	(scm_init_srfi_4): Initialize them.

	* srfi-4.i.c (scm_take_u8vector, etc): use uvec_sizes instead of
	sizeof(CTYPE) as explained in the comment.

	* read.c (scm_lreadr): Call scm_i_read_array for all characters
	following '#' that can start an array.  Explicitely disambiguate
	'i' and 'e' between introducing numbers and uniform vectors.  Do
	not call scm_i_read_homogenous_vector, since that is also handled
	by scm_i_read_array now.

2004-10-27  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	First cut at integrating uniform vectors from srfi-4 with the rest
	of Guile.  This change replaces scm_tc7_byvect with a s8 uniform
	vector.  The plan is to gradually replace one type after the other
	until none is left and then to consider general cleanups and
	optimizations.

	* srfi-4.h, srfi-4.i.c (scm_u8vector_elements, etc): New.

	* srfi-4.h, srfi-4.c (scm_uniform_vector_p,
	scm_uniform_vector_ref, scm_uniform_vector_set_x,
	scm_uniform_vector_to_list, scm_is_uniform_vector,
	scm_c_uniform_vector_lengths, scm_c_uniform_vector_size,
	scm_uniform_vector_elements, scm_uniform_vector_element_size,
	scm_uniform_vector_release): New.
	(scm_i_uniform_vector_prototype, scm_i_uniform_vector_tag): New.
	(scm_uniform_element_size, scm_uniform_vector_length): Moved here
	from unif.h, unif.c and extended to handle both the old and new
	uniform vectors.

	* tags.h (scm_tc7_byvect): Commented out.

	* unif.h, unif.c (scm_uniform_vector_ref, scm_array_ref): Renamed
	the former to the latter.
	(scm_uniform_vector_length, scm_uniform_element_size): Moved to
	srfi-4.h, srfi-4.c.
	(scm_make_uve): Call scm_make_s8vector for #\nul prototype.
	(scm_array_p, scm_array_rank, scm_array_dimensions,
	scm_transpose_array, scm_enclose_array, scm_array_ref, scm_cvref,
	scm_array_set_x, scm_array_contents, scm_uniform_array_read_x,
	scm_array_to_list, scm_array_prototype): Handle srfi-4 uniform
	vectors.  Removed code for scm_tc7_byvect.
	(scm_dimensions_to_uniform_array): Fill array with 0 when
	prototype is #\nul.
	(scm_i_print_array_dimension, scm_i_legacy_tag,
	scm_i_print_array): New.
	(scm_raprin1): Call scm_i_print_array for arrays.  Removed code
	for scm_tc7_byvect.

	* ramap.c (scm_ra_matchp, scm_array_fill_int, racp,
	scm_array_index_map_x, raeql_1, scm_array_equal_p): Handle srfi-4
	uniform vectors.  Removed code for scm_tc7_byvect

	* print.c (iprin1): Removed code for scm_tc7_byvect.
	* objects.c (scm_class_of): Likewise.
	* gc-mark.c (scm_gc_mark_dependencies): Likewise.
	* gc-card.c (scm_i_sweep_card): Likewise.
	* evalext.c (scm_self_evaluating_p): Likewise.
	* eq.c (scm_equal_p): Likewise.

	* gh_data.c (gh_chars2byvect): Reimplemented with
	scm_make_s8vector.
	(gh_scm2chars): Handle s8vectors, removed code for scm_tc7_byvect.

	* srfi-4.c (take_uvec): New.
	(alloc_uvec): Use it.
	* srfi-4.h, srfi-4.i.c (scm_take_u8vector, etc): New.

	* random.c (vector_scale, vector_scale_x): Renamed former to the
	latter, since it modifies its argument.
	(vector_scale_x, vector_sum_squares, scm_random_normal_vector_x):
	Do not use scm_universal_vector_length for non-uniform vectors.
	Use scm_f64vector_elements to access innards of uniform vectors.

	* convert.i.c: Convert srfi-4 style uniform vectors when
	requested.
	* convert.c (scm_c_scm2chars, scm_c_chars2scm,
	scm_c_chars2byvect): Use a s8vector instead of a scm_tc7_byvect.

2004-10-26  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* numbers.h, numbers.c (scm_i_print_double): New.

	* srfi-4.c, srfi-4.h, srfi-4.i.c: New files, initially from
	../srfi/ but heavily modified.
	* Makefile.am: Add them in all the right places.
	* init.c (scm_init_guile_1): Call scm_init_srfi_4.
	* read.c (scm_lreadr): Call scm_i_read_homogenous_vector for '#f',
	'#u', and '#s'.

	* read.h, read.c (scm_i_input_error): Renamed from scm_input_error
	and made non-static.  Changed all uses.

2004-10-22  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* variable.c, threads.c, struct.c, stackchk.c, smob.c, root.c,
	print.c, ports.c, mallocs.c, hooks.c, hashtab.c, fports.c,
	guardians.c, filesys.c, coop-pthreads.c, continuations.c: Use
	scm_uintprint to print unsigned integers, raw heap words, and
	adresses, using a cast to scm_t_bits to turn pointers into
	integers.

	* unif.c: Include "libguile/print.h".

	* numbers.h, numbers.c (SCM_T_INTBUFLEN): Increased to cover
	scm_t_intmax values.
	(scm_uint2str): New, for scm_t_uintmax.
	(scm_iint2str): Argument type changed to scm_t_intmax,
	reimplemented in terms of scm_uint2str.

	* print.c, print.h (scm_uintprint): New, for printing
	scm_t_uintmax values.
	(scm_intprint): Argument type changed to scm_t_intmax.

	* sort.c (quicksort, scm_merge, scm_merge_list_x,
	scm_merge_list_step, scm_merge_vector_step): Inserted SCM_TICKs at
	strategic places so that the loops can be interrupted.

	* Makefile.am (INCLUDES): Use @LTDLINC@ instead of
	"-I$(top_srcdir)/libguile-ltdl".
	(libguile_la_LIBADD): Use @LIBLTDL@ instead of
	"../libguile-ltdl/libguile-ltdl.a".

	* guile.c, dynl.c: Switched to using libltdl directly.  Replaced
	all references to scm_lt_* with just lt_*.  Include <ltdl.h>
	instead of <libguile-ltdl.h>.

2004-10-20  Marius Vollmer  <mvo@zagadka.de>

	* sort.c (quicksort): Copy pivot out of the array while
	constructing the partitions; it could get overwritten otherwise.
	Because of the ultimate insertion sort, this bug did not cause
	quicksort to fail, it just put all the burdon on the insertion
	sort and was thus very slow.  Thanks to Rolan Orre for reporting
	the slowness!

2004-10-19  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* numbers.c (scm_i_range_error): New.
	* conv-integer.i.c, conv-uinteger.i.c: Use it instead of
	scm_out_of_range.

	* sort.c (scm_restricted_vector_sort_x): Validate startpos <=
	endpos.  State inclusiveness/exclusiveness of bounds in docstring.

	* unif.c (scm_array_p): When no prototype is given, explicitely
	test for allowable types, do not simply return true.  Thanks to
	Roland Orre for reporting this!

	* private-gc.h (SCM_DEFAULT_MAX_SEGMENT_SIZE): Increase to 20 Mib.

	* gc-segment.c (scm_i_get_new_heap_segment): Limit size of new
	segment to scm_max_segment_size.

2004-10-08  Han-Wen Nienhuys  <hanwen@xs4all.nl>

	* gc.c (scm_igc): put scm_gc_running-- before running hooks.

	* inline.h (scm_double_cell): abort if GC running.
	(scm_cell): idem.

2004-10-04  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* error.c (scm_wrong_type_arg): Do not talk about "argument" for
	pos == 0.

	Keywords no longer store a 'dash symbol'.  Instead, they store a
	symbol with their real name.

	* keywords.h, keywords.c, deprecated.h, deprecated.c
	(SCM_KEYWORDP, SCM_KEYWORDSYM): Deprecated and implemented in
	terms of scm_is_keyword and scm_keyword_dash_symbol.

	* keywords.h, keywords.c, discouraged.h, discouraged.c
	(scm_make_keyword_from_dash_symbol, scm_keyword_dash_symbol,
	scm_c_make_keyword): Discouraged.

	* keywords.h, keywords.c (scm_symbol_to_keyword,
	scm_keyword_to_symbol): Implemented in C.
	(scm_is_keyword, scm_from_locale_keyword,
	scm_from_locale_keywordn): New.

	* goops.c: Replaced SCM_KEYWORDP with scm_is_keyword.

	* snarf.h (SCM_KEYWORD, SCM_GLOBAL_KEYWORD): Use
	scm_from_locale_keyword instead of scm_c_make_keyword.

	* keywords.c (scm_symbol_to_keyword): Use SCM_ASSERT_TYPE for a
	better error message.

	* deprecated.c: Include discouraged.h and keywords.h.

	* read.c (scm_lreadr): Simply do (symbol->keyword (read)) after
	reading '#:' or ':'.  See NEWS for consequences.

2004-09-29  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* read.c (scm_lreadr): Revert change from 2004-09-22: string
	literals are now read-write again (until SCM_STRING_CHARS is
	removed).

	* strings.c (SCM_STRING_CHARS): Explicitely reject read-only
	strings with an error message that blames SCM_STRING_CHARS.

	* options.c (change_option_setting): Use scm_car instead of
	explicit type check plus SCM_CAR.

	* print.h, print.c (SCM_PRINT_HIGHLIGHT_PREFIX,
	SCM_PRINT_HIGHLIGHT_SUFFIX): New printer options.
	(scm_iprin1): Use them instead of the previoulsy hardcoded
	strings.
	(scm_init_print): Initialize them.

	* backtrace.c (display_frame_expr): Do not remove control
	characters from the final string.  Print it directly using
	scm_display.

	* ramap.c (scm_array_equal_p): Include scm_tc7_svect in switch.
	Thanks to Roland Orre!

2004-09-29  Kevin Ryde  <user42@zip.com.au>

	* regex-posix.c (scm_regexp_exec): Correction to last change, should
	be whole original string in match struct, not offsetted substring.

2004-09-24  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* gc.c (scm_gc_unprotect_object): abort if called during GC.

2004-09-24  Marius Vollmer  <mvo@zagadka.de>

	* Makefile.am (EXTRA_DIST): Added gettext.h.

	* smob.c, smob.h (scm_assert_smob_type): New.

	* Makefile.am (guile_CFLAGS, guile_LDFLAGS, libguile_la_CFLAGS):
	Include GUILE_CFLAGS.
	(libguile_la_LIBADD): Removed THREAD_LIBS_LOCAL, which is unused
	now.
	(libpath.h): Put GUILE_CFLAGS in the build-info.

2004-09-23  Marius Vollmer  <mvo@zagadka.de>

        * print.h (scm_print_state): Added highlight_objects.
	* print.c (make_print_state, scm_free_print_state): Initialize it
	to SCM_EOL.
	(scm_iprin1): Wrap output in '{...}' when object is contained in
	highlight_objects.

	* backtrace.h, backtrace.c (scm_display_backtrace_with_highlights,
	scm_backtrace_with_highlights): New.  Set highlight_objects of
	printstate.

	* error.c (scm_error_scm): Document new meaning of data/rest
	argument for out-of-range and wrong-type-arg errors.
	(scm_out_of_range, scm_out_of_range_pos, scm_wrong_type_arg,
	scm_wrong_type_arg_msg): Pass bad_value in rest argument of
	exception so that it gets highlighted in the backtrace.
	Don't talk about "argument" when not giving a position.

	* throw.c (handler_message): The rest argument is the fourth
	argument, not everything after the third.  Call
	scm_display_backtrace_with_highlights, passing the rest argument
	when appropriate.

2004-09-22  Marius Vollmer  <mvo@zagadka.de>

	From Jan Nieuwenhuizen <janneke@gnu.org> and Bruno Haible
	<bruno@clisp.org>:

	* i18n.c: Handle --disable-nls (thanks Bruno).

	* posix.c (scm_init_posix): Add LC_PAPER, LC_NAME, LC_ADDRESS,
	LC_TELEPHONE, LC_MEASUREMENT, LC_IDENTIFICATION.

	* i18n.c (scm_i_to_lc_category): New name and export.  Support all
	LC categories.
	* posix.c (scm_setlocale): Use it.

	* i18n.h, i18n.c (scm_textdomain, scm_bindtextdomain,
	scm_bind_textdomain_codeset): Make wrappers similar to C function
	they wrap.

	* i18n.h: New file.
	* i18n.c: New file.
	* gettext.h: New file, taken from GNU gettext.
	* init.c: Include libguile/i18n.h.
	(scm_init_guile_1): Add call to scm_init_i18n().
	* Makefile.am (libguile_la_SOURCES): Add i18n.c.
	(DOT_X_FILES): Add i18n.x.
	(DOT_DOC_FILES): Add i18n.doc.
	(libguile_la_LDFLAGS): Add @LTLIBINTL@.
	(modinclude_HEADERS): Add i18n.h.

2004-09-22  Marius Vollmer  <mvo@zagadka.de>

	* gh_list.c: Replaced SCM_CAR, etc with scm_car, etc.

	* discouraged.h, tags.h (SCM_CONSP, SCM_NCONSP): Moved to
	discouraged.h.  Replaced all uses with scm_is_pair.
	(SCM_I_CONSP): New name for SCM_CONSP.

	* pairs.h, pairs.c (scm_is_pair, scm_is_null, scm_car, scm_cdr,
	scm_i_chase_pairs, SCM_I_A_PAT, SCM_I_D_PAT, etc, scm_caar,
	scm_cadr, etc): New.
	(SCM_NULLP, SCM_NNULLP): Moved to discouraged.h.  Replaced all
	uses with scm_is_null.

	* eval.c (scm_eval, scm_apply, call_cxr_1): Use scm_i_chase_pairs
	instead of explicit code.

2004-09-22  Marius Vollmer  <mvo@zagadka.de>

	* srfi-13.c (scm_string_contains, scm_string_contains_ci):
	Reworded logic a bit so that #f is returned immediately when s1 is
	too short to contain s2.

	* regex-posix.c (scm_regexp_exec): Convert string to
	zero-terminated locale string before matching against it.

	* strings.h, strings.c (scm_substring_read_only,
	scm_c_substring_read_only, scm_i_substring_read_only): New.
	(RO_STRING_TAG, IS_RO_STRING): New.
	(scm_i_string_writable_chars): Bail on read-only strings.

	* read.c (scm_lreadr): use scm_c_substring_read_only for string
	literals, thus making them read-only as specified by R5RS.

2004-09-22  Marius Vollmer  <mvo@zagadka.de>

	* eq.c (scm_equal_p): Allow smobs with different flags to be equal
	by testing for smobs before insisting on equal SCM_CELL_TYPES.

2004-09-21  Marius Vollmer  <mvo@zagadka.de>

	* numbers.h, numbers.c: Include <gmp.h> in numbers.h, not in
	numbers.c.
	(scm_to_mpz, scm_from_mpz): New.
	Thanks to Andreas Vögele!

	* read.c (skip_scsh_block_comment): Recognize "!#" everywhere, not
	just on a line of its own.

	* srfi-13.c (scm_string_any, scm_string_every,
	scm_string_tabulate, string_upcase_x, string_down_case_x,
	string_titlecase_x, string_reverse_x, scm_string_tokenize): Use
	size_t instead of int for indices into strings.  Make sure that no
	over- or underflow occurs.  Thanks to Andreas Vögele!
	(scm_xsubstring, scm_string_xcopy_x): Use ints for 'extended'
	indices, which can also be negative.

2004-09-20  Marius Vollmer  <mvo@zagadka.de>

	* gc-mark.c (SCM_MARK_BACKING_STORE): Removed, it was unused.

	* threads.c (scm_threads_mark_stacks): Call
	SCM_MARK_BACKING_STORE.  Also, do not use stack_len local, it was
	only used once.

2004-09-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	* srfi-13.c (scm_string_contains, scm_string_contains_ci):
	Bugfix: when subtracting unsigned values, make sure that result
	does not wrap.

2004-09-09  Kevin Ryde  <user42@zip.com.au>

	* filesys.c, stime.c (_POSIX_C_SOURCE): Use this only on hpux, it
	causes too many problems elsewhere (glibc, freebsd, mingw).  Reported
	by Andreas Vögele.

2004-09-08  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* Makefile.am (EXTRA_libguile_la_SOURCES): Removed "alloca.c".

	* eq.c (real_eqv): Pretend that all NaNs are equal.

	* numbers.c (scm_integer_expt): Do not accept inexact integers.

2004-09-07  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* srfi-13.c (scm_string_trim_right, scm_string_xcopy_x): Correctly
	use size_t for some locals instead of int.

	* read.c (scm_flush_ws): Detect "#!"-style comments here.
	(scm_lreadr): Abort on seeing "#!", which should no longer happen.
	(skip_scsh_block_comment): Use scm_input_error instead of
	scm_misc_error in case of EOF.

2004-09-07  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_integer_expt): Reject exponent +/-inf.
	Bug report by Bill Schottstaedt.

	* ports.c (scm_getc, scm_lfwrite): Recognise \a \b and \r for port
	column.
	* ports.h (SCM_ZEROCOL, SCM_DECCOL): New macros.

	* posix.c (scm_access): Update docstring per manual.

	* posix.c (scm_nice): Correction to error detection.  Reported by
	Matthias Koeppe.

	* stime.c (scm_current_time, scm_gettimeofday, scm_strptime): Don't
	throw error before unlocking mutex with SCM_ALLOW_INTS.

2004-09-06  Kevin Ryde  <user42@zip.com.au>

	* stime.h (SCM_TIME_UNITS_PER_SECOND): Use sysconf(_SC_CLK_TCK) when
	available.  This also gets around CLK_TCK being absent when
	_GNU_SOURCE and _POSIX_C_SOURCE are defined in stime.c.

2004-09-03  Stefan Jahn  <stefan@lkcc.org>

	* threads.c (scm_threads_mark_stacks):  Fixed local variable
	definitions.

	* strings.c (scm_i_substring_copy, scm_string_append): Fixed
	local variable definitions.

	* stime.c (_POSIX_C_SOURCE):  Do not define this item on
	MinGW32 because it conflicts with its pthread headers.
	(scm_mktime): Consider the HAVE_STRUCT_TM_TM_ZONE define.
	(scm_strftime): Using scm_from_locale_string() instead of
	scm_makfrom0str().

	* posix.c (scm_putenv): Fixed typo in the !HAVE_UNSETENV
	part.

	* numbers.c (scm_init_numbers): Removed check_sanity() call
	inside GUILE_DEBUG.  The function has been removed somewhen...

	* filesys.c (_POSIX_C_SOURCE): Do not define this item on
	MinGW32 because it conflicts with its pthread headers.

2004-08-27  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* strings.c (SCM_STRINGP): Accept all strings.
	(SCM_STRING_CHARS): Reject shared substrings here.

	* script.c (scm_compile_shell_switches): Added 2003 and 2004 to
	the Copyright years.

2004-08-27  Kevin Ryde  <user42@zip.com.au>

	* socket.c (scm_fill_sockaddr): Use HAVE_STRUCT_SOCKADDR_SIN_LEN and
	HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN for sockaddr fields, SIN_LEN and
	SIN_LEN6 are not defined on all systems.  Reported by Michael Tuexen.

2004-08-26  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* strings.h, strings.c (scm_i_make_symbol): Added FLAGS parameter.
	* symbols.h, symbols.c (SCM_I_F_SYMBOL_UNINTERNED,
	scm_i_symbol_is_interned, scm_i_mem2symbol,
	scm_i_mem2uninternedsymbol): Use it to store uninternedness flag.

2004-08-25  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* srfi-13.c: First cut at thread-safeness and proper use of
	scm_i_string_chars et al.  Copious scm_remember_upto_heres have
	been inserted.  Made sure that no internal string pointer is used
	across a SCM_TICK or a possible GC.

	* script.c (scm_compile_shell_switches): Use
	scm_from_locale_string instead of scm_makfrom0str.

	* srfi-13.c (scm_string_rindex): Export to Scheme, as it has
	always been.

2004-08-25  Marius Vollmer  <mvo@zagadka.de>

	Moved SRFI-13 and SRFI-14 into the core, taking over the role of
	strop.c.

	* srfi-13.c, srfi-13.h, srfi-14.c, srfi-14.h: New files.
	* strop.h, strop.c: Removed, they are now empty.
	* Makefile.am: Updated for new and removed files.

	* symbols.h, symbols.c (scm_string_ci_to_symbol): Moved here, next
	to scm_string_to_symbol.

	* chars.c (scm_char_alphabetic_p, scm_char_numeric_p,
	scm_char_whitespace_p, scm_upper_case_p, scm_lower_case_p,
	scm_char_is_both_p): Use scm_char_set_contains_p with the proper
	charset instead of libc functions.

	* strorder.c (scm_string_equal_p, scm_string_ci_equal_p,
	scm_string_less_p, scm_string_leq_p, scm_string_gr_p,
	scm_string_geq_p, scm_string_ci_less_p, scm_string_ci_leq_p,
	scm_string_ci_gr_p, scm_string_ci_geq_p): Use scm_string_eq, etc
	instead of explicit code.

	* deprecated.c, load.c, posix.c, unif.c, symbols.c: Include
	"srfi-13.h" instead of "strop.h".

	* init.c (scm_init_guile_1): Call scm_init_srfi_13 and
	scm_init_srfi_14.  Do not call scm_init_strop.

2004-08-24  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* numbers.c (scm_inf_p): Synced docstring back from manual.

2004-08-22  Marius Vollmer  <mvo@zagadka.de>

	* strings.c (get_str_buf_start): New helper function.
	(scm_i_substring, scm_i_substring_copy, scm_i_substring_shared,
	scm_i_string_char, scm_i_string_writable_chars): Use it.
	(scm_i_substring_copy): Make START argument optional for C
	callers, for upcoming SRFI-13 integration.

2004-08-21  Marius Vollmer  <mvo@zagadka.de>

        From Richard Todd, Thanks!

	* script.c (scm_compile_shell_switches): added '-L' switch to add
	to the %load-path.

2004-08-21  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (unmemoize_exprs): When dropping internal body markers
	from the output during unmemoization, also drop those that are not
	immediately at the beginning of a body.

2004-08-20  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* eval.c (scm_lookupcar1): Report "Variable used before given a
	value" insetad of an "Unbound" one for variables that are found
	but still contain SCM_UNDEFINED.

	* posix.c (scm_mkstemp): Correction to the correction, mkstemp
	expects a null-terminated string in the locale encoding, but
	scm_i_string_writable_chars doesn't give that.  Fixed by letting
	mkstemp modify a locale version of the tmpl argument and copying
	the result back into tmpl.

	* strop.c (scm_substring_move_x): Store into str2, not str1.

2004-08-20  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_mkstemp): Correction to new locale_string stuff, need
	to modify the input string.

2004-08-19  Marius Vollmer  <mvo@zagadka.de>

	* deprecated.c (SCM_SYMBOL_CHARS): Cast away const in return.
	(SCM_SYMBOL_LENGTH): It's scm_i_symbol_length, not
	scm_c_symbol_length.

2004-08-19  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

        New string implementation, with copy-on-write strings and
	mutation-sharing substrings, and a new internal string API.
	Symbols can now share memory with strings.

	* tags.h (scm_tc7_stringbuf): New tag.

	* strings.h, strings.c: (scm_i_string_chars, scm_i_string_length,
	scm_i_string_writable_chars, scm_i_string_stop_writing): New, to
	replace SCM_I_STRING_CHARS and SCM_I_STRING_LENGTH.  Updated all
	uses.
	(scm_i_make_string, scm_c_make_string): New, to replace
	scm_allocate_string.  Updated all uses.
	(SCM_STRINGP, SCM_STRING_CHARS, SCM_STRING_UCHARS,
	SCM_STRING_LENGTH): Deprecated.
	(scm_allocate_string, scm_take_str, scm_take0str, scm_mem2string,
	scm_str2string, scm_makfrom0str, scm_makfrom0str_opt):
	Discouraged.  Replaced all uses with scm_from_locale_string or
	similar, as appropriate.
	(scm_c_string_length, scm_c_string_ref, scm_c_string_set_x,
	scm_c_substring, scm_c_substring_shared, scm_c_substring_copy,
	scm_substring_shared, scm_substring_copy): New.

	* symbols.c, symbols.h (SCM_SYMBOLP, SCM_SYMBOL_FUNC,
	SCM_SET_SYMBOL_FUNC, SCM_SYMBOL_PROPS, SCM_SET_SYMBOL_PROPS,
	SCM_SYMBOL_HASH, SCM_SYMBOL_INTERNED_P, scm_mem2symbol,
	scm_str2symbol, scm_mem2uninterned_symbol): Discouraged.
	(SCM_SYMBOL_LENGTH, SCM_SYMBOL_CHARS, scm_c_symbol2str):
	Deprecated.
	(SCM_MAKE_SYMBOL_TAG, SCM_SET_SYMBOL_LENGTH, SCM_SET_SYMBOL_CHARS,
	SCM_PROP_SLOTS, SCM_SET_PROP_SLOTS): Removed.
	(scm_is_symbol, scm_from_locale_symbol, scm_from_locale_symboln):
	New, to replace scm_str2symbol and scm_mem2symbol, respectively.
	Updated all uses.
	(scm_gensym): Generate only the number suffix in the buffer, just
	string-append the prefix.

	* error.c (scm_memory_error): Do not try to throw, just abort.
	Throwing will not work anyway.

	* gh.h, gh-data.c (gh_set_substr): Made src const.

	* ports.c (scm_i_mode_bits_n): New, for counted strings.
	(scm_mode_bits): Use it.
	(scm_c_port_for_each): Blocking GC does not seem to work, allocate
	a vector normally and fill that instead of consing a list with a
	blocked GC.

	* read.c (scm_i_casei_streq): New, for counted strings.

	* threads.c (gc_section_count): Removed, thread-sleeping can not
	be nested.
	(scm_i_thread_put_to_sleep): Call scm_i_leave_guile before locking
	admin mutex so that we can be put to sleep by other threads while
	blocking on that mutex.  Lock all the heap mutex of all threads,
	including ourselves.
	(scm_i_thread_wake_up): Unlock all threads, including ourselves,
	call scm_i_enter_guile.
	(scm_thread_mark_stacks): Expect all threads to be suspended.

	* gc.h, gc.c (scm_i_gc_admin_mutex): New, to protect
	scm_gc_mallocated, for now.
	(scm_init_storage): Initialize it.
	* gc-malloc.c (descrease_mtrigger, increase_mtrigger): Use it.

	* gc-mark.c (scm_gc_mark_dependencies): Call scm_i_string_mark,
	scm_i_stringbuf_mark and scm_i_symbol_mark, as appropriate.
	* gc-card.c (scm_i_sweep_card):  Call scm_i_string_free,
	scm_i_stringbuf_free and scm_i_symbol_free, as appropriate.

	* strop.c (scm_string_copy): Use scm_c_substring to get a
	copy-on-write string.

2004-08-18  Kevin Ryde  <user42@zip.com.au>

	* arbiters.c (FETCH_STORE): New macro.
	(SCM_LOCK_VAL, SCM_UNLOCK_VAL): New constants.
	(SCM_LOCK_ARB, SCM_UNLOCK_ARB): Remove, effectively absorbed into
	scm_try_arbiter and scm_release_arbiter.
	(scm_try_arbiter, scm_release_arbiter): Use FETCH_STORE to get xchg
	for speed on i386, otherwise using mutex.

	* eq.c (scm_equal_p): Remove real==fraction and fraction==real, they
	must be #f according to R5RS.  (equal? follows eqv?, and for eqv? an
	exact and inexact is #f.)

	* fports.c (fport_print): Use scm_ttyname instead of ttyname directly,
	to get thread safety of scm_ttyname.

	* ports.c (ttyname): Remove prototype, unused.

	* socket.c (scm_init_socket): Add SOCK_SEQPACKET and SOCK_RDM.
	Reported by Michael Tuexen.

2004-08-13  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* load.c (scm_init_load_path): Do not pass NULL to
	scm_to_locale_string, which would happen when GUILE_LOAD_PATH is
	not set.  Thanks to Bill Schottstaedt.

2004-08-12  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* socket.c (scm_inet_aton, scm_inet_pton): Convert SCM strings to
	locale strings instead of accessing their internals.
	(scm_recv, scm_send, scm_recvfrom, scm_sendto): Use
	SCM_I_STRING_CHARS and SCM_I_STRING_LENGTH instead of
	SCM_STRING_CHARS and SCM_STRING_LENGTH.

	* simpos.c (scm_system): Convert SCM strings to locale strings
	instead of accessing their internals.

	* script.c (scm_compile_shell_switches): Convert version to locale
	string before printing it.

	* rdelim.c (scm_read_delimited_x): Avoid
	SCM_VALIDATE_SUBSTRING_SPEC_COPY and use scm_from_size_t instead
	of scm_from_long for the returned number of read characters.

	* ioext.c (scm_fdopen): Use scm_i_fdes_to_port together with
	scm_i_mode_bits to avoid accessing internals of SCM string from C.

	* filesys.c (STRING_SYSCALL, STRING2_SYSCALL): New helper macros.
	Use them instead of SCM_SYSCALL when one or two strings need to be
	converted into locale strings.
	(my_rename): New, gathers platform dependent code for renaming.
	(scm_rename): Use it.
	(scm_readlink, scm_copy_file): Convert SCM strings to locale
	strings instead of accessing their internals.
	(scm_basename, scm_dirname): Use SCM_I_STRING_CHARS and
	SCM_I_STRING_LENGTH instead of SCM_STRING_CHARS and
	SCM_STRING_LENGTH.

	* extensions.c (load_extension): Convert lib and init to locale
	strings instead of accessing the internals directly.
	(scm_c_load_extension): Use scm_from_locale_string instead of
	scm_makfrom0str.

	* fports.h, fports.c (scm_i_fdes_to_port): New, like
	scm_fdes_to_port, but take mode bits directly instead of as a C
	string.
	(scm_i_fdes_to_port): Implement using above.
	(scm_open_file): Use scm_i_fdes_to_port together with
	scm_i_mode_bits to avoid accessing internals of SCM string from C.
	* vports.c (scm_make_soft_port): Use scm_i_fdes_to_port together
	with scm_i_mode_bits to avoid accessing internals of SCM string
	from C.

	* ports.h (scm_i_mode_bits): New, same as scm_mode_bits but with a
	SCM string as argument.

	* ports.c (scm_i_void_port): New, like scm_void_port but take mode
	bits directly instead of C string.
	(scm_void_port): Implement using above.
	(scm_sys_make_void_port): Use scm_i_void_port together with
	scm_i_mode_bits to avoid accessing internals of SCM string.

	* strings.h, strings.c (scm_i_get_substring_spec): New.

	* socket.c, rw.c, deprecated.h, validate.h
	(SCM_VALIDATE_STRING_COPY): Deprecated.  Replaced all uses with
	SCM_VALIDATE_STRING plus SCM_I_STRING_CHARS or
	scm_to_locale_string, etc.
	(SCM_VALIDATE_SUBSTRING_SPEC_COPY): Deprecated.  Replaced as
	above, plus scm_i_get_substring_spec.

	* regex-posix.c, read.c, random.c, ramap.c, print.c, numbers.c,
	hash.c, gc.c, gc-card.c, convert.i.c, backtrace.c, strop.c,
	strorder.c, strports.c, struct.c, symbols.c, unif.c, ports.c: Use
	SCM_I_STRING_CHARS, SCM_I_STRING_UCHARS, and SCM_I_STRING_LENGTH
	instead of SCM_STRING_CHARS, SCM_STRING_UCHARS, and
	SCM_STRING_LENGTH, respectively.  Also, replaced scm_return_first
	with more explicit scm_remember_upto_here_1, etc, or introduced
	them in the first place.

	* posix.c (WITH_STRING): New helper macro.  Use it where one
	locale string is needed for a short piece of code.
	(STRING_SYSCALL): New helper macro.  Use it instead of SCM_SYSCALL
	when one locale string is needed.
	(scm_mkstemp): Convert tmpl to a locale string.
	(scm_putenv): Rewritten to use only C strings.
	(scm_setlocale, scm_crpt): Convert argument strings to locale
	strings.

2004-08-11  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* load.c (scm_primitive_load_path): Do not check for absolute
	filenames when scm_sys_search_load_path returns false, which will
	return absolute filenames unchanged.

2004-08-11  Marius Vollmer  <mvo@zagadka.de>

	* gc.c, procprop.c (scm_init_storage, scm_stand_in_procs,
	scm_stand_in_proc): Use a hastable for scm_stand_in_procs instead
	of an alist.  Thanks to Matthias Koeppe!

2004-08-10  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* strings.h, deprecated.h (SCM_STRING_COERCE_0TERMINATION_X):
	Moved from string.h to deprecated.h.

	* deprecated.c, deprecated.h (SCM_CHARS, SCM_LENGTH): Removed.

	* strings.h, strings.c (SCM_MAKE_STRING_TAG): Renamed to
	SCM_I_MAKE_STRING_TAG, changed all uses.
	(SCM_STRING_CHARS, SCM_STRING_UCHARS, SCM_STRING_LENGTH): Renamed
	to SCM_I_STRING_CHARS, SCM_I_STRING_UCHARS, and SCM_I_LENGTH
	respectively.  For a short time, the old names are still there as
	aliases.  Not all uses have been changed yet, but the ones in
	strings.c have.
	(SCM_STRING_MAX_LEN): Do not hardcode to 24 bits, compute from
	SCM_T_BITS_MAX.
	(scm_is_string, scm_from_locale_string, scm_from_locale_stringn,
	scm_take_locale_string, scm_take_locale_stringn,
	scm_to_locale_string, scm_to_locale_stringn,
	scm_to_locale_stringbuf): New.
	(scm_c_string2str, scm_c_substring2str): Deprecated by moving to
	deprecated.[hc]. Implemented in terms of the new functions above.
	(scm_take_str, scm_take0str, scm_mem2string, scm_str2string,
	scm_makfrom0str): Reimplemented in terms of the new functions from
	above.  They will be discouraged shortly.
	(scm_substring): Do not use scm_mem2string.
	(scm_i_allocate_string_pointers, scm_i_free_string_pointers): New,
	to replace similar code from posix.c, simpos.c, and dynl.c.
	(scm_string_append): Use memcpy instead of explicit loop.  Do not
	use register keyword.  Use plain 'char' instead of 'unsigned
	char'.

	* strports.c (scm_mkstrport): Use SCM_I_STRING_UCHARS instead of
	SCM_STRING_UCHARS.  Use SCM_I_STRINGP instead of SCM_STRINGP.

	* strop.c (scm_i_index): Replaced SCM_STRINGP, SCM_STRING_CHARS,
	and SCM_STRING_LENGTH with SCM_I_STRINGP, SCM_I_STRING_CHARS, and
	SCM_I_STRING_LENGTH, respectively.  Pass string object directly,
	not as a pointer.  Use scm_remember_upto_here_1 to protect it.

	* read.c (scm_input_error): Use a SCM value for 'fn', not a C
	string.  This avoids a conversion round-trip.

	* gh_data.c: Replaced SCM_STRINGP, SCM_STRING_CHARS, and
	SCM_STRING_LENGTH with SCM_I_STRINGP, SCM_I_STRING_CHARS, and
	SCM_I_STRING_LENGTH, respectively.
	(gh_scm2newstr): Implement in terms of scm_to_locale_string.

	* environments.c: Instead calling scm_puts on the SCM_STRING_CHARS
	of a string, call scm_display on the string itself.

	* dynwind.c, dynwind.h (scm_frame_free): New.

	* stime.c, socket.c, simpos.c, procs.c, posix.c, ports.c,
	net_db.c, fports.c, filesys.c, eval.c, deprecation.c, dynl.c:
	Replaced uses of SCM_STRING_CHARS with proper uses of
	scm_to_locale_string.  Replaced SCM_STRINGP with scm_is_string.
	Replaced scm_mem2string with scm_from_locale_string.

	* simpos.c, posix.c (allocate_string_pointers, environ_list_to_c):
	Removed, replaced all uses with scm_i_allocate_string_pointers.

	* load.h, load.c (scm_internal_parse_path): Removed.
	(scm_parse_path): Use scm_string_split to do the work.
	(scm_init_load_path): Use scm_parse_path instead of
	scm_internal_parse_path.
	(scm_search_path): Rewritten string handling part of the code in
	terms of scm_to_locale_stringbuf and so that it is thread safe.

	* error.c (scm_error_scm): Throw directly instead of calling
	scm_error, this avoids the back and forth conversion of SUBR and
	MESSAGE and also plugs a memory leak.
	(scm_error): Call scm_error_scm.

	* backtrace.c: Replaced SCM_STRINGP with scm_is_string.
	(display_header): Print FNAME when it is true, not
	merely when it is a string.

	* strings.h (SCM_SET_STRING_LENGTH, SCM_SET_STRING_CHARS): Removed
	unceremoniously.  They were unused by Guile itself, and external
	use should stop immediately.


2004-08-10  Marius Vollmer  <mvo@zagadka.de>

	* numbers.h, number.c, deprecated.h, deprecated.c (scm_round,
	scm_truncate): Renamed to scm_c_round and scm_c_truncate;
	deprecated versions installed in deprecated.h and deprecated.c.
	Changed all uses.

2004-08-06  Rob Browning  <rlb@defaultvalue.org>

	* net_db.c (scm_resolv_error): don't cause an exception while
	trying to throw an exception -- call scm_misc_error with correct
	arguments.  The previous arguments needed a format escape that
	wasn't in any of the format strings.

2004-08-06  Kevin Ryde  <user42@zip.com.au>

	* ramap.c (scm_array_fill_x): For byvect char fill, force signed char
	so as not to depend on signedness of plain char.  For byvect range
	check, throw out-of-range rather than wrong-type-arg.

	* unif.c (scm_uniform_vector_ref, scm_array_set_x): For byvect, force
	signed byte range checks by using scm_to_schar and scm_from_schar,
	don't want to depend on signedness of C char.

2004-08-05  Kevin Ryde  <user42@zip.com.au>

	* arbiters.c (scm_try_arbiter): Use scm_i_misc_mutex instead of
	SCM_DEFER_INTS.
	(scm_release_arbiter): Use scm_i_misc_mutex so return value can be
	guaranteed if multiple threads compete to unlock.
	Update docstrings per doc/ref/api-scheduling.texi.

	* filesys.c (scm_copy_file): Use fstat on the input fd rather than
	stat on the filename, to be certain a file rename can't mean we get
	info on one filesystem object but open another.  This fstat usage is
	similar to Emacs copy-file.

	* posix.c (scm_setgroups): Enhance docstring, per doc/ref/posix.texi.

	* simpos.c (scm_system_star): Change scm_from_long to scm_from_int on
	SIGINT and SIGQUIT, since those values are ints.

2004-08-03  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* num2integral.i.c, num2float.i.c: Removed.
	* Makefile.am (noinst_HEADERS): Updated.

	* numbers.h. numbers.c (scm_make_ratio): Renamed to
	scm_i_make_ratio and made static, replaced uses with scm_divide.
	(scm_complex_p): New, export as "complex?" to Scheme.
	(scm_number_p): Export as "number?" to Scheme.
	(scm_is_complex, scm_is_number): New.
	(scm_c_make_rectangular, scm_c_make_polar): New.
	(scm_make_rectangular, scm_make_polar): Use above.
	(scm_c_real_part, scm_c_imag_part, scm_c_magnitude, scm_c_angle):
	New.
	(scm_make_complex): Discouraged by moving to discouraged.h and
	discouraged.c.  Replaced all uses with scm_c_make_rectangular.

	* discouraged.h, discouraged.c, numbers.c, numbers.h
	(scm_is_rational): New.
	(scm_i_short2big, scm_i_int2big, scm_i_uint2big, scm_i_size2big,
	scm_i_ptrdiff2big, scm_i_long_long2big, scm_i_ulong_long2big):
	Removed prototypes.
	(scm_make_real, scm_num2dbl, scm_float2num, scm_double2num):
	Discouraged by moving to discouraged.h and discouraged.c.
	Replaced all uses with scm_from_double.
	(scm_num2float, scm_num2double): Discouraged by moving prototype
	to discouraged.h and rewriting in terms of scm_to_double.
	Replaced all uses with scm_to_double.
	(scm_to_double): Do not implement in terms of scm_num2dbl, use
	explicit code.
	(scm_from_double): Do not implement in terms of scm_make_real, use
	explicit code.

2004-08-02  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* init.c (scm_init_guile_1): Call scm_i_init_discouraged.

	* gen-scmconfig.h.in (SCM_I_GSC_ENABLE_DISCOURAGED): New.
	* gen-scmconfig.c (SCM_ENABLE_DISCOURAGED): Emit based on above.

	* eval.c (SCM_EVALIM, SCM_EVALIM2, SCM_XEVAL, SCM_XEVALCAR):
	Renamed to SCM_I_* in order to avoid collisions with the versions
	defined in deprecated.h.

	* discouraged.h, discouraged.c: New files.

	* deprecated.h (SCM_FALSEP, SCM_NFALSEP, SCM_BOOLP, SCM_EQ_P,
	SCM_NEGATE_BOOL, SCM_BOOL, SCM_BOOT_NOT): Promoted from being
	deprecated to being discouraged by moving to discouraged.h.

	* numbers.h, numbers.c, discouraged.h, discouraged.c
	(scm_short2num, scm_ushort2num, scm_int2num, scm_uint2num,
	scm_long2num, scm_ulong2num, scm_size2num, scm_ptrdiff2num,
	scm_num2short, scm_num2ushort, scm_num2int, scm_num2uint,
	scm_num2long, scm_num2ulong, scm_num2size, scm_num2ptrdiff,
	scm_long_long2num, scm_ulong_long2num, scm_num2long_long,
	scm_num2ulong_long): Discouraged by moving to discouraged.h and
	discouraged.c and reimplementing in terms of scm_from_* and
	scm_to_*.  Changed all uses to the new scm_from_* and scm_to_*
	functions.

	* numbers.h, numbers.c: Removed GUILE_DEBUG code.
	(scm_i_short2big, scm_i_ushort2big, scm_i_int2big, scm_i_uint2big,
	scm_i_size2big, scm_i_ptrdiff2big): Removed.
	(scm_i_long2big, scm_i_ulong2big): New, explicit definitions.
	* conv-integer.i.c, conv-uinteger.i.c: Use them instead of
	explicit code.

2004-08-02  Kevin Ryde  <user42@zip.com.au>

	* __scm.h (SCM_DEFER_INTS, SCM_ALLOW_INTS): Add comments about past
	and current usage and migration.

2004-07-31  Kevin Ryde  <user42@zip.com.au>

	* error.c (scm_strerror): Use scm_i_misc_mutex around strerror since
	it's not thread safe.
	(scm_syserror): Use scm_strerror rather than SCM_I_STRERROR, to take
	advantage of this.
	* fports.c (scm_open_file): Use scm_strerror likewise.
	* filesys.c (scm_stat, scm_lstat): Ditto.

	* filesys.c (scm_copy_file): Avoid fd leak when destination file
	cannot be opened.

	* symbols.c (scm_gensym): Use scm_i_misc_mutex around gensym_counter
	update, for thread safety.
	(gensym_counter): Move into scm_gensym which is its only user.
	(scm_init_symbols): No need to explicitly initialize gensym_counter.

2004-07-29  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* numbers.h (scm_to_schar, scm_to_uchar, scm_to_char,
	scm_to_short, scm_to_ushort, scm_to_int, scm_to_uint, scm_to_long,
	scm_to_ulong, scm_to_long_long, scm_to_ulong_long, scm_to_intmax,
	scm_to_uintmax, scm_to_size_t, scm_to_ssize_t scm_from_schar,
	scm_from_uchar, scm_from_char, scm_from_short, scm_from_ushort,
	scm_from_int, scm_from_uint, scm_from_long, scm_from_ulong,
	scm_from_long_long, scm_from_ulong_long, scm_from_intmax,
	scm_from_uintmax, scm_from_size_t, scm_from_ssize_t): No longer
	defined in terms of scm_to_signed_integer, etc, but in terms of
	scm_to_int8, etc.

	* gen-scmconfig.c (SCM_SIZEOF_INTMAX, SCM_SIZEOF_SIZE_T): New.

	* gen-scmconfig.h.in: Removed SCM_I_GSC_*_LIMITS macros, they are
	no longer used.

	* __scm.h (SCM_I_UTYPE_MAX, SCM_I_TYPE_MAX, SCM_I_TYPE_MIN,
	SCM_I_SIZE_MAX, SCM_I_SSIZE_MIN, SCM_I_SSIZE_MAX): New.

	* __scm.h, gen-scmconfig.c (SCM_I_LLONG_MAX, SCM_I_LLONG_MIN,
	SCM_I_ULLONG_MAX, SCM_T_INT8_MIN, SCM_T_INT8_MAX, SCM_T_UINT8_MAX,
	SCM_T_INT16_MIN, SCM_T_INT16_MAX, SCM_T_UINT16_MAX,
	SCM_T_INT32_MIN, SCM_T_INT32_MAX, SCM_T_UINT32_MAX,
	SCM_T_INT64_MIN, SCM_T_INT64_MAX, SCM_T_UINT64_MAX,
	SCM_T_INTMAX_MIN, SCM_T_INTMAX_MAX, SCM_T_UINTMAX_MAX): Moved
	definition into __scm.h, using new SCM_I_TYPE_MIN, etc.

	* conv-integer.i.c, conv-uinteger.i.c: New files, used to generate
	the functions below.

	* Makefile.am (noinst_HEADERS): Added conv-integer.i.c and
	conv-uinteger.i.c.

	* numbers.c, numbers.h (scm_to_int8, scm_to_uint8, scm_to_int16,
	scm_to_uint16, scm_to_int32, scm_to_uint32, scm_to_int64,
	scm_to_uint64, scm_from_int8, scm_from_uint8, scm_from_int16,
	scm_from_uint16, scm_from_int32, scm_from_uint32, scm_from_int64,
	scm_from_uint64): Turned from macros into proper functions.
	(scm_to_signed_integer, scm_to_unsigned_integer,
	scm_from_signed_integer, scm_from_unsigned_integer): Generate via
	conv-integer.i.c and conv-uinteger.i.c, as well.

	* number.h (scm_to_ssize_t, scm_to_size_t): Use the new
	SCM_I_SSIZE_MIN, SCM_I_SSIZE_MAX, and SCM_I_SIZE_MAX macros for
	the limits.  Those are always defined.

2004-07-29  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_ttyname): Use scm_i_misc_mutex for thread safety.

2004-07-28  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_ctermid): Use an L_ctermid buf on the stack, for thread
	safety.

	* unif.c (scm_array_set_x): For svect, use scm_num2short for
	consistency with other vector types and to get arg and func name into
	error message.

2004-07-27  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* deprecated.h (SCM_FALSEP, SCM_NFALSEP, SCM_BOOLP, SCM_BOOL):
	Reimplement using scm_is_false, scm_is_true, scm_is_bool, and
	scm_from_bool, respectively.
	(SCM_NINUMP): Added.

	* tags.h, deprecated.h (SCM_EQ_P): Deprecated by moving it into
	deprecated.h.  Replaced all uses with scm_is_eq.

2004-07-24  Kevin Ryde  <user42@zip.com.au>

	* threads.c, threads.h (scm_i_misc_mutex): New SCM_GLOBAL_MUTEX.
	* posix.c (scm_crypt): Use it to protect static data in crypt().

2004-07-23  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* deprecated.h, deprecated.c, numbers.h (SCM_INUMP, SCM_NINUMP,
	SCM_INUM): Deprecated by renaming them to SCM_I_INUMP,
	SCM_I_NINUMP and SCM_I_INUM, respectively and adding deprecated
	versions to deprecated.h and deprecated.c.  Changed all uses to
	either use the SCM_I_ variants or scm_is_*, scm_to_*, or
	scm_from_*, as appropriate.

	* dynwind.c (scm_i_dowinds): Removed unused code that would call
	the unexisting scm_cross_dynwind_binding_scope for inums on the
	windlist.

2004-07-10  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* socket.c (ipv6_net_to_num, scm_from_ipv6): Renamed
	ipv6_net_to_num to scm_from_ipv6, for converting from an IPv6
	byte-wise address to a SCM integer.  Changed all uses.
	(ipv6_num_to_net, scm_to_ipv6): Renamed ipv6_num_to_net to
	scm_to_ipv6 and added type and range checking, for converting from
	an IPv& byte-wise address to a SCM integer.  Changed all uses.
	(bignum_in_ipv6_range_p, VALIDATE_INET6): Removed, their function
	is now done by scm_to_ipv6.

	* numbers.c (scm_to_signed_integer, scm_to_unsigned_integer): dot
	not accept inexact integers.

	* validate.h, deprecated.h (SCM_VALIDATE_INUM,
	SCM_VALIDATE_INUM_COPY, SCM_VALIDATE_BIGINT,
	SCM_VALIDATE_INUM_MIN, SCM_VALIDATE_INUM_MIN_COPY,
	SCM_VALIDATE_INUM_MIN_DEF_COPY,SCM_VALIDATE_INUM_DEF,
	SCM_VALIDATE_INUM_DEF_COPY, SCM_VALIDATE_INUM_RANGE,
	SCM_VALIDATE_INUM_RANGE_COPY): Deprecated because they make the
	fixnum/bignum distinction visible.  Changed all uses to
	scm_to_size_t or similar.

2004-07-09  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* cpp_cnvt.awk: Use scm_from_int instead of SCM_MAKINUM.

2004-07-10  Kevin Ryde  <user42@zip.com.au>

	* hash.c (scm_hashq, scm_hashv, scm_hash): Restrict to size>=1 rather
	than size>=0, since 0<=hash<size cannot be satisfied for size==0, and
	such a size causes divide-by-zeros in scm_hasher.

        * regex-posix.c (scm_make_regexp): Free rx on error, to avoid memory
	leak.

2004-07-08  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* numbers.c (scm_is_signed_integer, scm_is_unsigned_integer):
	Rewritten using the same logic as scm_to_signed_integer and
	scm_to_unsigned_integer, respectively, which is better(tm).  Also,
	use CHAR_BIT instead of hardcoding 8.
	(LLONG_MIN, LLONG_MAX, ULLONG_MAX): Removed and used
	SCM_I_LLONG_MIN etc. instead.

	* numbers.h (SCM_MAKINUM, SCM_I_MAKINUM): Renamed SCM_MAKINUM to
	SCM_I_MAKINUM and changed all uses.
	* deprecated.h, deprecated.c (SCM_MAKINUM): Newly deprecated.

	* gen-scmconfig.c (SCM_I_LLONG_MIN, SCM_I_LLONG_MAX,
	SCM_I_ULLONG_MAX): Instead of hard-coding the numbers, compute
	them by assuming twos-complement.

2004-07-07  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* gen-scmconfig.h.in: Added all the new SCM_I_GSC_*_LIMITS that
	configure now produces.
	* gen-scmconfig.c: Use them to output SCM_T_INT8_MIN, etc
	definitions, giving the limits of the integer types defined by
	Guile. Also, output a hard coded SCM_I_LLONG_MIN, etc since
	LLONG_MIN or LONG_LONG_MIN is hard to get at.

	* numbers.h (scm_to_short, scm_to_ushort): It's SHRT_MIN, etc, not
	SHORT_MIN.
	(scm_to_size_t): Use SIZE_MAX instead of cooking our own.
	(scm_to_long_long, scm_to_ulong_long, scm_to_int8, scm_to_uint8,
	scm_to_int16, scm_to_uint16, scm_to_int32, scm_to_uint32,
	scm_to_int64, scm_to_uint64, scm_to_intmax, scm_to_uintmax,
	scm_from_long_long, scm_from_ulong_long, scm_from_int8,
	scm_from_uint8, scm_from_int16, scm_from_uint16, scm_from_int32,
	scm_from_uint32, scm_from_int64, scm_from_uint64, scm_from_intmax,
	scm_from_uintmax): New.

2004-07-06  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* tags.h (scm_is_eq): New.

	* deprecated.h, boolean.h (SCM_FALSEP, SCM_NFALSEP, SCM_BOOL,
	SCM_NEGATE_BOOL, SCM_BOOLP): Deprecated by moving into
	"deprecated.h".  Replaced all uses with scm_is_false, scm_is_true,
	scm_from_bool, and scm_is_bool, respectively.

	* boolean.h (scm_is_bool): Fix bug in prototype.
	(scm_from_bool): The argument is "x" not "f", stupid.

	* boolean.c (scm_is_bool): Fix typo.

	* numbers.h, numbers.c (scm_is_integer, scm_is_signed_integer,
	scm_is_unsigned_integer, scm_to_signed_integer,
	scm_to_unsigned_integer, scm_to_schar, scm_to_uchar, scm_to_char,
	scm_to_short, scm_to_ushort, scm_to_long, scm_to_ulong,
	scm_to_size_t, scm_to_ssize_t, scm_from_schar, scm_from_uchar,
	scm_from_char, scm_from_short, scm_from_ushort, scm_from_int,
	scm_from_uint, scm_from_long, scm_from_ulong, scm_from_size_t,
	scm_from_ssize_t, scm_is_real, scm_to_double, scm_from_double):
	New.

2004-07-05  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* boolean.h, boolean.c (scm_is_true, scm_is_false, scm_from_bool,
	scm_to_bool): New.

2004-06-27  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* backtrace.c (display_expression, display_frame): Call
	scm_i_unmemoize_expr for unmemoizing a memoized object holding a
	single memoized expression.

	* debug.c (memoized_print): Don't try to unmemoize the memoized
	object, since we can't know whether it holds a single expression
	or a body.

	(scm_mem_to_proc): Removed check for lambda expression, since it
	was moot anyway.  Whoever uses these functions for debugging
	purposes should know what they do: Creating invalid memoized code
	will cause crashes, independent of whether this check is present
	or not.

	(scm_proc_to_mem): Take the closure's code as it is and don't
	append a SCM_IM_LAMBDA isym.  To allow easier debugging, the
	memoized code should not be modified.

	* debug.[ch] (scm_unmemoize, scm_i_unmemoize_expr): Removed
	scm_unmemoize from public use, but made scm_i_unmemoize_expr
	available as a guile internal function instead.  However,
	scm_i_unmemoize_expr will only work on memoized objects that hold
	a single memoized expression.  It won't work with bodies.

	* debug.c (scm_procedure_source), macros.c (macro_print), print.c
	(scm_iprin1): Call scm_i_unmemocopy_body for unmemoizing a body,
	i. e. a list of expressions.

	* eval.c (unmemoize_exprs): Drop internal body markers from the
	output during unmemoization.

	* eval.[ch] (scm_unmemocopy, scm_i_unmemocopy_expr,
	scm_i_unmemocopy_body): Removed scm_unmemocopy from public use,
	but made scm_i_unmemocopy_expr and scm_i_unmemocopy_body available
	as guile internal functions instead.  scm_i_unmemoize_expr will
	only work on a single memoized expression, while
	scm_i_unmemocopy_body will only work on bodies.

2004-06-21  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (unmemoize_exprs): Handle semi-memoized code.

	(scm_cons_source, scm_primitive_eval): Prefer higher level
	predicate SCM_FALSEP over SCM_IMP.

2004-06-15  Rob Browning  <rlb@defaultvalue.org>

	* script.c (scm_shell_usage): minor phrasing change.

	* gc_os_dep.c: update ifdefery for macosx.
	(scm_get_stack_base): separate result initialization from
	declaration to slience warnings with macosx and hp-ux using gcc
	3.3.  Thanks to Andreas Vögele.

2004-06-13  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* eval.c (unmemoize_exprs): use SCM_CONSP for the loop condition.

2004-06-06  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* list.[ch] (scm_i_finite_list_copy): New internal function to
	copy lists that are known to be finite (though not necessarily
	proper).

	* debug.c (scm_procedure_source): Don't have scm_unmemocopy treat
	a closure's argument list like an expression of a body.

	* eval.c (unmemoize_expression, unmemoize_exprs, unmemoize_and,
	unmemoize_begin, unmemoize_case, unmemoize_cond, unmemoize_delay,
	unmemoize_do, unmemoize_if, unmemoize_lambda, unmemoize_let,
	unmemoize_letrec, unmemoize_letstar, unmemoize_or,
	unmemoize_set_x, unmemoize_apply, unmemoize_atcall_cc,
	unmemoize_at_call_with_values, unmemoize_future, sym_atslot_ref,
	unmemoize_atslot_ref, sym_atslot_set_x, unmemoize_atslot_set_x,
	unmemoize_builtin_macro): New static functions and symbols.

	(scm_unmemocopy): Rewritten in terms of the above.  scm_unmemocopy
	now has a slightly different meaning: The memoized form that is
	receives as its argument is now interpreted as a sequence of
	expressions from a body.

	(unmemocar, scm_unmemocar): Since the whole functionality of
	unmemocar and scm_unmemocar is not needed any more, scm_unmemocar
	has its old content back and is deprecated, while unmemocar has
	been removed.

	(SCM_BIT7): Removed.

	(CEVAL): For unmemoizing a single expression, call
	unmemoize_expression instead of scm_unmemocopy, which now expects
	a sequence of body expressions.  Eliminated unnecessary empty
	environment frame when executing let* forms.  Eliminated
	unmemoization step from evaluator.

2004-06-02  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* eval.c (scm_macroexp, macroexp): Renamed scm_macroexp to
	macroexp and made static.  Added new version of scm_macroexp that
	emits a deprecation warning and then calls macroexp.
	(scm_m_undefine): Issue deprecation warning.

2004-05-30  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (lookup_global_symbol, literal_p, try_macro_lookup):
	Modified to make set! work on symbols that represent syntactic
	keywords.

2004-05-26  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* gc.h (SCM_CELL_OBJECT_LOC): use SCM_GC_CELL_OBJECT to prevent
	compound expression as lvalue errors.

2004-05-24  Marius Vollmer  <mvo@zagadka.de>

	* dynwind.c (winder_mark): Use SCM_PACK to correctly convert the
	WINDER_DATA to a SCM.

2004-05-24  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* goops.c (compute_getters_n_setters, create_standard_classes,
	scm_add_slot): Compute closures by calling scm_i_eval_x on a
	lambda expression rather than creating them with scm_closure.

2004-05-22  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (s_macro_keyword, scm_m_set_x): Remove checking for
	misplaced syntactic keywords.  This will not work unless guile's
	defmacro feature is deprecated.

	(scm_m_case): Fixed a bug that caused the list of labels to grow
	with every case form.

2004-05-19  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_round_number): For inum and big, just return x.  For
	real, use scm_round for 2^54-1 etc problems covered there.

	* numbers.c (trunc): Remove #define to scm_truncate when the C library
	doesn't provide trunc.  This was for when `truncate' was done as a
	scm_tc7_dsubr, no longer required.

	* threads.c (scm_threads_mark_stacks) [SCM_STACK_GROWS_UP]: Correction
	to stack marking call, two parameters and no cast on t->base.

2004-05-18  Marius Vollmer  <mvo@zagadka.de>

	* hashtab.c (rehash_after_gc): Bug fix: properly link the
	processed hashtables back into the weak_hashtables list.  Thanks
	to Bill Schottstaedt!

2004-05-16  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (unmemoize_quote): New static function.

	(scm_m_quote, scm_m_atslot_ref, SCM_CEVAL): Changed the byte code
	representation of 'quote' and '@slot-ref' to an improper list.
	This reduces execution time, the number of cells used to hold the
	memoized code, and thus also reduces garbage collection time.

	(scm_unmemocopy): Use unmemoize_quote for quote expressions.

	(SCM_CEVAL): Changed macro handling to also work with macros that
	return improper lists.  Added an assertion, that the code returned
	by a macro transformer will not lead to cycles in the memoized
	code.

2004-05-15  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	No functional change, just rearrangements of functions within the
	file.

	* eval.c (scm_ilookup, scm_unbound_variable_key,
	error_unbound_variable, scm_lookupcar1, scm_lookupcar): Moved to
	the definitions used for execution, since that's where they will
	belong to later.

2004-05-15  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* numbers.h (SCM_SLOPPY_FRACTIONP): Removed.  It was not used
	throughout guile, has not been part of an official release yet,
	and the concept of sloppy predicates has never been a good idea.

	(SCM_FRACTION_NUMERATOR, SCM_FRACTION_DENOMINATOR,
	SCM_FRACTION_SET_NUMERATOR, SCM_FRACTION_SET_DENOMINATOR):
	Simplified.

2004-05-15  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* throw.c (SETJBJMPBUF, SCM_SETJBDFRAME): Add cast to scm_t_bits
	to make explicit what happens.

2004-05-15  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* dynl.c (SET_DYNL_HANDLE): Add cast to scm_t_bits to make
	explicit what happens.

	* guardians.c (TCONC_IN): Use SCM_SET_CELL_OBJECT_x rather than
	SCM_SET_CELL_WORD_x when writing scheme objets to cell elements.

2004-05-11  Marius Vollmer  <mvo@zagadka.de>

	* scmsigs.c (scm_sigaction_for_thread): Validate that the handler
	is indeed a procedure when it isn't a number.

2004-05-10  Marius Vollmer  <mvo@zagadka.de>

	Convert floating point numbers into strings with an arbitrary
	radix.  Thanks to Richard Todd!

	* numbers.c (FLOBUFLEN): Increase so that radix 2 strings will
	fit.
	(fx): Removed.
	(scm_dblprec, fx_per_radix, init_dblprec, init_fx_radix,
	number_chars): New, to support variable radices.
	(idbl2str): Use above instead of the old base-10 only tables.
	(iflo2str): Pass on new RADIX argument to idbl2str.
	(scm_number_to_string): Pass radix to iflo2str.
	(scm_print_real, scm_print_complex): Explicitly pass radix 10 to
	iflo2str.
	(scm_init_numbers): Call init_dblprec and init_fx_radix for all
	possible radices.

2004-05-10  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_logbit_p): Correction to test above the end of an
	inum.  Reported by Jan Konecny.

2004-05-06  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* gc.h (scm_t_cell): Fields are now of type SCM instead of
	scm_t_bits.  Updated all users.
	(SCM_GC_CARD_SIZE_MASK): Use SCM_GC_SIZEOF_CARD instead of
	duplicating the code.
	(SCM_CELL_OBJECT_LOC): New.
	(SCM_CARLOC, SCM_CDRLOC): Use it instead of SCM_CELL_WORD_LOC.
	(SCM_CELL_WORD_LOC): Moved to "deprecated.h".

	* smob.h (SCM_SMOB_DATA_2, SCM_SMOB_DATA_3, SCM_SMOB_FLAGS,
	SCM_SET_SMOB_DATA_2, SCM_SET_SMOB_DATA_3, SCM_SET_SMOB_FLAGS,
	SCM_SMOB_OBJECT, SCM_SMOB_OBJECT_2, SCM_SMOB_OBJECT_3,
	SCM_SET_SMOB_OBJECT, SCM_SET_SMOB_OBJECT_2, SCM_SET_SMOB_OBJECT_3,
	SCM_SMOB_OBJECT_LOC, SCM_SMOB_OBJECT_2_LOC,
	SCM_SMOB_OBJECT_3_LOC): New.
	* smob.c (scm_i_set_smob_flags): New function.

	* dynl.c, dynwind.c, eval.h, fluids.h, futures.h, hashtab.h,
	hooks.h, keywords.h, macros.h, macros.c, mallocs.c, mallocs.h,
	random.h, regex-posix.h, root.h, srcprop.h, srcprop.c, threads.h:
	Use SCM_SMOB_* instead of SCM_CELL_* as appropriate.  Use
	SCM_SMOB_FLAGS and SCM_SET_SMOB_FLAGS instead of accessing the
	zeroth word directly.  Use SCM_SMOB_PREDICATE as appropriate.

	* numbers.h (SCM_I_BIG_MPZ): Use SCM_CELL_OBJECT_LOC instead of
	taking the address of SCM_CELL_WORD_1, the latter being no longer
	an lvalue.

	* variable.h (SCM_VARIABLE_LOC): Use SCM_CELL_OBJECT_LOC instead
	of casting SCM_CELL_WORD_LOC.

2004-05-02  Kevin Ryde  <user42@zip.com.au>

	* eval.c (scm_macroexp): Add prototype, since it's not in eval.h under
	--disable-deprecated.  Reported by Andreas Vögele.

	* filesys.c (_POSIX_C_SOURCE): Define to 199506L to get readdir_r (in
	particular on HP-UX).  Reported by Andreas Vögele.

	* list.c (varargs.h): Remove, leave just stdarg.h which is all the
	code has support for.  Fixes building with AIX cc, which is ansi but
	doesn't define __STDC__.  Reported by Keith Crane.
	(var_start): Remove macro, this variation no longer required.
	(scm_list_n): Use va_start directly.

2004-05-01  Kevin Ryde  <user42@zip.com.au>

	* continuations.c (scm_dynthrow): Use >= instead of SCM_PTR_GE which
	is now gone.  Reported by Andreas Vögele.

2004-04-28  Kevin Ryde  <user42@zip.com.au>

	* backtrace.c (display_frame_expr), numbers.c (XDIGIT2UINT,
	mem2uinteger, mem2decimal_from_point, mem2ureal): Cast char to int for
	ctype.h tests, to avoid warnings from gcc on HP-UX about char as array
	subscript.  Reported by Andreas Vögele.
	Also cast through unsigned char to avoid passing negatives to those
	macros if input contains 8-bit values.

	* num2integral.i.c (NUM2INTEGRAL): Under non-BIGMPZ_FITSP case,
	corrections to range check for signed numbers.  Remove
	scm_remember_upto_here_1(num) from these checks, since num is used
	subsequently anyway.

	* num2integral.i.c (NUM2INTEGRAL): Test BIGMPZ_FITSP with "!= 0" to
	avoid warning from gcc 3.4.  Reported by Hyperdivision.

	* numbers.c (scm_bit_extract): Use min instead of MIN.
	(MIN): Remove, this conflicts with similar macro defined by limits.h
	on HP-UX.  Reported by Andreas Vögele.

	* stime.c (_POSIX_C_SOURCE): Define to 199506L to get gmtime_r (in
	particular on HP-UX).  Reported by Andreas Vögele.

	* threads.c (scm_threads_mark_stacks): Correction sizet -> size_t.
	Reported by Andreas Vögele.

	* threads-plugin.h (SCM_MUTEX_MAXSIZE): Increase to 25*sizeof(long),
	for the benefit of hpux11 where pthread_mutex_t is 88 bytes.  Reported
	by Andreas Vögele.

2004-04-22  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (s_macro_keyword): New static identifier.

	(scm_m_define): Change order to first create binding and
	evaluating the expression afterwards.

	(scm_m_set_x): Memoize complete set! expression.  Only leave
	symbols if no binding exists at memoization time.  Throw error if
	assigning to a syntactic keyword.

	(lazy_memoize_variable): New function.

	(CEVAL): When execution set!, perform lazy memoization if
	unmemoized symbol is detected.

	* modules.c (module_variable): Return variables with unbound
	value.

	* tags.h: Fix comment.

2004-04-25  Kevin Ryde  <user42@zip.com.au>

	* chars.c (scm_char_upcase, scm_char_downcase, scm_c_upcase,
	scm_c_downcase): Use ctype.h toupper and tolower.  This will be useful
	in 8-bit locales, and ensures consistency with char-upper-case? and
	char-lower-case? which already use ctype.h.
	(scm_c_upcase_table, scm_c_downcase_table, scm_lowers, scm_uppers):
	Remove.
	* chars.c, chars.h, init.c (scm_tables_prehistory): Remove.

	* socket.c (VALIDATE_INET6): Correction to bignum_in_ipv6_range_p
	call.  Reported by Hyperdivision.

	* threads.c (scm_yield): Correction, actually call scm_thread_yield.
	Reported by Hyperdivision.

	* unif.c (s_scm_make_uve): Remove unused local variable.  Reported by
	Hyperdivision.

2004-04-22  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	Hide the implementation of ilocs and isyms in eval.c.

	* deprecated.h (SCM_IFRINC, SCM_ICDR, SCM_IFRAME, SCM_IDIST,
	SCM_ICDRP), eval.c (SCM_IFRINC, SCM_ICDR, SCM_IFRAME, SCM_IDIST,
	SCM_ICDRP), eval.h (SCM_ICDR, SCM_IFRINC, SCM_IFRAME, SCM_IDIST,
	SCM_ICDRP): Deprecated and added to deprecated.h.  Moved from
	eval.h to eval.c.

	* deprecated.c (scm_isymnames), deprecated.h (scm_isymnames,
	SCM_ISYMNUM, SCM_ISYMCHARS), eval.c (SCM_ISYMNUM, isymnames,
	scm_unmemocopy, CEVAL), print.c (scm_isymnames), tags.h
	(SCM_ISYMNUM, scm_isymnames, SCM_ISYMCHARS): Deprecated
	scm_isymnames, SCM_ISYMNUM and SCM_ISYMCHARS and added to
	deprecated.[hc].  Moved scm_isymnames from print.c to eval.c and
	renamed to isymnames.  Moved SCM_ISYMNUM from tags.h to eval.c and
	renamed to ISYMNUM.

	* eval.c (scm_i_print_iloc, scm_i_print_isym), eval.h
	(scm_i_print_iloc, scm_i_print_isym), print.c (scm_iprin1):
	Extracted printing of ilocs and isyms to guile internal functions
	scm_i_print_iloc, scm_i_print_isym of eval.c.

2004-04-22  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_bit_extract): Use SCM_SRS for signed right shift.

	* numbers.c (scm_round): Test for x already an integer, to avoid bad
	rounding in x+0.5 when x is a big value already an integer.  In
	certain hardware rounding cases x+0.5 can give an adjacent integer,
	leading to that as the result, when we really just wanted x itself.

2004-04-19  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (scm_unmemocopy): Fixed unmemoization of let*.

	(deval_args, CEVAL): Minor improvements: Reduced variable scopes,
	added const qualifiers, cast intentionally unused expressions to
	void for emphasis, improved comment.

2004-04-18  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* tags.h (scm_tags, scm_tc8_tags, scm_tc9_flag, scm_tc8_flag,
	scm_tc8_isym): Renamed scm_tags to scm_tc8_tags.  Renamed
	scm_tc9_flag to scm_tc8_flag.  Introduced new identifier
	scm_tc8_isym.  Defined tc8-tags relative to scm_tc3_imm24.
	Defined the tc8-tag for flags to be 0x04, which will mean that
	SCM_BOOL_F will also have the value 0x04 instead of 0x013c.  Due
	to the reduced number of bits and the simpler bit pattern for
	SCM_BOOL_F, certain machines may be able to use more efficient
	processor instructions to deal with SCM_BOOL_F.

	(SCM_ITAG9, SCM_MAKE_ITAG9, SCM_ITAG9_DATA): Removed.  These have
	never been defined in a released version, thus no need to
	deprecate them.

	(SCM_IFLAGP, SCM_MAKIFLAG, SCM_IFLAGNUM): Flags now use tc8
	instead of tc9 tags.

	(SCM_ISYMP, SCM_MAKISYM, SCM_ISYMNUM): Isyms now use tc8 instead
	of tc9 tags.

	(SCM_MAKSPCSYM): Removed.  It is almost impossible that user code
	could have used this definition.

	(SCM_IM_AND, SCM_IM_BEGIN, SCM_IM_CASE, SCM_IM_COND, SCM_IM_DO,
	SCM_IM_IF, SCM_IM_LAMBDA, SCM_IM_LET, SCM_IM_LETSTAR,
	SCM_IM_LETREC, SCM_IM_OR, SCM_IM_QUOTE, SCM_IM_SET_X): Now encoded
	as isyms, as special isyms don't exist any more.

2004-04-18  Kevin Ryde  <user42@zip.com.au>

	* filesys.c (scm_readdir): Use readdir_r when available, for thread
	safety.

	* numbers.c (scm_max, scm_min): For big/real, use SCM_SWAP rather than
	explicit swapping code.

2004-04-15  Kevin Ryde  <user42@zip.com.au>

	* cpp_sig_symbols.in: Add SIGSYS.

	* list.c (scm_append_x): Use iterative style, to avoid non-tail
	recursion.

	* numbers.c (scm_max, scm_min): For inum/frac, frac/inum, big/frac,
	frac/big and frac/frac, use scm_less_p for exact comparison.

	* numbers.c (scm_gcd): For inum/big, use mpz_gcd_ui by sharing code
	with big/inum.

	* numbers.c (xisinf): Add a comment about solaris 7 lacking isinf.

2004-04-06  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* inline.h (scm_cell): use SCM_GC_CELL_WORD for checking tag.

	* chars.h (scm_init_chars): change scm_{upcase,downcase} to
	scm_c_{up,down}case.
	(SCM_MAKE_CHAR): add (unsigned char) cast. This prevents havoc
	when hi-bit ASCII is subjected to SCM_MAKE_CHAR().

2004-04-06  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_ash): Remove stray "}" in docstring.

	* numbers.c (scm_make_ratio): For inum/bignum integer detection, use
	x==SCM_MOST_NEGATIVE_FIXNUM explicitly, for clarity and to avoid
	calling mpz_cmp_ui in most cases.

	* numbers.c (scm_quotient, scm_remainder): In inum/big, use mpz_cmp_ui
	for big == abs(most-negative-fixnum) special case.
	(abs_most_negative_fixnum): Remove, no longer used.

	* scmsigs.c (scm_sigaction_for_thread): Correction to signum range
	test, avoids SCM_VECTOR_REF outside bounds of signal_handlers on
	calling (sigaction NSIG).

	* simpos.c (scm_system_star): Fix execargv memory leak, merge parent
	and fork error cases to do this.

2004-04-03  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (CEVAL): Don't distinguish between short and long
	instructions when dispatching - just always dispatch on the
	instruction code, which is common for short and long instructions.
	Further, removed unnecessary goto statements and added comment.

2004-04-03  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (scm_unmemocopy): Don't distinguish between short and
	long instructions when dispatching - just always dispatch on the
	instruction code, which is common for short and long instructions.
	Further, removed unnecessary goto statements, fixed indentation
	and replaced SCM_IMP predicates by SCM_NULLP.

2004-04-03  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (scm_lookupcar1, CEVAL): Use SCM_ILOCP instead of
	comparison with SCM_ILOC00.  In CEVAL, eliminate goto-label
	'checkmacro'.

2004-03-31  Kevin Ryde  <user42@zip.com.au>

	* simpos.c: Include <signal.h> for SIG_IGN and friends.

2004-03-29  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	Introduce scm_debug_mode_p as a replacement for scm_debug_mode and
	SCM_DEBUGGINGP:

	* debug.h (scm_debug_mode_p, scm_debug_mode, SCM_DEBUGGINGP),
	eval.c (scm_debug_mode_p): Deprecated scm_debug_mode and
	SCM_DEBUGGINGP.  Provided scm_debug_mode_p instead, to have one
	single interface that also matches the naming conventions.
	Probably scm_debug_mode_p should be part of the private interface
	anyway.

	* debug.h (scm_debug_mode_p), backtrace.c (display_error_body),
	eval.c (SCM_APPLY, scm_trampoline_0, scm_trampoline_1,
	scm_trampoline_2): Change uses of scm_debug_mode or SCM_DEBUGGINGP
	to scm_debug_mode_p.


	Deprecate direct access to scm_ceval, scm_deval and scm_ceval_ptr:

	* eval.h (scm_ceval, scm_deval, scm_ceval_ptr), debug.h
	(scm_ceval_ptr): Deprecated.  Moved declaration of scm_ceval_ptr
	from debug.h to eval.h.

	* debug.h (SCM_RESET_DEBUG_MODE): Don't access scm_ceval_ptr any
	more, just leave it with setting scm_debug_mode_p, which is
	equivalent for practical purposes.

	* deprecated.h (SCM_XEVAL, SCM_XEVALCAR): Call scm_i_eval_x
	instead of *scm_ceval_ptr.  Leave all evaluating to scm_i_eval_x.

	* gdbint.c (gdb_eval): Call scm_i_eval_x instead of scm_ceval.

	* eval.c (ceval, deval, scm_ceval, scm_deval): Made scm_ceval
	static and renamed it to ceval throughout.  Provide a new exported
	but deprecated function scm_ceval as a wrapper for backwards
	compatibility.  The same is done for the deval/scm_deval pair of
	functions.

	* eval.c (CEVAL, SCM_CEVAL): Renamed SCM_CEVAL to CEVAL
	throughout.  Defined CEVAL to ceval or deval, based on compilation
	phase.

	* eval.c (SCM_XEVAL, SCM_XEVALCAR): Dispatch on scm_debug_mode_p
	to ceval and deval instead of calling *scm_ceval_ptr.

	* eval.c (dispatching_eval): New deprecated static function.

	* eval.c (scm_ceval_ptr): Initialized to dispatching_eval in order
	to emulate its old behaviour as closely as possible.


	Change the evaluator such that only expressions for which pair? is
	true are passed to CEVAL, and such that all other expressions are
	evaluated outside of CEVAL:

	* eval.c (EVAL): New, provided in analogy to EVALCAR.  Evaluate an
	expression that is assumed to be memoized already.  All but
	expressions of the form '(<form> <form> ...)' are evaluated inline
	without calling an evaluator.

	* eval.c (SCM_XEVAL, SCM_XEVALCAR, EVALCAR): Evaluate all but
	expressions of the form '(<form> <form> ...)' inline without
	calling an evaluator.

	* eval.c (scm_i_eval_x, scm_i_eval, scm_ceval, scm_deval): Handle
	the special case of unmemoized symbols passed on the top level.

	* eval.c (CEVAL): Change calls to CEVAL to EVAL, except where it
	is known that the expression passed to CEVAL is of the form
	'(<form> <form> ...)'.  Remove handling of the tc7-objects, since
	now it is known that the input expression of CEVAL is a pair.

2004-03-29  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c (is_self_quoting_p): New static function.

	(scm_m_quote): Use is_self_quoting_p.

	(copy_tree): Corrected typo in comment.

2004-03-28  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* eval.c (s_scm_copy_tree): idem.

	* list.c (s_scm_filter): remove "pointer" from doc string.

	* gc.h (SCM_GC_CELL_TYPE): SCM_GC_CELL_TYPE uses SCM_GC_CELL_OBJECT.

	* goops.h (SCM_NUMBER_OF_SLOTS): don't SCM_UNPACK the result.

	* backtrace.c ("display_backtrace_body"): SCM_PACK before SCM_EQ_P
	(display_frame): idem.
	(display_backtrace_file_and_line): idem.

	* tags.h (SCM_UNPACK): stricter typechecking on SCM_UNPACK
	arguments.

2004-03-26  Kevin Ryde  <user42@zip.com.au>

	* filesys.c (scm_getcwd, scm_readlink): Avoid memory leak on errors.

	* numbers.c (scm_modulo): For inum/big and big/big, remove test of
	big==0 since that never occurs.

	* numbers.c, numbers.h (scm_modulo_expt): Renamed from
	scm_modular_expt, matching scheme level name `modulo-expt'.

	* numbers.c (scm_modular_expt): Return a negative remainder for a
	negative divisor, the same as `modulo' does.

2004-03-26  Eric Hanchrow <offby1@blarg.net>

	* numbers.c, numbers.h (scm_modular_expt): New function.

2004-03-25  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_min, scm_max): Correction to big/real and real/big,
	return inexact as required by r5rs.

2004-03-24  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* eval.c: Separated some definitions relevant for execution from
	the memoization part of the file.

	(copy_tree): New static function

	(scm_copy_tree): Rewritten to fix two kinds or bugs: First, cyclic
	structures are detected now and will lead to an exception instead
	of forcing guile to run in an endless loop, using up all the
	system's memory.  Second, arrays in the cdr of an improper list
	are now copied.  See the new test cases in eval.test.

2004-03-24  Dirk Herrmann  <dirk@dirk-herrmanns-seiten.de>

	* posix.c (scm_gethostname): Make sure len is initialised before
	it is used.  Restructured to (hopefully) represent possible
	configurations more clearly in the code.  Added unwind handler.

2004-03-23  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_gethostname): Use sysconf(_SC_HOST_NAME_MAX) and/or
	MAXHOSTNAMELEN when available.

2004-03-21  Marius Vollmer  <mvo@zagadka.de>

	* read.c (skip_scsh_block_comment): Also recognize '\r' as a line
	terminator.  Rewritten the logic as a state machine, I must have
	been doing too much VHDL lately...

	* eval.c (scm_ceval, scm_deval): Explicitely evaluate ports to
	themselves.  Thanks to Han-Wen Nienhuys!

	* list.c: Changed docstrings so that they no longer talk about
	returning 'pointers' to something.

2004-03-20  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* gc.c: remove set_debug_cell_accesses! when
	SCM_DEBUG_CELL_ACCESSES is not defined. Scheme source code should
	use (if (defined? 'set-debug-cell-accesses!) .. ) to switch on
	debugging conditionally.

2004-03-21  Kevin Ryde  <user42@zip.com.au>

	* stime.c (scm_gmtime): Use gmtime_r when available, for thread safety.

2004-03-20  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_gethostname): Preserve errno across free() call.

2004-03-18  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* gc-card.c (sweep_card): use SCM_GC_SET_CELL_WORD for setting
	free cells.

2004-03-14  Kevin Ryde  <user42@zip.com.au>

	* stime.c: Define _GNU_SOURCE for strptime prototype from glibc.
	(strptime): Use	HAVE_DECL_STRPTIME for when to give own prototype.

2004-03-07  Kevin Ryde  <user42@zip.com.au>

	* stime.c (scm_gmtime): Return bd_time->tm_zone when available, rather
	than "GMT" always.
	(filltime): Make zname parameter "const".

2004-03-03  Mikael Djurfeldt  <mdj@chunk.mit.edu>

	* threads.c, threads.h (scm_c_scm2thread): New function.

2004-02-29  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (guile_ieee_init): Use C99 INFINITY and NAN when
	available.  Test HAVE_DINFINITY and HAVE_DQNAN for those globals, in
	particular don't assume "defined (__alpha__) && ! defined (linux)"
	means OSF.  Remove "SCO" code, which was not really SCO specific and
	which John W. Eaton advises should be long past being needed.

	* posix.c (scm_execl, scm_execlp, scm_execle): Avoid memory leak under
	error throw.

2004-02-24  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_cuserid): Use a private result buffer, for thread safe.

2004-02-22  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_max, scm_min): For one arg, dispatch to generic for
	complex, same as for two args.  (Handle only inum, big, real, frac).

2004-02-21  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_crypt): Use new HAVE_CRYPT.
	(<crypt.h>): Remove HAVE_LIBCRYPT condition.
	Reported by Andreas Voegele.

2004-02-20  Neil Jerram  <neil@ossau.uklinux.net>

	* list.c (scm_list_n): Add #if SCM_DEBUG_CELL_ACCESSES_P around
	validation.

	* read.c (scm_lreadparen): Removed.
	(scm_lreadparen1): Renamed scm_i_lreadparen.

2004-02-20  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* list.c (scm_list_n): validate non-immediate arguments;
	this will catch forgotten a SCM_UNDEFINED.

2004-02-18  Marius Vollmer  <mvo@zagadka.de>

	* gc.h (scm_gc_cells_collected): Removed duplicated declaration.
	Thanks to Bill Schottstaedt!

	* socket.h (scm_gethost): Removed prototype it is already in
	"net_db.h".  Thanks to Bill Schottstaedt!

2004-02-18  Kevin Ryde  <user42@zip.com.au>

	* num2integral.i.c (INTEGRAL2BIG): WORDS_BIGENDIAN not right for word
	order parameter to mpz_import, in fact with just one word there's no
	order to worry about at all.

	* numbers.c (scm_num_eq_p): For real==frac, complex==frac, frac==real
	and frac==complex, make an exact comparison rather than converting
	with fraction2double.

	* posix.c, putenv.c, stime.c (environ): Use _NSGetEnviron in Darwin
	shared library, since environ is not directly available there.

	* script.c (scm_shell_usage): Print to stdout for --help, per GNU
	standard.

	* stime.c (scm_localtime, scm_gmtime, scm_mktime): Provide a default
	errno EINVAL in case localtime and gmtime don't set it.
	(scm_mktime, scm_strptime): Forcibly use errno EINVAL for our
	SCM_SYSERROR, since mktime and strptime generally don't set errno.

2004-02-16  Kevin Ryde  <kevin@swox.se>

	* gc-malloc.c (scm_done_malloc, scm_done_free): Allow negative sizes,
	which were permitted in the past for these.

	* num2float.i.c (NUM2FLOAT): Expand isfinite to !xisinf, as per
	previous change to numbers.c.

	* script.c (scm_shell_usage): Print bug-guile email address, as per
	GNU standard.  Reported by Han-Wen Nienhuys.

2004-02-13  Mikael Djurfeldt  <djurfeldt@nada.kth.se>

	* unif.c (scm_make_uve): Removed local variable and simplified
	code in order to avoid compiler used uninitialized warnings.

	* hashtab.c, hashtab.h (scm_hash_map_to_list): Renamed from
	scm_hash_map.
	(scm_hash_fold): Use scm_call_3 directly in the call to
	scm_internal_hash_fold instead of going via fold_proc (which is
	now removed).
	(scm_hash_for_each): Use a trampoline +
	scm_internal_hash_for_each_handle.
	(scm_internal_hash_for_each_handle, scm_hash_for_each_handle): New
	functions.

2004-02-12  Kevin Ryde  <user42@zip.com.au>

	* ports.c (scm_port_line): In docstring, note first line is 0.
	(scm_set_port_line_x): In docstring, note first line is 0.
	(scm_port_column): In docstring, there's no default to current input
	port, and remove shared port-line @defun.
	(scm_set_port_column_x): In docstring, there's no default to current
	input port, note first column is 0, remove shared set-port-line!
	@defun.

	* ramap.c (scm_array_fill_x): For fvect and dvect, use scm_num2dbl to
	convert args the same way that array-set! does.

	* unif.c (scm_make_uve, scm_array_p): Allow fraction 1/3 as prototype
	for dvect.
	(scm_array_p): Add missing "break"s in switch, fix llvect test look
	for "l" not "s", fix dvect to be false for singp(prot) since such a
	value is for fvect.
	(scm_array_prototype): Return 1/3 for dvect, rather than 0.33..33.
	(exactly_one_third): New variable.
	(scm_init_unif): Initialize it.

2004-02-10  Neil Jerram  <neil@ossau.uklinux.net>

	* read.c (scm_read_opts): Change `escaped-parens' to
	`elisp-strings'.

2004-02-08  Neil Jerram  <neil@ossau.uklinux.net>

	* read.c (scm_read_opts): New opts `elisp-vectors' and
	`escaped-parens'.
	(s_vector): New.
	(scm_lreadr): Use scm_lreadparen1 instead of scm_lreadparen.  Make
	handling of elisp vector syntax dependent on SCM_ENABLE_ELISP and
	`elisp-vectors' option instead of SCM_ELISP_READ_EXTENSIONS.
	Allow "\(" and "\)" in strings when SCM_ENABLE_ELISP defined and
	`escaped-parens' option set.
	(scm_read_token): If elisp vector syntax active, disallow [ and ]
	in tokens.
	(scm_lreadparen): Rewrite as interface to scm_lreadparen1.
	(scm_lreadparen1): New.

	* read.h: Remove conditionally compiled last arg to
	scm_lreadparen.
	(SCM_ELISP_VECTORS_P, SCM_ESCAPED_PARENS_P): New.

2004-01-23  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* eval.c (m_expand_body): remove stray variable new_body.

2004-01-22  Marius Vollmer  <mvo@zagadka.de>

	* eval.c (m_expand_body): Rewrite the expression in place (by
	overwriting FORMS) also when a letrec is constructed, not only
	when no definitions are found.  Do not return rewritten expression
	to emphasize the in-place rewriting.  Changed all users.

2004-01-19  Han-Wen Nienhuys   <hanwen@xs4all.nl>

	* gc.c: add protected_object_count, a number that is dumped from
	gc_stats()

2004-01-11  Marius Vollmer  <mvo@zagadka.de>

	* dynwind.h, dynwind.c (scm_frame_unwind,
	scm_frame_unwind_handler): Renamed and changed all uses.
	(scm_frame_rewind, scm_frame_rewind_handler): Likewise.

2004-01-11  Kevin Ryde  <user42@zip.com.au>

	* unif.c (scm_bit_count, scm_bit_position, s_scm_bit_set_star_x,
	s_scm_bit_count_star, s_scm_bit_invert_x): Clarify docstrings, as per
	changes made to scheme-compound.texi.

2004-01-10  Marius Vollmer  <mvo@zagadka.de>

 	* print.c (scm_print_symbol_name): Handle #{`foo}#, #{,foo}#,
	#{.}#, and all numeric strings specially.  Thanks to Paul Jarc!

	* guile-snarf.in: Use mkdir to create a unique temporary directory
	that we can safely use.  Thanks to Stefan Nordhausen!

2004-01-07  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* dynwind.h, dynwind.c (scm_i_dowinds): Removed 'explicit'
	argument since it is always zero now.  Changed all callers.
	Removed code for handling fluids.

	* fluids.c (scm_c_with_fluids): Use frames instead of adding to
	the wind chain explicitely.  Use scm_c_with_fluid for the common
	case of only one fluid.
	(scm_with_fluid): New.
	(scm_c_with_fluid): Use frames instead of scm_c_with_fluids.

	* fluids.h, fluids.c (scm_frame_fluid): New.
	(scm_with_fluid): New.
	(scm_i_swap_fluids, scm_i_swap_fluids_reverse): Removed.

	* dynwind.c (scm_frame_end): Do not use scm_i_dowinds.  Instead,
	do the unwinding directly.  It is simple enough.

	* dynwind.h, dynwind.c: Did the following renamings:
	scm_begin_frame -> scm_frame_begin,
	scm_end_frame -> scm_frame_end,
	scm_on_unwind -> scm_frame_unwind,
	scm_on_rewind -> scm_frame_rewind,
	scm_on_unwind_with_scm -> scm_frame_unwind_with_scm,
	scm_on_rewind_with_scm -> scm_frame_rewind_with_scm.
	Changed all uses.

	* aync.h, async.c: Did the follwing renamings:
	scm_with_blocked_asyncs -> scm_frame_block_asyncs,
	scm_with_unblocked_asyncs -> scm_frame_unblock_asyncs.
	Changed all uses.

	* ports.h, ports.c: Did the follwing renamings:
	scm_with_current_input_port -> scm_frame_current_input_port,
	scm_with_current_output_port -> scm_frame_current_output_port,
	scm_with_current_error_port -> scm_frame_current_error_port.
	Changed all uses.

2004-01-07  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (s_bignum): Remove, not used since gmp bignums.
	Reported by Richard Todd.

	* threads-plugin.h (SCM_MUTEX_MAXSIZE): Increase to 12*sizeof(long),
	for the benefit of powerpc-apple-darwin5.5.  Reported by Richard Todd.

	* unif.c (scm_aind): Test SCM_CONSP rather than !SCM_NULLP while
	traversing the args list, fixes segv if an improper list is given.
	Reported by Rouben Rostamian.

2004-01-06  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	* ports.c (swap_ports, scm_with_current_foo_port): Do not allocate
	swap_data on stack, use a 'malloc obj'.

	* fluids.h, fluids.c (scm_make_initial_fluids, scm_copy_fluids,
	scm_swap_fluids, scm_swap_fluids_reverse): Renamed to
	scm_i_... since they are internal.  Changed all uses.

	* dynwind.c (frame_print): Removed, use the default printer.
	(WINDER_F_MARK, WINDER_MARK_P, winder_mark): New.
	(scm_on_unwind_with_scm, scm_on_rewind_with_scm): New. Use above
	to protect SCM values.

	* dynwind.h (SCM_F_WIND_EXPLICITELY,
	SCM_F_WIND_EXPLICITLY): It's "explicitly" not "explicitely", damn.
	Changed all uses.
	(scm_on_unwind_with_scm, scm_on_rewind_with_scm): New.

2004-01-05  Marius Vollmer  <mvo@zagadka.de>

	* ports.h, ports.c (scm_with_current_input_port,
	scm_with_current_output_port, scm_with_current_error_port): New.

	* async.h, async.c (scm_with_blocked_asyncs,
	scm_with_unblocked_asyncs): New.

2004-01-03  Marius Vollmer  <mvo@zagadka.de>

	* dynwind.h, scm_dynwind.c (scm_t_frame_flags, scm_t_wind_flags,
	scm_begin_frame, scm_end_frame, scm_on_unwind, scm_on_rewind):
	New.
	(scm_dowinds, scm_i_dowinds): scm_dowinds has been renamed to
	scm_i_dowinds and extended to handle frames and to invoke a 'turn'
	function when the outermost wind point has been reached.  The
	latter is used to copy a continuation stack at the right time.
	scm_dowinds remains available.
	(SCM_GUARDSP, SCM_BEFORE_GUARD, SCM_AFTER_GUARD, SCM_GUARD_DATA,
	tc16_guard, guards_print): Removed.
	(scm_internal_dynamic_wind): Reimplemented using frames.

	* continuations.c (copy_stack): New, do only the stack copying
	part of copy_stack_and_call.
	(copy_stack_and_call): Copy the stack after unwinding and before
	rewinding.
	(scm_dynthrow): Do not call scm_dowinds, this is now done by
	copy_stack_and_call.

2004-01-04  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_less_p): Don't convert frac to float for compares,
	can give bad results due to rounding.

	* stime.c (scm_current_time, scm_gettimeofday): Add a comment about
	setzone/restorezone protection for DOS.

2003-12-26  Marius Vollmer  <mvo@zagadka.de>

	* gen-scmconfig.h.in, gen-scmconfig.c: Arrange for scm_t_intmax
	and scm_t_uintmax to be defined in scmconfig.h

2003-12-03  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_less_p): Remove spurious xisnan from frac+big case.

	* numbers.c (scm_make_ratio): Check for numerator equal to
	SCM_MOST_NEGATIVE_FIXNUM and bignum denominator the negative of that,
	giving integer -1.

	* numbers.c (scm_real_part): Return fraction unchanged rather than
	converting to flonum.

2003-11-30  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* modules.c (module_variable): Fixed (and thus simplified) the
	definition of SCM_BOUND_THING_P to reflect the fact that since
	after the 1.4 series of guile, obarrays only hold variable
	objects.

2003-11-30  Marius Vollmer  <mvo@zagadka.de>

	* numbers.c (scm_logand): It's "#b...", not "#\b...".

	From Paul Jarc:

	* read.c (scm_lreadr): Signal an error for invalid escape
	sequences in strings.  Code cleanups too.

	* print.c (scm_iprin1): use \xNN hexadecimal sequences when
	writing control characters in strings.

2003-11-21  Marius Vollmer  <mvo@zagadka.de>

	* ports.c (scm_drain_input): Bug fix: only access the port after
	checking that it indeed is one.

2003-11-22  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_bad_define): New static identifier.

	(m_body): Fixed comment.

	(scm_m_define): Don't generate memoized code for definitions that
	are not on the top level.  As a consequence, no memoized code at
	all is generated for definitions any more: Top level definitions
	are executed immediately during memoization and internal
	definitions are handled separately in m_expand_body.

	(scm_unmemocopy, unmemocopy): Removed code for unmemoizing
	definitions.  Consequently, there is no unmemoizing code any more
	that might modify the environment.  Thus, the old scm_unmemocopy
	is removed and the old unmemocopy is renamed to scm_unmemocopy.

	(SCM_CEVAL): The SCM_IM_DEFINE keyword can no longer occur in
	memoized code.  Call EVALCAR for continuations.  Prefer !SCM_NULLP
	over SCM_NIMP in places, where the argument is known to be part of
	a proper list.

2003-11-21  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_abs): Allocate a new real only for negatives, as done
	for bignums.

	* numbers.c (scm_bit_extract): Use mpz functions, rearrange inum case
	to share some shifting.

	* numbers.c (scm_integer_expt): Don't mpz_init after scm_i_clonebig or
	scm_i_mkbig, since they do so already.  Don't mpz_clear a bignum SCM,
	since gc does this.

2003-11-19  Marius Vollmer  <mvo@zagadka.de>

	* numbers.c (scm_make_ratio): Rewritten to have a simpler
	structure.  Previously, not all cases with a negative denominator
	were covered.

	* numbers.c (mem2decimal_from_point): use scm_divide instead of
	scm_divide2real when forming the fractional part.  This allows
	"#e1.2" to yield 6/5.

	* numbers.c (scm_i_fraction_equalp): Do not treat the return value
	of scm_equal_p as a C boolean, use SCM_FALSEP.  Previously, all
	fractions were equal to each other regardless of value.  Ooops.

	* numbers.c (scm_rationalize): Return an inexact result when given
	inexact arguments.

	* numbers.c (scm_exact_p, scm_inexact_p): Throw error for
	non-numbers.

2003-11-18  Marius Vollmer  <marius.vollmer@uni-dortmund.de>

	Support for exact fractions from Bill Schottstaedt!  Thanks!

	* print.c (scm_iprin1): Handle fractions.

	* objects.h (scm_class_fraction): New.
	* objects.c (scm_class_fraction): New.
	(scm_class_of): Handle fractions.

	* hash.c (scm_hasher): Handle fractions.

	* numbers.c: New code for handling fraction all over the place.
	(scm_odd_p, scm_even_p): Handle inexact integers.
	(scm_rational_p): New function, same as scm_real_p.
	(scm_round_number, scm_truncate_number, scm_ceiling, scm_floor):
	New exact functions that replace the inexact 'dsubr'
	implementations.
	(scm_numerator, scm_denominator): New.

	* numbers.h (SCM_NUMP): Recognize fractions.
	(SCM_FRACTIONP, SCM_SLOPPY_FRACTIONP, SCM_FRACTION_NUMERATOR,
	SCM_FRACTION_DENOMINATOR, SCM_FRACTION_SET_NUMERATOR,
	SCM_FRACTION_SET_DENOMINATOR, SCM_FRACTION_REDUCED_BIT,
	SCM_FRACTION_REDUCED_SET, SCM_FRACTION_REDUCED_CLEAR,
	SCM_FRACTION_REDUCED): New.
	(scm_floor, scm_ceiling, scm_truncate_number, scm_round_number):
	New prototypes.
	(scm_make_ratio, scm_rationalize, scm_numerator, scm_denominator,
	scm_rational_p): New prototypes.
	(scm_i_dbl2num, scm_i_fraction2double, scm_i_fraction_equalp,
	scm_i_print_fraction): New prototypes.

	* goops.c (create_standard_classes): Create "<fraction>" class.

	* gc-mark.c (scm_gc_mark_dependencies): Handle fractions.

	* gc-card.c (scm_i_sweep_card): Include scm_tc16_fraction as a
	case in the switch, but do nothing for now.

	* eval.c (SCM_CEVAL, SCM_APPLY, call_dsubr_1): Convert fractions
	to doubles when calling 'dsubr' functions.

	* eq.c (scm_eqv_p, scm_equal_p): Handle fractions.

2003-11-18  Rob Browning  <rlb@defaultvalue.org>

	* gen-scmconfig.c (main): remove public definition of
	SCM_SIZEOF___INT64 and SCM_SIZEOF_UNSIGNED___INT64 and add
	direct typedef of long_long and ulong_long inside deprecated block
	when appropriate.

	* deprecated.h: move long_long and ulong_long definitions to
	gen-scmconfig.c so that we don't need to add SCM_SIZEOF___INT64
	and SCM_SIZEOF_UNSIGNED___INT64 to the public namespace.

2003-11-17  Marius Vollmer  <mvo@zagadka.de>

	* hash.c (scm_string_hash): New hashing algorithm that takes the
	complete string into account.

	* eval.c (scm_m_generalized_set_x): Macroexpand the target when it
	is a list.  This allows (@ ...) to work with set!.
	(scm_m_generalized_set_x): Use ASSERT_SYNTAX_2 instead of
	SCM_ASSYNT.

	* script.c (scm_compile_shell_switches): Use scm_c_read_string for
	the "-e" option instead of scm_str2symbol.  This allows things
	like (@ ...) to be specified for the entry point.

2003-11-16  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_m_letstar): Create memoized code in place to
	minimize consing.

2003-11-16  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_splicing): Commented and reformulated.

	(lookup_global_symbol, lookup_symbol): New static functions.

	(s_test, s_bindings, s_duplicate_bindings, s_variable): Removed.

	(try_macro_lookup, literal_p): Use lookup_symbol instead of
	creating a temporary pair for scm_lookupcar.

	(scm_unmemocar, unmemocar): Renamed scm_unmemocar to unmemocar,
	created deprecated wrapper function scm_unmemocar.

	(SCM_VALIDATE_NON_EMPTY_COMBINATION, scm_sym_else,
	scm_sym_unquote, scm_sym_uq_splicing, scm_sym_enter_frame,
	scm_sym_apply_frame, scm_sym_exit_frame, scm_sym_trace, f_apply,
	undefineds, sym_three_question_marks): Moved around without
	modifications.

	* eval.c, eval.h (scm_macroexp, scm_unmemocar): Deprecated.

2003-11-15  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (try_macro_lookup, expand_user_macros, is_system_macro_p,
	m_expand_body, scm_m_expand_body): Grouped together with m_body.
	No further modifications.

2003-11-15  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_mixed_body_forms): New static identifier.

	(canonicalize_define, scm_m_define): The check for a bad
	expression is performed in canonicalize_define now.

	(try_macro_lookup, expand_user_macros, is_system_macro_p): New
	static helper functions for m_expand_body.

	(m_expand_body): Use ASSERT_SYNTAX to signal syntax errors.  Only
	expand user defined macros.  Fixed handling of the definition/
	expression boundary.  Fixed handling of definitions grouped with
	'begin.  Use canonicalize_define to expand definitions.

2003-11-13  Marius Vollmer  <mvo@zagadka.de>

	* read.c (scm_lreadr): detect EOF after backslash, and interpret
	\xNN hexadecimal sequences.  From Paul Jarc, thanks!

	* snarf.h (SCM_SMOB, SCM_GLOBAL_SMOB, SCM_SMOB_MARK,
	SCM_GLOBAL_SMOB_MARK, SCM_SMOB_FREE, SCM_GLOBAL_SMOB_FREE,
	SCM_SMOB_PRINT, SCM_GLOBAL_SMOB_PRINT, SCM_SMOB_EQUALP,
	SCM_GLOBAL_SMOB_EQUALP, SCM_SMOB_APPLY, SCM_GLOBAL_SMOB_APPLY):
	New macros from Paul Jarc.  Thanks!

	* gc_os_dep.c (scm_get_stack_base): Provide a definition that
	return NULL when the machine type is unknown.  Previously,
	gc_os_dep.c would refuse to compile.

2003-11-09  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_m_body, m_body, scm_m_lambda, memoize_named_let,
	scm_m_let, scm_m_letrec, m_expand_body): Renamed static function
	scm_m_body to m_body.

2003-11-09  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c, eval.h (scm_m_expand_body, m_expand_body): Deprecated
	public use of scm_m_expand_body in eval.h.  In eval.c, renamed
	scm_m_expand_body to m_expand_body and made it static.  Added
	deprecated wrapper scm_m_expand_body.

	(scm_eval_body, SCM_CEVAL, SCM_APPLY): Use m_expand_body instead
	of scm_m_expand_body.

2003-11-09  Kevin Ryde  <user42@zip.com.au>

	* dynl.c (scm_dynamic_unlink): Need scm_list_1 on error message
	argument.  Reported by Mike Gran.

2003-11-08  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_missing_body_expression): New static identifier.

	(s_body): Removed.

	(scm_m_expand_body): Fixed core dump when passing a body with
	defines, but without expressions (see additions to syntax.test).
	Use ASSERT_SYNTAX to signal syntax errors.

2003-11-02  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (canonicalize_define): New static helper function.

	(memoize_define, canonicalize_define): Extract handling of
	function currying to canonicalize_define.

2003-11-02  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_trampoline_0, scm_trampoline_1, scm_trampoline_2):
	Make sure that error checking in debug mode is not worse than in
	standard mode.

2003-11-01  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_m_body, scm_m_lambda): Documentation strings are not
	handled in scm_m_body any more, but rather in scm_m_lambda.

	(scm_m_body, memoize_named_let, scm_m_let, scm_m_letstar,
	scm_m_letrec, scm_m_expand_body): Check for validity is done by
	calling functions of scm_m_body.

	(scm_m_lambda): Avoid unnecessary consing when creating the
	memoized code.

2003-11-01  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_expression): Added comment.

	(s_empty_combination, error_unbound_variable): New static
	identifiers.

	(SCM_VALIDATE_NON_EMPTY_COMBINATION, SCM_EVALIM2, scm_lookupcar1):
	Use ASSERT_SYNTAX, syntax_error or error_unbound_variable to
	signal syntax errors.

	(SCM_CEVAL): Separated handling of evaluator bytecodes and other
	scheme objects.

2003-10-25  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (unmemocar, sym_three_question_marks, scm_unmemocar):
	Grouped together with unmemocopy, without modifications.

	(build_binding_list, unmemocopy): Renamed names of list arguments
	and variables to reflect the actual order of the list elements.

2003-10-22  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_defun): New static identifier.

	(scm_m_nil_cond, scm_m_atfop, scm_m_undefine): Add comments.  Use
	ASSERT_SYNTAX to signal syntax errors.  Avoid unnecessary consing
	when creating the memoized code.

2003-10-19  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_ash): Revise docstring as per recent update to manual.

	* numbers.c (scm_i_big2dbl): Rewrite, carefully rounding to "closest"
	in accordance with R5RS, which just mpz_get_d doesn't really give.

2003-10-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_bad_slot_number): New static identifier.

	(scm_m_atslot_ref, scm_m_atslot_set_x): Use ASSERT_SYNTAX to
	signal syntax errors.  Avoid unnecessary consing when creating the
	memoized code.

2003-10-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_m_cont, scm_m_at_call_with_values,
	scm_m_generalized_set_x): Use ASSERT_SYNTAX to signal syntax
	errors.  Avoid unnecessary consing when creating the memoized
	code.

	(scm_m_generalized_set_x): Let scm_m_set_x handle the R5RS
	standard case.  Make sure line and file information are copied to
	every created expression.

2003-10-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_m_set_x, scm_m_apply, scm_m_atbind): Use
	ASSERT_SYNTAX to signal syntax errors.  Avoid unnecessary consing
	when creating the memoized code.

	(scm_m_atbind): Reversed the order, in which the init expressions
	are stored and executed.  The order of execution is now equal to
	the order in which the initializers of the let-forms are executed.
	Use check_bindings and transform_bindings.

	(SCM_CEVAL): Eliminated SCM_NIMP in favor of more appropriate
	!SCM_NULLP.  Added some comments.

2003-10-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c: Sorted include files alphabetically.

	(scm_m_begin): Added comment.

	(scm_m_or): Use ASSERT_SYNTAX to signal syntax errors.  Avoid
	unnecessary consing when creating the memoized code.

	(iqq, scm_m_quasiquote, scm_m_quote): Use ASSERT_SYNTAX to signal
	syntax errors.  Be more specific about the kind of error that was
	detected.

	(scm_m_quote, unmemocopy): As an optimization, vector constants
	are now inserted unquoted into the memoized code.  During
	unmemoization the quotes are added again to provide syntactically
	correct code.

2003-10-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_m_let, scm_m_letstar, scm_m_letrec,
	scm_m_expand_body, check_bindings): Extracted syntax checking of
	bindings to new static function check_bindings.

	(scm_m_let, memoize_named_let): Extracted handling of named let to
	new static function memoize_named_let.

	(transform_bindings, scm_m_let, scm_m_letstar, scm_m_letrec): Use
	ASSERT_SYNTAX to signal syntax errors.  Be more specific about the
	kind of error that was detected.  Avoid use of SCM_CDRLOC.  Avoid
	unnecessary consing when creating the memoized code.

2003-10-12  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_bad_formals, s_bad_formal, s_duplicate_formal): New
	static identifiers.

	(s_clauses, s_formals, s_duplicate_formals): Removed.

	(scm_m_lambda): Use ASSERT_SYNTAX to signal syntax errors.  Be more
	specific about the kind of error that was detected.  Prepare for
	easier integration of changes for separated memoization.

2003-10-12  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_duplicate_binding): New static identifier.

	(scm_m_case): Call scm_c_memq instead of implementing it inline.

	(scm_m_define): Added comment about how we check for duplicate
	formals.

	(scm_m_do): Added check for duplicate bindings.

	(scm_m_if): Use ASSERT_SYNTAX to signal syntax errors.  Avoid
	unnecessary consing when creating the memoized code.

	(scm_c_improper_memq, c_improper_memq, scm_m_lambda): Renamed
	scm_c_improper_memq to c_improper_memq, since it is not exported.

	(transform_bindings): Call scm_c_memq rather than
	scm_c_improper_memq.

	(SCM_CEVAL): Simplified handling of SCM_IM_IF forms.

2003-10-12  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_bad_bindings, s_bad_binding, s_bad_exit_clause): New
	static identifiers.

	(scm_m_do): Use ASSERT_SYNTAX to signal syntax errors.  Be more
	specific about the kind of error that was detected.  Avoid use of
	SCM_CDRLOC.  Avoid unnecessary consing when creating the memoized
	code, this way also making sure that file name, line number
	information etc. remain available.

2003-10-12  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (memoize_as_thunk_prototype): New static function.

	(scm_m_delay, scm_m_future): Use memoize_as_thunk_prototype.
	Avoid unnecessary consing when creating the memoized code.

2003-10-12  Kevin Ryde  <user42@zip.com.au>

	* list.c (scm_append): Track argument number and use in error.

2003-10-11  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_missing_expression, s_bad_variable): New static
	identifiers.

	(scm_m_define): Use ASSERT_SYNTAX to signal syntax errors.  Prefer
	R5RS terminology for the naming of variables.  Be more specific
	about the kind of error that was detected.  Make sure file name,
	line number etc. are added to all freshly created expressions.
	Avoid unnecessary consing when creating the memoized code.

2003-10-11  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_extra_expression, s_misplaced_else_clause,
	s_bad_cond_clause, s_missing_recipient): New static identifiers.

	(s_extra_case_clause): Removed.

	(scm_m_case, scm_m_cond): If a clause appears after an else
	clause, report a misplaced else clause.

	(scm_m_cond): Use ASSERT_SYNTAX to signal syntax errors.  Be more
	specific about the kind of error that was detected.  Handle bound
	'else and '=>.  Avoid unnecessary consing when creating the
	memoized code.

	(scm_m_cond, unmemocopy, SCM_CEVAL): Use SCM_IM_ELSE to memoize
	the syntactic keyword 'else and SCM_IM_ARROW to memoize the
	syntactic keyword '=>.

2003-10-11  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (scm_m_case): Allow empty lists of case labels.

2003-10-11  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* tags.h (SCM_IM_ELSE, SCM_IM_ARROW): New memoizer codes.

	* print.c (scm_isymnames): Add names for the new memoizer codes.

	* eval.c (s_missing_clauses, s_bad_case_clause,
	s_extra_case_clause, s_bad_case_labels, s_duplicate_case_label,
	literal_p): New static identifiers.

	(scm_m_case): Use ASSERT_SYNTAX to signal syntax errors.  Be more
	specific about the kind of error that was detected.  Check for
	duplicate case labels.  Handle bound 'else.  Avoid unnecessary
	consing when creating the memoized code.

	(scm_m_case, unmemocopy, SCM_CEVAL): Use SCM_IM_ELSE to memoize
	the syntactic keyword 'else.

2003-10-10  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (s_bad_expression, syntax_error_key, syntax_error,
	ASSERT_SYNTAX, ASSERT_SYNTAX_2): New static identifiers.

	(scm_m_and): Use ASSERT_SYNTAX to signal syntax errors.  Avoid
	unnecessary consing when creating the memoized code.

2003-10-09  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_inexact_to_exact): Don't depend on what double->long
	cast gives for values bigger than a long, or for nan or inf.

2003-10-08  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* smob.h (scm_make_smob_type): Made the declaration match the
	definition.

2003-10-07  Marius Vollmer  <mvo@zagadka.de>

 	* goops.c, objects.h, smob.c, smob.h: Make type names char
        const * instead of char *.  Thanks to Paul Jarc!

2003-10-02  Kevin Ryde  <user42@zip.com.au>

	* strports.c (scm_call_with_output_string): scm_get_output_string
	rather than scm_strport_to_string, so as to guard against the port
	having been closed by the called procedure.  Reported by Nic Ferrier.

2003-09-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* numbers.h (SCM_INEXACTP): Removed uses of SCM_TYP16S.

	* tags.h, deprecated.h (SCM_TYP16S): Deprecated and moved from
	tags.h to deprecated.h.

2003-09-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	This set of patches introduces a new tc7 code scm_tc7_number for
	numbers.  Bignums, reals and complex numbers are turned from smobs
	into subtypes of scm_tc7_number.

	* tags.h (scm_tc7_number): New.

	* eq.c (scm_equal_p), eval.c (SCM_CEVAL), evalext.c
	(scm_self_evaluating_p), gc-card.c (scm_i_sweep_card), gc-mark.c
	(scm_gc_mark_dependencies), goops.c (create_smob_classes), hash.c
	(scm_hasher), numbers.c, numbers.h (SCM_NUMP), objects.c
	(scm_class_of), print.c (scm_iprin1), smob.c
	(scm_smob_prehistory): Don't handle bignums, reals and complex
	numbers as subtypes of scm_tc7_smob any more.

	* numbers.h, tags.h (scm_tc16_big, scm_tc16_real,
	scm_tc16_complex): Moved definitions from tags.h to numbers.h.

2003-09-18  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* numbers.c (scm_make_complex), gc-card.c (scm_i_sweep_card): Use
	sizeof (scm_t_complex) to determine the memory size of the
	malloc'd area for complex numbers.

2003-09-17  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* numbers.c (scm_bigequal): Fixed.

2003-09-16  Marius Vollmer  <mvo@zagadka.de>

	* stime.c (scm_current_time): 'time' does not set errno so don't
	use SCM_SYSERROR for reporting errors.

2003-09-16  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	This set of patches eliminates the dependency between the
	implementation of evaluator specific memoization codes and special
	constants like #f, '() etc. ('flags'), which are not evaluator
	specific.  The goal is to remove definitions of evaluator
	memoization codes completely from the public interface.  This will
	make it possible to experiment more freely with optimizations of
	guile's internal representation of memoized code.

	* objects.c (scm_class_of): Eliminate dependency on SCM_ISYMNUM.

	* print.c (iflagnames): New array, holding the printed names of
	guile's special constants ('flags').

	(scm_isymnames): Now holds only the printed names of the
	memoization codes.

	(scm_iprin1): Separate the handling of memoization codes and
	guile's special constants.

	* tags.h (scm_tc9_flag, SCM_ITAG9, SCM_MAKE_ITAG9, SCM_ITAG9_DATA,
	SCM_IFLAGNUM): new

	(scm_tc8_char, scm_tc8_iloc, SCM_BOOL_F, SCM_BOOL_T,
	SCM_UNDEFINED, SCM_EOF_VAL, SCM_EOL, SCM_UNSPECIFIED, SCM_UNBOUND,
	SCM_ELISP_NIL, SCM_IM_DISPATCH, SCM_IM_SLOT_REF,
	SCM_IM_SLOT_SET_X, SCM_IM_DELAY, SCM_IM_FUTURE,
	SCM_IM_CALL_WITH_VALUES, SCM_IM_NIL_COND, SCM_IM_BIND): Changed
	values.

	(SCM_IFLAGP): SCM_IFLAGP now only tests for flags.

	(SCM_IFLAGP, SCM_MAKIFLAG, SCM_IFLAGNUM): Generalized to use the
	tc9 macros and scm_tc9_flag.

2003-09-15  Marius Vollmer  <mvo@zagadka.de>

	* posix.c (scm_setgroups): Check that the gid list is not too
	long.  Thanks to Paul Jarc!

2003-09-14  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* tags.h: Reduced the number of short instructions from 14 to 13.
	The typecode of the former 14th short instruction is now used to
	represent long instructions.  Changed some comments to reflect
	this fact.

	(SCM_MAKISYM): ISYMs get a new tc7 code, namely the one that was
	previously used by SCM_IM_DEFINE.

	(SCM_IM_DEFINE): Turned into a long instruction.

	* eval.c (unmemocopy, SCM_CEVAL): Treat SCM_IM_DEFINE as a long
	instruction.

	* eval.c (SCM_CEVAL): Since characters and iflags have now a tc7
	code that is separate from all instructions, one level of dispatch
	for long instructions can be eliminated.

	* print.c (scm_isymnames): Removed some commented code.

2003-09-12  Marius Vollmer  <mvo@zagadka.de>

	* __scm.h (SCM_FENCE): Use __memory_barrier with the Intel
	compiler on IA64.

	* hashtab.h (scm_tc16_hashtable): Added "extern" declaration.

	* modules.c (scm_module_reverse_lookup): Check that the obarray
	really is a hashtable and do nothing if not.

	* inline.h: Use "extern inline" only with GCC.  Use "static
	inline" else.

2003-09-06  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* numbers.h (SCM_INEXACTP, SCM_REALP, SCM_COMPLEXP): Removed uses
	of SCM_SLOPPY_INEXACTP, SCM_SLOPPY_REALP and SCM_SLOPPY_COMPLEXP.

	* numbers.h, deprecated.h (SCM_SLOPPY_INEXACTP, SCM_SLOPPY_REALP,
	SCM_SLOPPY_COMPLEXP): Deprecated and moved from numbers.h to
	deprecated.h.

2003-09-06  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eq.c (scm_eqv_p, scm_equal_p): Removed uses of
	SCM_SLOPPY_INEXACTP, SCM_SLOPPY_REALP and SCM_SLOPPY_COMPLEXP.

	* eq.c (scm_eqv_p, scm_equal_p): Reordered comparisons from
	0.0==some_expression to some_expression==0.0.  The latter is
	better readable.  The former is preferred by some people, since it
	leads to a compiler error when confusing == with =.  However, when
	using gcc, a warning will be issued if in an if-statement an
	assigment appears.  Since many Guile developers are using gcc,
	such errors will not remain unnoticed anyway.  We can therefore
	focus on better readability.

2003-09-04  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* tags.h: Added description of Guile's type system.  Removed some
	old and misleading comments.

2003-09-04  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* unit.c (scm_cvref): Eliminate unnecessary uses of SCM_NIMP,
	SCM_SLOPPY_REALP and SCM_SLOPPY_COMPLEXP.

2003-09-04  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* numbers.h (SCM_MAKINUM): Define in terms of scm_tc2_int.

	(SCM_INEXACTP, SCM_REALP, SCM_COMPLEXP): Define in terms of the
	respective SLOPPY macro.

2003-09-04  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eq.c (scm_equal_p): Use SCM_TYP7 to check if an object is of
	type string, not SCM_TYP7S.

2003-09-03  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_lognot): Correction to docstring, ones-complement not
	2s-complement.

	* stime.c (scm_strptime): Add comment about glibc strptime %s and
	current timezone requiring SCM_DEFER_INTS.

2003-08-30  Neil Jerram  <neil@ossau.uklinux.net>

	* script.c (scm_compile_shell_switches): Make -s switch optional
	if file to be loaded does not begin with a `-'.  (Thanks to Aaron
	VanDevender for the patch!)

2003-08-30  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_lognot): Rewrite using ~ and mpz_com, for directness
	and to have non-integer types rejected as per other logical funcs.

2003-08-28  Kevin Ryde  <user42@zip.com.au>

	* gc.h (scm_remember_upto_here_1): Revise comments on the asm form.

2003-08-23  Kevin Ryde  <user42@zip.com.au>

	* simpos.c (scm_system): Remove SCM_DEFER_INTS, system() should be
	thread safe, and could take a long time too.

2003-08-22  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_difference): Correction to bignum - negative inum.

2003-08-14  Kevin Ryde  <user42@zip.com.au>

	* gc.h (scm_remember_upto_here_1, scm_remember_upto_here_2)
	[__GNUC__]: Use volatile asm macros rather than a function call.
	* gc.c (scm_remember_upto_here_1, scm_remember_upto_here_2): Undefine
	macros while defining functions.

	* simpos.c (getenv): Use <stdlib.h> for prototype.
	(scm_system): In docstring, refer to status:exit-val rather than
	"functions above".

2003-08-09  Kevin Ryde  <user42@zip.com.au>

	* srcprop.c (scm_source_properties): Return plist from hash if it's a
	list set by source-properties! rather than an SRCPROPS object,

2003-07-29  Kevin Ryde  <user42@zip.com.au>

	* properties.c (scm_primitive_property_ref): In docstring, note
	parameters to not-found-proc, use hyphens rather than underscores for
	that parameter name.
	(scm_primitive_property_set_x): In docstring, VAL is the value
	parameter not CODE.

2003-07-27  Marius Vollmer  <mvo@zagadka.de>

	* print.c (scm_print_symbol_name): handle more weird characters by
	escaping the symbol name properly.  Thanks to Paul Jarc!

	* posix.h (scm_setgroups): New prototype.
	* posix.c (scm_setgroups): New.  Thanks to Paul Jarc!
	(scm_getgroups): Handle groups ids that don't fit into a fixnum.
	Don't use SCM_WRITABLE_VELTS.

	* gc.h (SCM_GC_SET_CELL_BVEC): New.
	* gc-card.c (scm_i_init_card_freelist): Use it.  Thanks to
	Matthias Koeppe!

	* __scm.h (SCM_C_INLINE_KEYWORD): New.
	* numbers.c: Use it in place of SCM_C_INLINE so that the code
	compiles when SCM_C_INLINE is undefined.

2003-07-24  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* __scm.h: Reformulated the architecture and compiler properties
	in terms of properties of scm_t_bits and SCM variables rather than
	in terms of c standard types.  This is since it is not known which
	of the standard types scm_t_bits and SCM variables will be defined
	to.

2003-07-24  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_angle): Use scm_flo0 for non-negative inum, bignum
	and real.

2003-07-18  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_product): In complex * bignum, correction to
	REAL/IMAG fetch, x is the complex, not y.

2003-07-13  Mikael Djurfeldt  <djurfeldt@nada.kth.se>

	* numbers.c (scm_odd_p, scm_even_p): Bugfix: Treat result of
	scm_inf_p test as Scheme values.
	(scm_sum): Bugfix: Normalize bignum created from a negative bignum
	and a positive inum.
	Use GNU indentation style.

2003-07-12  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* values.c (scm_values): Build lists of length 1 by using
	scm_list_1 instead of using scm_cons.

2003-07-10  Kevin Ryde  <user42@zip.com.au>

	* deprecation.c (scm_c_issue_deprecation_warning_fmt): Add va_end.
	* list.c (scm_list_n): Ditto.

	* gc-malloc.c (scm_gc_realloc): Define "ptr" at start of function.

2003-07-08  Matthias Koeppe <mkoeppe@merkur.math.uni-magdeburg.de>

	* tags.h (scm_t_bits, scm_t_signed_bits, etc): Avoid solaris empty
	defines of INTPTR_MAX and UINTPTR_MAX, combine conditionals for
	scm_t_bits and scm_t_signed_bits to avoid any chance of one and not
	the other using intptr_t.

2003-07-08  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_make_polar): Use sincos, when available.
	(scm_magnitude): Use hypot.

	* ports.c (scm_char_ready_p, scm_peek_char): In docstrings, don't use
	@footnote since it doesn't go through to guile-procedures.txt.

	* threads.c (scm_call_with_new_thread): In docstring, use "( )"
	outside @var to quieten makeinfo, and use @code.

2003-07-06  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* gc-malloc.c (decrease_mtrigger): new function
	(increase_mtrigger): new function, separate debug registering and
	mtrigger administration.
	(scm_gc_realloc): bugfix: do mtrigger administration before the
	actual realloc, for the realloc might invalidate a GC-d segment of
	memory. Thanks to Sam Hocevar for pointing this out.
	(scm_gc_realloc): use scm_malloc_reregister instead of
	unregistering and registering in sequence.

2003-07-03  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* __scm.h (SCM_ASSERT): change "else" expansion to "do { } while (0)"

2003-07-02  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* __scm.h (SCM_ASRTGO): add "else" to macro expansions with if
	clauses.

2003-06-29  Marius Vollmer  <mvo@zagadka.de>

	* deprecated.h (SCM_OPDIRP, scm_fport, scm_option, scm_srcprops,
	scm_srcprops_chunk, scm_info_frame, scm_stack, scm_array,
	scm_array_dim, SCM_ARRAY_CONTIGUOUS, SCM_FUNC_NAME, SCM_WTA,
	RETURN_SCM_WTA, SCM_VALIDATE_NUMBER_COPY,
	SCM_VALIDATE_NUMBER_DEF_COPY, SCM_VALIDATE_OPDIR): Re-added from
	the release_1_6 branch.

2003-06-25  Stefan Jahn  <stefan@lkcc.org>

	* continuations.c: Redeclaration of getcontext() via the
	__asm__ ("getcontext") directive.

	* continuations.h: Include <ucontext.h> instead of
	<sys/ucontext.h>.

2003-06-21  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (_GNU_SOURCE): #define, to get C99 things.
	(scm_asinh, scm_acosh, scm_atanh, scm_truncate, $asinh, $acosh,
	$atanh, truncate): Use C library asinh, acosh, atanh and trunc, when
	available.
	(scm_inexact_to_exact): Expand isfinite to its definition !xisinf.
	(isfinite): Remove, conflicts with C99 isfinite().

2003-06-19  Marius Vollmer  <mvo@zagadka.de>

	* deprecated.h, deprecated.c (scm_strhash, scm_sym2ovcell_soft,
	scm_sym2ovcell, scm_intern_obarray_soft, scm_intern_obarray,
	scm_symbol_value0, scm_string_to_obarray_symbol scm_intern_symbol,
	scm_unintern_symbol, scm_symbol_binding, scm_symbol_interned_p,
	scm_symbol_bound_p, scm_symbol_set_x, scm_gentemp): Re-added from
	the release_1_6 branch.

2003-06-14  Stefan Jahn  <stefan@lkcc.org>

	* threads.h: Redefined scm_getspecific() and scm_setspecific()
	to be functions instead of macros.

	* threads.c: Conditionalized inclusion of <sys/time.h> and
	<unistd.h>.
	(scm_getspecific, scm_setspecific): Made these two function
	real part of the API.

	* posix.c (s_scm_putenv): Added some code to make a
	(putenv "FOO="), i.e. setting an empty string, work also on
	Win32 systems.  Thanks to Kevin Ryde for the proposal.

2003-06-12  Kevin Ryde  <user42@zip.com.au>

	* posix.c (scm_putenv): Free temporary ptr in mingw unset.  Add
	freebsd to comment about need to use unsetenv.

2003-06-02  Marius Vollmer  <mvo@zagadka.de>

	* ports.c (scm_peek_char): Safe the column of the port around the
	getc/ungetc calls.  Thanks to Dr. Peter Ivanyi!

2003-06-07  Kevin Ryde  <user42@zip.com.au>

	* tags.h: Use inttypes.h and stdint.h when available, for INTPTR_MAX
	and friends required by scm_t_bits setups.

2003-06-06  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* tags.h (scm_tc2_int): Added.

	* tags.h (scm_tc3_int_1, scm_tc3_int_2): Expressed in terms of
	scm_tc2_int.

	* tags.h (scm_tcs_cons_imcar, scm_tcs_cons_nimcar, scm_tcs_struct,
	scm_tcs_closures): Hard coded values replaced by symbolic ones.

2003-06-05  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c: Partially undid my patch from 2003-05-31.  This patch
	caused the segfault referenced in the previous changelog entry.

2003-06-05  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* tags.h: Fixed comment about the immediate type code layout.

	* eval.c: Fixed handling of non-special instructions.  Without
	this patch, guile will segfault on (#\0) and similar instructions.

2003-06-05  Kevin Ryde  <user42@zip.com.au>

	* numbers.c (scm_max, scm_min): For inum, bignum and real, if other
	operand is NaN, then return NaN.  Also avoid passing NaN to mpz_cmp_d.

	* read.c (scm_input_error): Pass arg list parameter to scm_error_scm,
	rather than SCM_EOL.  Needed by "Unknown # object" case in scm_lreadr.

2003-06-04  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* __scm.h, gc-card.c (SCM_DEBUG_DEBUGGER_SUPPORT,
	SCM_DEBUG_DEBUGGING_SUPPORT): Renamed macro
	SCM_DEBUG_DEBUGGER_SUPPORT to SCM_DEBUG_DEBUGGING_SUPPORT and
	generalized it to apply not only to C level functions but also to
	scheme level functions.

	* debug.c, debug.h, eval.c (make-iloc, scm_make_iloc, iloc?,
	scm_iloc_p, dbg-make-iloc, scm_dbg_make_iloc, dbg-iloc?,
	scm_dbg_iloc_p): Moved functions scm_make_iloc, scm_iloc_p to
	eval.c, made them available under SCM_DEBUG_DEBUGGING_SUPPORT == 1
	only and renamed them to scm_dbg_make_iloc, scm_dbg_iloc_p,
	respectively.

	* deprecated.h, eval.c, eval.h (SCM_ILOC00, SCM_IDINC,
	SCM_IDSTMSK): Deprecated.  The macro definitions are moved from
	eval.h into eval.c and a copy is placed into deprecated.h.

	* eval.c, eval.h (SCM_MAKE_ILOC): Removed from eval.h and placed
	into eval.c. This definition was not part of the API in any
	officially released version of guile and thus does not need to go
	through a phase of deprecation.

2003-06-02  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* deprecated.c, deprecated.h, eval.c, eval.h (scm_s_expression,
	scm_s_test, scm_s_body, scm_s_bindings, scm_s_variable,
	scm_s_clauses, scm_s_formals): Deprecated.  In eval.c the
	definitions are make static and renamed from scm_s_xxx to s_xxx.
	In deprecated.c the original definitions are copied.

	* deprecated.h, eval.c, eval (SCM_EVALIM2, SCM_EVALIM, SCM_XEVAL,
	SCM_XEVALCAR): Deprecated.  The macro definitions are moved from
	eval.h into eval.c and a copy (slightly modified to work in user
	code) is placed into deprecated.h.

	* eval.c: Use the local static s_xxx definitions instead of the
	scm_s_xxx definitions throughout.

2003-06-01  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	This set of patches separates the representation of the cxr family
	of functions (car, cdr etc.) from the dsubr family of functions
	(i. e. functions that take a double precision floating point
	argument).  Further, the algorithm for handling the cxr function
	is improved.

	* eval.c (SCM_CEVAL, SCM_APPLY, scm_trampoline_1), numbers.c
	(scm_asinh, scm_acosh, scm_atanh, scm_truncate, scm_round, floor,
	ceil, sqrt, fabs, exp, log, sin, cos, tan, asin, acos, atan, sinh,
	cosh, tanh), objects.c (scm_class_of), procprop.c
	(scm_i_procedure_arity), ramap.c (scm_array_map_x), tags.h
	(scm_tc7_dsubr, scm_tcs_subrs): Introduce scm_tc7_dsubr as new
	typecode for the dsubr family of functions.

	* ramap.c (ramap_cxr, ramap_dsubr): Renamed ramap_cxr to
	ramap_dsubr.

	* eval.c (SCM_CEVAL, SCM_APPLY, call_cxr_1), pairs.c
	(scm_init_pairs): Make use of the (now usable) second cell element
	of a scm_tc7_cxr function to implement the cxr family of functions
	more efficiently.

2003-05-31  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (SCM_CEVAL, SCM_APPLY, scm_trampoline_0,
	scm_trampoline_1, scm_trampoline_2): Postpone error cases to the
	end of an if-else-if-sequence of checks.

2003-05-30  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (SCM_CEVAL): Improved readability of call-with-values
	execution.  Generalize apply_closure to apply_proc and use that
	for call-with-values.

2003-05-30  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* eval.c (SCM_CEVAL): Avoid one level of indirection when applying
	a non closure.

2003-05-30  Stefan Jahn  <stefan@lkcc.org>

